IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5PostDocumentChangeNotificationEvent]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5PostDocumentChangeNotificationEvent'
		DROP PROCEDURE [dbo].[pjm5PostDocumentChangeNotificationEvent]
	END
GO

PRINT 'Creating procedure pjm5PostDocumentChangeNotificationEvent'
GO


/******************************************************************************
**		Name: pjm5PostDocumentChangeNotificationEvent
**		Desc:    Azure SQL   ServiceBroker
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/12/2006
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5PostDocumentChangeNotificationEvent]
	@EventType TName,
	@DocumentClassName TCode,
	@DocumentId TIdentifier,
	@Data xml
AS
    SET NOCOUNT ON;
       
	DECLARE @FromID TIdentifier, 
			@DocumentClass TClass

    SET @DocumentClass = dbo.adfGetClassByName(@DocumentClassName)
                    
    DECLARE @sql nvarchar(max), @params nvarchar(max), @result int
                    
    SET @sql = N'EXEC @result = [dbo].[GenerateEvents' + @EventType + '] @FromID, @EventType, @DocumentClass, @DocumentID, @Data';
    SET @params = N'@result int OUTPUT, @FromID int, @EventType nvarchar(32), @DocumentClass smallint, @DocumentID int, @Data xml';
                    
    EXEC sp_executesql @sql, @params, @result OUTPUT, @FromID, @EventType, @DocumentClass, @DocumentID, @Data;

	RETURN 0;
GO

