IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfBankAccountUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfBankAccountUpdate'
		DROP PROCEDURE [dbo].[adfBankAccountUpdate]
	END
GO

PRINT 'Creating procedure adfBankAccountUpdate'
GO

/******************************************************************************
**		File: adfBankAccountUpdate.sql
**		Name: adfBankAccountUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/04/2004 15:04:36
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfBankAccountUpdate
	@ID TIdentifier,
	@CompanyID TIdentifier,
	@FileAs TName,
	@CurrencyCode TCode3,
	@BankName TName,
	@BankCode TCode,
	@Country TName,
	@City TCity,
	@Address TName,
	@SWIFT TCode,
	@ABA TCode,
	@IBAN TCode,
	@Account TAccount,
	@IntermediaryBank TName,
	@IntermediaryAddress TName,
	@IntermediarySWIFT TCode,
	@IntermediaryABA TCode,
	@IntermediaryAccount TAccount,
	@AdditionalAccounts TDescription
AS
	
	SET NOCOUNT ON
	
	IF @CurrencyCode IS NULL
	BEGIN
		RAISERROR('#currencycodeismandatory', 18, -1)
		RETURN 1
	END

	UPDATE [BankAccount]
	SET
		[BankAccount].[CompanyID] = @CompanyID,
		[BankAccount].[FileAs] = @FileAs,
		[BankAccount].[CurrencyCode] = @CurrencyCode,
		[BankAccount].[BankName] = @BankName,
		[BankAccount].[BankCode] = @BankCode,
		[BankAccount].[Country] = @Country,
		[BankAccount].[City] = @City,
		[BankAccount].[Address] = @Address,
		[BankAccount].[SWIFT] = @SWIFT,
		[BankAccount].[ABA] = @ABA,
		[BankAccount].[IBAN] = @IBAN,
		[BankAccount].[Account] = @Account,
		[BankAccount].[IntermediaryBank] = @IntermediaryBank,
		[BankAccount].[IntermediaryAddress] = @IntermediaryAddress,
		[BankAccount].[IntermediarySWIFT] = @IntermediarySWIFT,
		[BankAccount].[IntermediaryABA] = @IntermediaryABA,
		[BankAccount].[IntermediaryAccount] = @IntermediaryAccount,
		[BankAccount].[AdditionalAccounts] = @AdditionalAccounts,
		[BankAccount].[Modified] = DEFAULT,
		[BankAccount].[ModifiedBy] = DEFAULT
	WHERE
		[BankAccount].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC adfBankAccountGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfBankAccountUpdate TO PUBLIC
GO
 