IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfBankAccountDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfBankAccountDelete'
		DROP PROCEDURE [dbo].[adfBankAccountDelete]
	END
GO

PRINT 'Creating procedure adfBankAccountDelete'
GO

/******************************************************************************
**		File: adfBankAccountDelete.sql
**		Name: adfBankAccountDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/04/2004 15:04:36
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfBankAccountDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	IF EXISTS(SELECT * FROM [Company] WHERE [BankAccountID] = @ID)
	BEGIN
		UPDATE
			[Company]
		SET
			[BankAccountID] = NULL
		WHERE
			[BankAccountID] = @ID
	END
	
	DELETE FROM [BankAccount] WHERE [BankAccount].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfBankAccountDelete TO PUBLIC
GO
 