IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCompanyBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCompanyBrowse'
		DROP PROCEDURE [dbo].[adfCompanyBrowse]
	END
GO

PRINT 'Creating procedure adfCompanyBrowse'
GO

/******************************************************************************
**		File: adfCompanyBrowse.sql
**		Name: adfCompanyBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry
**		Date: 10/03/2004 21:04:59
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		06.05.10	KOV				  ApplyVAT    
**
**		23.6.10		MAN				  Number
**		15.12.11	PAM				   
**		25.09.13	SOV				   -
**									dbo.fnPjm7GetUserIDByEmployeeID
**		03.09.14	GNV				  
*******************************************************************************/
CREATE PROCEDURE [adfCompanyBrowse]
	@StateSelector INT,
	@EmployeeID TIdentifier = NULL,
	@ContractSelector INT,
	@CompanyStatusSelector int,
	@CompanyStatusID TIdentifier
AS
	SET NOCOUNT ON
	SET ARITHABORT ON
 
	--     
	IF dbo.adfHasAccessRightByName('ManageCompanies') = 0 AND dbo.adfHasAccessRightByName('ViewAllCompanies') = 0
		RETURN 0

	DECLARE
		@CurrentUserID TIdentifier, 
		@CompanyClass TClass, 
		@UserID TIdentifier,
		@value TVariant,
		@UseCompanyRelationships BIT
	
	SET @CurrentUserID = dbo.adfGetCurrentUserID()
	SET @CompanyClass = dbo.adfGetClassByName('Adf.Company')
	
	IF @EmployeeID = -1
	BEGIN
		SET @UserID = @CurrentUserID
	END
	
	EXEC adfParameterGet 'UseCompanyRelationships', 'Pjm7', @value OUTPUT	
	SET @UseCompanyRelationships = CAST(@value AS BIT)

	SELECT
		[Company].[ID],
		[Company].[Class],
		[Company].[State],
		[Company].[Flag],
		[Company].[FileAs],
		[Company].[FoundationDate],
		[Company].[LegalName],
		[Company].[KPP],
		[Company].[LegalCode],
		[Company].[BankAccountID],
		[Company].[ExecutiveEmployeeID],
		[Company].[AccountantEmployeeID],
		[Company].[Own],
		[ManagerEmployeeID] =
		CASE
			WHEN ([dbo].[adfHasAccessRightByNameForUser] ('ViewAllCompanies', dbo.fnPjm5GetEmployeeUserID(ManagerEmployeeID))=0)
				OR
				([dbo].[adfHasAccessRightByNameForUser] ('ManageCompanies', dbo.fnPjm5GetEmployeeUserID(ManagerEmployeeID))=0)
			THEN null
			ELSE
			ManagerEmployeeID
		END,
		[Company].[CompanySizeID],
		[Company].[CompanyTurnoverID],
		[Company].[CompanyStatusID],
		[Company].[Comments],
		[Company].[Created],
		[Company].[CreatedBy],
		[Company].[Modified],
		[Company].[ModifiedBy],
		[Company].[Timestamp],
		[Company].[ApplyVAT],
		[Company].[Number],
		[#PhoneType#7] as Phone1,
		[#PhoneType#11] as Phone2,
		(SELECT [Street]  FROM [Address] WHERE [Address].[BusinessCardID] = [Company].[ID] AND [Address].[BusinessCardClass] = [Company].[Class] AND [Address].[AddressTypeID] = 1) as [Street],
		(SELECT [Street] FROM [Address] WHERE [Address].[BusinessCardID] = [Company].[ID] AND [Address].[BusinessCardClass] = [Company].[Class] AND [Address].[AddressTypeID] = 3) as [Street2],
		(SELECT [Country] FROM [Address] WHERE [Address].[BusinessCardID] = [Company].[ID] AND [Address].[BusinessCardClass] = [Company].[Class] AND [Address].[AddressTypeID] = 1) as [Country],
		(SELECT [Country] FROM [Address] WHERE [Address].[BusinessCardID] = [Company].[ID] AND [Address].[BusinessCardClass] = [Company].[Class] AND [Address].[AddressTypeID] = 3) as [Country2],
		(SELECT [Region] FROM [Address] WHERE [Address].[BusinessCardID] = [Company].[ID] AND [Address].[BusinessCardClass] = [Company].[Class] AND [Address].[AddressTypeID] = 1) as [Region],
		(SELECT [Region] FROM [Address] WHERE [Address].[BusinessCardID] = [Company].[ID] AND [Address].[BusinessCardClass] = [Company].[Class] AND [Address].[AddressTypeID] = 3) as [Region2],
		(SELECT [City] FROM [Address] WHERE [Address].[BusinessCardID] = [Company].[ID] AND [Address].[BusinessCardClass] = [Company].[Class] AND [Address].[AddressTypeID] = 1) as [City],
		(SELECT [City] FROM [Address] WHERE [Address].[BusinessCardID] = [Company].[ID] AND [Address].[BusinessCardClass] = [Company].[Class] AND [Address].[AddressTypeID] = 3) as [City2],
		(SELECT [PostalCode] FROM [Address] WHERE [Address].[BusinessCardID] = [Company].[ID] AND [Address].[BusinessCardClass] = [Company].[Class] AND [Address].[AddressTypeID] = 1) as [PostalCode],
		(SELECT [PostalCode] FROM [Address] WHERE [Address].[BusinessCardID] = [Company].[ID] AND [Address].[BusinessCardClass] = [Company].[Class] AND [Address].[AddressTypeID] = 3) as [PostalCode2],
		(SELECT [Email] FROM [Email] WHERE [Email].[BusinessCardID] = [Company].[ID] AND [Email].[BusinessCardClass] = [Company].[Class] AND [Email].[EmailTypeID] = 1) as Email,
		(SELECT [Email] FROM [Email] WHERE [Email].[BusinessCardID] = [Company].[ID] AND [Email].[BusinessCardClass] = [Company].[Class] AND [Email].[EmailTypeID] = 4) as WebPage,
		CAST((CASE WHEN [UserContact].[BusinessCardID] IS NULL THEN 0 ELSE 1 END) as bit) as [Private],
		[#PhoneType#1],
		[#PhoneType#2],
		[#PhoneType#3],
		[#PhoneType#4],
		[#PhoneType#5],
		[#PhoneType#6],
		[#PhoneType#7],
		[#PhoneType#8],
		[#PhoneType#9],
		[#PhoneType#10],
		[#PhoneType#11],
		CASE @UseCompanyRelationships 
			WHEN 1 THEN [CRE].[FirstCompanyID] 
			ELSE NULL
		END AS [ParentCompanyID]
	FROM
		[Company]
		LEFT OUTER JOIN [vwPhone]
			ON ([Company].[ID] = [vwPhone].[BusinessCardID] AND @CompanyClass = [vwPhone].[BusinessCardClass])
		LEFT OUTER JOIN [UserContact]
			ON ([Company].[ID] = [UserContact].[BusinessCardID] AND [UserContact].[BusinessCardClass] = @CompanyClass AND [UserContact].[UserID] = @CurrentUserID)
		LEFT OUTER JOIN [CompanyRelationshipEntry] AS [CRE]
			ON [Company].[ID] = [CRE].[SecondCompanyID]
			AND [CRE].[FileAs] = N' '
	WHERE
		(
			(@StateSelector = 0) OR 
			(@StateSelector != 0 AND [Company].[State] = @StateSelector)
		)		
		AND
			[Company].[State] < 100
		AND
		(
			@ContractSelector = 0 OR
			(@ContractSelector = 1 AND EXISTS(SELECT * FROM Project WHERE [SupplierCompanyID] = [Company].[ID] OR [CustomerCompanyID]=[Company].[ID])) OR
			(@ContractSelector = 2 AND NOT EXISTS(SELECT * FROM Project WHERE [SupplierCompanyID] = [Company].[ID] OR [CustomerCompanyID]=[Company].[ID]))
		)
		AND
		(
			@EmployeeID IS NULL
			OR
			(@EmployeeID = -1 AND  [UserContact].[BusinessCardID] IS NOT NULL)
			OR
			([Company].[ManagerEmployeeID] = @EmployeeID)
		)
		AND
		(
			@CompanyStatusSelector = 0 OR
			ISNULL([CompanyStatusID], 0) = ISNULL(@CompanyStatusID, 0)
		)

	RETURN 0
GO

GRANT EXECUTE ON [adfCompanyBrowse] TO PUBLIC
GO
