IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCompanySmartSearch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCompanySmartSearch'
		DROP PROCEDURE [dbo].[adfCompanySmartSearch]
	END
GO

PRINT 'Creating procedure adfCompanySmartSearch'
GO

/******************************************************************************
**		File: adfCompanySmartSearch.sql
**		Name: adfCompanySmartSearch
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Nikita.Golyshev
**		Date: 27/03/2014 16:43:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
*******************************************************************************/
CREATE PROCEDURE [dbo].[adfCompanySmartSearch]
	@LegalName TName,
	@LegalCode TCode,
	@CompanyReturnID INT = NULL OUTPUT
AS
	DECLARE	@result INT

	SET NOCOUNT ON
	
	SET @CompanyReturnID = (
		SELECT TOP(1) [ID]
		FROM (
			SELECT 
				CASE 
					WHEN CHARINDEX (N'ООО',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,4,'')
					WHEN CHARINDEX (N'ОАО',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,4,'')
					WHEN CHARINDEX (N'ЗАО',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,4,'')
					WHEN CHARINDEX (N'ОДО',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,4,'')
					WHEN CHARINDEX (N'АНО',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,4,'')
					WHEN CHARINDEX (N'ПИФ',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,4,'')
						
					WHEN CHARINDEX (N'АО',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,3,'')
					WHEN CHARINDEX (N'ИП',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,3,'')
					WHEN CHARINDEX (N'ЧП',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,3,'')
					WHEN CHARINDEX (N'УП',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,3,'')
					WHEN CHARINDEX (N'ПК',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,3,'')
						
					WHEN CHARINDEX (N'ОБЩЕСТВО С ОГРАНИЧЕННОЙ ОТВЕТСТВЕННОСТЬЮ',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,41,'')
					WHEN CHARINDEX (N'ОТКРЫТОЕ АКЦИОНЕРНОЕ ОБЩЕСТВО',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,30,'')
					WHEN CHARINDEX (N'ЗАКРЫТОЕ АКЦИОНЕРНОЕ ОБЩЕСТВО',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,30,'')
					WHEN CHARINDEX (N'ОБЩЕСТВО С ДОПОЛНИТЕЛЬНОЙ ОТВЕТСТВЕННОСТЬЮ',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,43,'')
					WHEN CHARINDEX (N'АВТОНОМНЫЕ НЕКОММЕРЧЕСКИЕ ОРГАНИЗАЦИИ',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,38,'')
					WHEN CHARINDEX (N'ПАЕВОЙ ИНВЕСТИЦИОННЫЙ ФОНД',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,27,'')
					WHEN CHARINDEX (N'АКЦИОНЕРНОЕ ОБЩЕСТВО',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,21,'')
					WHEN CHARINDEX (N'ИНДИВИДУАЛЬНЫЙ ПРЕДПРИНИМАТЕЛЬ',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,31,'')
					WHEN CHARINDEX (N'ЧАСТНЫЙ ПРЕДПРИНИМАТЕЛЬ',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,24,'')
					WHEN CHARINDEX (N'УНИТАРНОЕ ПРЕДПРИЯТИЕ',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,22,'')
					WHEN CHARINDEX (N'ПРОИЗВОДСТВЕННЫЙ КООПЕРАТИВ',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,28,'')
						
					ELSE [LegalName]
				END AS LegalName,
				LegalCode,
				ID
			FROM (
				SELECT 
					UPPER (
						REPLACE(REPLACE(REPLACE([LegalName],'"',''),'«',''),'»','')
					) AS LegalName,
					LegalCode,
					ID
				FROM [Company] ) AS REPLACED_UPPER
		) AS FINAL
		WHERE (FINAL.[LegalCode] = @LegalCode 
				OR (FINAL.[LegalCode] IS NULL AND @LegalCode IS NULL) 
				OR (FINAL.[LegalCode] IS NULL AND @LegalCode = '')) 
			AND FINAL.[LegalName] IN (
			SELECT TOP(1)
				CASE 
					WHEN CHARINDEX (N'ООО',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,4,'')
					WHEN CHARINDEX (N'ОАО',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,4,'')
					WHEN CHARINDEX (N'ЗАО',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,4,'')
					WHEN CHARINDEX (N'ОДО',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,4,'')
					WHEN CHARINDEX (N'АНО',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,4,'')
					WHEN CHARINDEX (N'ПИФ',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,4,'')
						
					WHEN CHARINDEX (N'АО',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,3,'')
					WHEN CHARINDEX (N'ИП',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,3,'')
					WHEN CHARINDEX (N'ЧП',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,3,'')
					WHEN CHARINDEX (N'УП',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,3,'')
					WHEN CHARINDEX (N'ПК',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,3,'')
						
					WHEN CHARINDEX (N'ОБЩЕСТВО С ОГРАНИЧЕННОЙ ОТВЕТСТВЕННОСТЬЮ',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,41,'')
					WHEN CHARINDEX (N'ОТКРЫТОЕ АКЦИОНЕРНОЕ ОБЩЕСТВО',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,30,'')
					WHEN CHARINDEX (N'ЗАКРЫТОЕ АКЦИОНЕРНОЕ ОБЩЕСТВО',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,30,'')
					WHEN CHARINDEX (N'ОБЩЕСТВО С ДОПОЛНИТЕЛЬНОЙ ОТВЕТСТВЕННОСТЬЮ',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,43,'')
					WHEN CHARINDEX (N'АВТОНОМНЫЕ НЕКОММЕРЧЕСКИЕ ОРГАНИЗАЦИИ',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,38,'')
					WHEN CHARINDEX (N'ПАЕВОЙ ИНВЕСТИЦИОННЫЙ ФОНД',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,27,'')
					WHEN CHARINDEX (N'АКЦИОНЕРНОЕ ОБЩЕСТВО',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,21,'')
					WHEN CHARINDEX (N'ИНДИВИДУАЛЬНЫЙ ПРЕДПРИНИМАТЕЛЬ',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,31,'')
					WHEN CHARINDEX (N'ЧАСТНЫЙ ПРЕДПРИНИМАТЕЛЬ',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,24,'')
					WHEN CHARINDEX (N'УНИТАРНОЕ ПРЕДПРИЯТИЕ',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,22,'')
					WHEN CHARINDEX (N'ПРОИЗВОДСТВЕННЫЙ КООПЕРАТИВ',[LegalName] COLLATE Cyrillic_General_CI_AS) > 0
						THEN STUFF([LegalName],1,28,'')
						
					ELSE [LegalName]
				END AS LegalName
			FROM (
				SELECT 
					UPPER (
						REPLACE(REPLACE(REPLACE(@LegalName,'"',''),'«',''),'»','')
					) AS LegalName
				) AS REPLACED_UPPER
		)
	)
	
	RETURN 0
GO

GRANT EXECUTE ON adfCompanySmartSearch TO PUBLIC
GO