IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfNoteBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfNoteBrowse'
		DROP  Procedure  adfNoteBrowse
	END

GO

PRINT 'Creating Procedure adfNoteBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfNoteBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfNoteBrowse
	@DocumentClass TClass,
	@DocumentID TIdentifier
AS
	SET NOCOUNT ON

	SELECT
		[Note].[ID],
		[Note].[Text],
		[Note].[Created],
		[Trustee].[DisplayName] as [CreatedByName],
		[Note].[CreatedBy]
	FROM
		[Note] INNER JOIN [Trustee]
			ON ([Note].[CreatedBy] = [Trustee].[ID])
	WHERE
		[Note].[DocumentClass] = @DocumentClass 
	AND
		[Note].[DocumentID] = @DocumentID
	ORDER BY
		[Note].[Created] DESC
	
	RETURN 0
GO

GRANT EXEC ON adfNoteBrowse TO PUBLIC
GO
