IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfMailItemGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfMailItemGet'
		DROP PROCEDURE [dbo].[adfMailItemGet]
	END
GO

PRINT 'Creating procedure adfMailItemGet'
GO

SET QUOTED_IDENTIFIER ON
GO

/******************************************************************************
**		File: adfMailItemGet.sql
**		Name: adfMailItemGet
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/17/2006
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfMailItemGet] @ID int
AS
	SET NOCOUNT ON
	
	SELECT
		[MailItem].[Class],
		[MailItem].[ID],
		[MailItem].[State],
		[MailItem].[Flag],
		[MailItem].[FileAs],
		[MailItem].[EventType],
		[MailItem].[FromID],
		[MailItem].[DocumentID],
		[MailItem].[DocumentClass],
		[MailItem].[Read],
		[MailItem].[Data],
		[MailItem].[Comments],
		[MailItem].[Created],
		[MailItem].[CreatedBy],
		[MailItem].[Modified],
		[MailItem].[ModifiedBy],
		CAST([MailItem].[Timestamp] as bigint) as [Timestamp]
	FROM
		[MailItem]
	WHERE
		[MailItem].[ID] = @ID
		
	RETURN 0
GO

GRANT EXECUTE ON [adfMailItemGet] TO PUBLIC
GO
 