IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfWorkingPeriodBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfWorkingPeriodBrowse'
		DROP PROCEDURE [dbo].[adfWorkingPeriodBrowse]
	END
GO

PRINT 'Creating procedure adfWorkingPeriodBrowse'
GO

/******************************************************************************
**		File: adfWorkingPeriodBrowse.sql
**		Name: adfWorkingPeriodBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/07/2004 13:16:13
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfWorkingPeriodBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[WorkingPeriod].[ID],
		[WorkingPeriod].[Class],
		[WorkingPeriod].[State],
		[WorkingPeriod].[Flag],
		[WorkingPeriod].[FileAs],
		[WorkingPeriod].[StartDate],
		[WorkingPeriod].[EndDate],
		[WorkingPeriod].[Comments],
		[WorkingPeriod].[Created],
		[WorkingPeriod].[CreatedBy],
		[WorkingPeriod].[Modified],
		[WorkingPeriod].[ModifiedBy],
		[WorkingPeriod].[Timestamp]
	FROM
		[WorkingPeriod]
	WHERE
		((@StateSelector = 0) OR (@StateSelector != 0 AND [WorkingPeriod].[State] = @StateSelector))
		
	RETURN 0
GO

GRANT EXECUTE ON [adfWorkingPeriodBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfWorkingPeriodGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfWorkingPeriodGet'
		DROP PROCEDURE [dbo].[adfWorkingPeriodGet]
	END
GO

PRINT 'Creating procedure adfWorkingPeriodGet'
GO

/******************************************************************************
**		File: adfWorkingPeriodGet.sql
**		Name: adfWorkingPeriodGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/07/2004 13:16:13
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfWorkingPeriodGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[WorkingPeriod].[ID],
		[WorkingPeriod].[Class],
		[WorkingPeriod].[State],
		[WorkingPeriod].[Flag],
		[WorkingPeriod].[FileAs],
		[WorkingPeriod].[StartDate],
		[WorkingPeriod].[EndDate],
		[WorkingPeriod].[Comments],
		[WorkingPeriod].[Created],
		[WorkingPeriod].[CreatedBy],
		[WorkingPeriod].[Modified],
		[WorkingPeriod].[ModifiedBy],
		[WorkingPeriod].[Timestamp]
	FROM
		[WorkingPeriod]
	WHERE
		[WorkingPeriod].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [adfWorkingPeriodGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfWorkingPeriodCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfWorkingPeriodCreate'
		DROP PROCEDURE [dbo].[adfWorkingPeriodCreate]
	END
GO

PRINT 'Creating procedure adfWorkingPeriodCreate'
GO

/******************************************************************************
**		File: adfWorkingPeriodCreate.sql
**		Name: adfWorkingPeriodCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/07/2004 13:16:13
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfWorkingPeriodCreate]
	@FileAs TName,
	@StartDate TDate,
	@EndDate TDate,
	@Comments TNotes
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('9137d8a2-3341-4215-8461-acf6825052ad')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [WorkingPeriod]
		([Flag], [State], [FileAs], [StartDate], [EndDate], [Comments])
	VALUES
		(0, @State, @FileAs, @StartDate, @EndDate, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC adfWorkingPeriodGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfWorkingPeriodCreate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfWorkingPeriodUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfWorkingPeriodUpdate'
		DROP PROCEDURE [dbo].[adfWorkingPeriodUpdate]
	END
GO

PRINT 'Creating procedure adfWorkingPeriodUpdate'
GO

/******************************************************************************
**		File: adfWorkingPeriodUpdate.sql
**		Name: adfWorkingPeriodUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/07/2004 13:16:13
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfWorkingPeriodUpdate
	@ID TIdentifier,
	@FileAs TName,
	@StartDate TDate,
	@EndDate TDate,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[WorkingPeriod]
	SET
		[WorkingPeriod].[FileAs] = @FileAs,
		[WorkingPeriod].[StartDate] = @StartDate,
		[WorkingPeriod].[EndDate] = @EndDate,
		[WorkingPeriod].[Comments] = @Comments,
		[WorkingPeriod].[Modified] = GETDATE(),
		[WorkingPeriod].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[WorkingPeriod].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC adfWorkingPeriodGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfWorkingPeriodUpdate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfWorkingPeriodDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfWorkingPeriodDelete'
		DROP PROCEDURE [dbo].[adfWorkingPeriodDelete]
	END
GO

PRINT 'Creating procedure adfWorkingPeriodDelete'
GO

/******************************************************************************
**		File: adfWorkingPeriodDelete.sql
**		Name: adfWorkingPeriodDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/07/2004 13:16:13
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfWorkingPeriodDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [WorkingPeriod] WHERE [WorkingPeriod].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfWorkingPeriodDelete TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfWorkingPeriodChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfWorkingPeriodChangeState'
		DROP PROCEDURE [dbo].[adfWorkingPeriodChangeState]
	END
GO

PRINT 'Creating procedure adfWorkingPeriodChangeState'
GO

/******************************************************************************
**		File: adfWorkingPeriodChangeState.sql
**		Name: adfWorkingPeriodChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/07/2004 13:16:13
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfWorkingPeriodChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [WorkingPeriod].[Class],
		@FromState = [WorkingPeriod].[State]
	FROM
		[WorkingPeriod]
	WHERE
		[WorkingPeriod].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[WorkingPeriod]
	SET
		[WorkingPeriod].[State] = @ToState,
		[WorkingPeriod].[Modified] = GETDATE(),
		[WorkingPeriod].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[WorkingPeriod].[ID] = @ID
	AND
		[WorkingPeriod].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfWorkingPeriodChangeState TO PUBLIC
GO
 