IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfBase64ToBin]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function adfBase64ToBin'
		DROP FUNCTION [dbo].[adfBase64ToBin]
	END

GO

PRINT 'Creating function adfBase64ToBin'
GO
/******************************************************************************
**		File: 
**		Name: adfBase64ToBin
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION adfBase64ToBin(@text varchar(8000))
RETURNS varbinary(8000)
AS
BEGIN
	DECLARE @out varbinary(8000)
	DECLARE @index int
	DECLARE @length int
	DECLARE @ch char(1)
	DECLARE @code int
	DECLARE @result int
	DECLARE @phase int
	DECLARE @temp varbinary(8000)

	IF @text IS NOT NULL 
	BEGIN
		SET @length = LEN(@text)
		SET @index = 1
		SET @phase = 0
		SET @out = 0x
		WHILE @index <= @length
		BEGIN
			IF @phase = 0
				SET @result = 0

			BEGIN
				SET @ch = SUBSTRING(@text, @index, 1)
				IF ASCII(@ch) BETWEEN 65 AND 90
					SET @code = ASCII(@ch) - 65
				ELSE IF @ch LIKE '[a-z]'
					SET @code = ASCII(@ch) - 71
				ELSE IF @ch LIKE '[0-9]'
					SET @code = ASCII(@ch) + 4 -- 52 range starts at '0'
				ELSE IF @ch = '+'
					SET @code = 62
				ELSE IF @ch = '/'
					SET @code = 63
				ELSE 
					SET @code = -1
			END
			IF @code >= 0
			BEGIN			
				SET @result = @result * 64 + @code				
				SET @phase = (@phase + 1) % 4
				IF @phase = 0
				BEGIN
					SET @temp = CONVERT(binary(3), @result)
					SET @out = @out + CONVERT(binary(3), @result)
				END
			END		
			SET @index = @index + 1
		END
		IF @phase = 3
			SET @out = @out + SUBSTRING(CONVERT(binary(3), @result * 64), 1, 2)
		ELSE IF @phase = 2
			SET @out = @out + SUBSTRING(CONVERT(binary(3), @result * 64 * 64), 1, 1)
		ELSE IF @phase = 1 
			SET @out = @out + SUBSTRING(CONVERT(binary(3), @result * 64 * 64 * 64), 1, 1)
	END
	RETURN @out
END
GO

