IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfGetDocumentClassNameByTable]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function adfGetDocumentClassNameByTable'
		DROP FUNCTION [dbo].[adfGetDocumentClassNameByTable]
	END

GO

PRINT 'Creating function adfGetDocumentClassNameByTable'
GO
/******************************************************************************
**		File: 
**		Name: adfGetDocumentClassNameByTable
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: nikita.alexandrov
**		Date: 09/07/2009
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION adfGetDocumentClassNameByTable (@DocumentTable TSysname)
RETURNS TName
AS
BEGIN
	DECLARE
		@Lang TLanguage,
		@DocumentClassName TName
	
	SET @Lang = dbo.adfGetLanguage()

	IF @Lang = 'en'
		BEGIN
			SELECT
				@DocumentClassName = [ClassGlobal].[Name]
			FROM
				[ClassGlobal]
			INNER JOIN [Class] ON
			(
				[ClassGlobal].[Class] = [Class].[Class]
				AND
				[Class].[TableName] = @DocumentTable
			)
			WHERE
				[ClassGlobal].[Language] = @Lang
		END
	ELSE IF @Lang = 'ru'
		BEGIN
			SELECT
				@DocumentClassName = [Class].[Name]
			FROM
				[Class]
			WHERE
				[Class].[TableName] = @DocumentTable
		END 
	
	RETURN @DocumentClassName
END
GO

GRANT EXECUTE ON adfGetDocumentClassNameByTable TO PUBLIC
GO