IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfAccessRightCheck')
	BEGIN
		PRINT 'Dropping Procedure adfAccessRightCheck'
		DROP  Procedure  adfAccessRightCheck
	END

GO

PRINT 'Creating Procedure adfAccessRightCheck'
GO
/******************************************************************************
**		File: 
**		Name: adfAccessRightCheck
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfAccessRightCheck 
	@Name TSysname -- right name
AS
	DECLARE @UserID TIdentifier,
			@RightID TIdentifier,
			@Result TIdentifier
			
	SET NOCOUNT ON

	IF @Name = 'ManageLogins'
	BEGIN
		IF IS_SRVROLEMEMBER('securityadmin') = 1
			RETURN 0
		ELSE
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
	END
	
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @RightID = dbo.adfGetRightID(@Name)

	EXEC @Result = adfAccessRightCheckInternal @RightID, @UserID
	
	RETURN @Result
GO

GRANT EXEC ON adfAccessRightCheck TO PUBLIC
GO
