IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfIsRoleMember]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function adfIsRoleMember'
		DROP FUNCTION [dbo].[adfIsRoleMember]
	END

GO

PRINT 'Creating function adfIsRoleMember'
GO
/******************************************************************************
**		File: 
**		Name: adfIsRoleMember
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION adfIsRoleMember
	(@rolename TSysname)
RETURNS BIT
AS
BEGIN
	DECLARE @UserID INT
	SET @UserID = dbo.adfGetCurrentUserID()
	IF EXISTS(SELECT * FROM [UserRole] WHERE 
		[UserRole].[RoleID] = dbo.adfGetRoleID(@rolename)
		AND [UserRole].[UserID] = dbo.adfGetCurrentUserID())
	BEGIN
		RETURN 1
	END
	RETURN 0
END
GO

GRANT EXEC ON adfIsRoleMember TO PUBLIC
GO
