IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfRoleRightsGet')
	BEGIN
		PRINT 'Dropping Procedure adfRoleRightsGet'
		DROP  Procedure  adfRoleRightsGet
	END

GO

PRINT 'Creating Procedure adfRoleRightsGet'
GO
/******************************************************************************
**		File: 
**		Name: adfRoleRightsGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		05.06.14	SAP				    Active
*******************************************************************************/
CREATE Procedure adfRoleRightsGet
	@Name TSysname
AS
	DECLARE @RoleID TIdentifier
	
	SET NOCOUNT ON
	
	SET @RoleID = dbo.adfGetRoleID(@Name)

	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()
	
	SELECT
		[Right].[Name],
		ISNULL([RightGlobal].[DisplayName], [Right].[DisplayName]) as [DisplayName],
		[Right].[Active]
	FROM
		[AccessRight] INNER JOIN [Right]
			ON ([AccessRight].[RightID] = [Right].[ID])
		LEFT OUTER JOIN [RightGlobal]
			ON ([Right].[ID] = [RightGlobal].[ID] AND [RightGlobal].[Language] = @Lang)
	WHERE
		[AccessRight].[TrusteeID] = @RoleID
	ORDER BY
		ISNULL([RightGlobal].[DisplayName], [Right].[DisplayName])
	
	RETURN 0
GO

GRANT EXEC ON adfRoleRightsGet TO PUBLIC
GO
