IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfRoleUpdate')
	BEGIN
		PRINT 'Dropping Procedure adfRoleUpdate'
		DROP  Procedure  adfRoleUpdate
	END

GO

PRINT 'Creating Procedure adfRoleUpdate'
GO
/******************************************************************************
**		File: 
**		Name: adfRoleUpdate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		04.06.13	SOV				   " "
*******************************************************************************/
CREATE Procedure adfRoleUpdate
	@ID TIdentifier,
	@Name TSysname,
	@DisplayName TName,
	@Comments TNotes,
	@IsActive TBool
AS
	SET NOCOUNT ON
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	BEGIN TRANSACTION
	IF @Lang = 'ru'
	BEGIN
		UPDATE [Trustee]
		SET
			[Trustee].[Name] = @Name,
			[Trustee].[DisplayName] = @DisplayName,
			[Trustee].[Comments] = @Comments,
			[Trustee].[Active] = @IsActive
		WHERE
			[Trustee].[ID] = @ID
	END

/*	ELSE
	BEGIN
		UPDATE [Trustee]
		SET
			[Trustee].[Name] = @Name
		WHERE
			[Trustee].[ID] = @ID
	END
*/

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	IF EXISTS(SELECT * FROM [TrusteeGlobal] WHERE [ID] = @ID AND [Language] = @Lang)
	BEGIN
		UPDATE [TrusteeGlobal]
		SET
			[DisplayName] = @DisplayName,
			[Comments] = @Comments
		WHERE
			[ID] = @ID AND [Language] = @Lang
	END
	ELSE
	BEGIN
		INSERT [TrusteeGlobal]
			([ID], [Language], [DisplayName], [Comments])
		VALUES
			(@ID, @Lang, @DisplayName, @Comments)
	END

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION
	
	EXEC adfRoleGet @ID
	
	RETURN 0
GO

GRANT EXEC ON adfRoleUpdate TO PUBLIC
GO
