IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfStateUpdate')
	BEGIN
		PRINT 'Dropping Procedure adfStateUpdate'
		DROP  Procedure  adfStateUpdate
	END

GO

PRINT 'Creating Procedure adfStateUpdate'
GO
/******************************************************************************
**		File: 
**		Name: adfStateUpdate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfStateUpdate
	@Class TClass,
	@State TState,
	@Name TName,
	@Comments TNotes,
	@UIText TName,
	@Image TPicture
AS
	SET NOCOUNT ON
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()
	
	BEGIN TRANSACTION

	IF @Lang = 'ru'
	BEGIN
		UPDATE [State]
		SET
			[State].[Name] = @Name,
			[State].[Comments] = @Comments,
			[State].[UIText] = @UIText,
			[State].[Image] = @Image
		WHERE
			[State].[Class] = @Class
		AND
			[State].[State] = @State
	END
	ELSE
	BEGIN
		UPDATE [State]
		SET
			[State].[Image] = @Image
		WHERE
			[State].[Class] = @Class
		AND
			[State].[State] = @State
	END
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
		
	IF EXISTS(SELECT * FROM [StateGlobal] WHERE [Class] = @Class AND [State] = @State  AND [Language] = @Lang)
	BEGIN
		UPDATE [StateGlobal]
		SET
			[Name] = @Name,
			[Comments] = @Comments,
			[UIText] = @UIText
		WHERE
			[Class] = @Class AND [State] = @State  AND [Language] = @Lang
	END
	ELSE
	BEGIN
		INSERT INTO [StateGlobal] 
			([Class], [State], [Language], [Name], [Comments], [UIText])
		VALUES
			(@Class, @State, @Lang, @Name, @Comments, @UIText)
	END
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	
	EXEC adfStateGet @Class, @State
	
	RETURN 0
GO

GRANT EXEC ON adfStateUpdate TO PUBLIC
GO
