IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'adftrUserI')
	BEGIN
		PRINT 'Dropping Trigger adftrUserI'
		DROP  Trigger adftrUserI
	END
GO

/******************************************************************************
**		File: 
**		Name: adftrUserI
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:		Description:
**		--------	--------	-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger adftrUserI'
GO
CREATE TRIGGER adftrUserI ON [dbo].[User] FOR INSERT
AS
	IF EXISTS(SELECT COUNT(*) FROM [User] WHERE [Locked]= 0 AND [NTLogin] IS NOT NULL GROUP BY [NTLogin] HAVING COUNT(*) > 1)
	BEGIN
		RAISERROR('#UserLoginMustBeUnique', 16, -1)
		ROLLBACK TRANSACTION
		RETURN
	END
	IF EXISTS(SELECT COUNT(*) FROM [User] WHERE [Locked]= 0 AND [SQLLogin] IS NOT NULL GROUP BY [SQLLogin] HAVING COUNT(*) > 1)
	BEGIN
		RAISERROR('#UserLoginMustBeUnique', 16, -1)
		ROLLBACK TRANSACTION
		RETURN
	END
	INSERT INTO [UserRole] ([RoleID], [UserID])
	SELECT
		0, [ID]
	FROM
		inserted
		
	
GO

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'adftrUserU')
	BEGIN
		PRINT 'Dropping Trigger adftrUserU'
		DROP  Trigger adftrUserU
	END
GO

/******************************************************************************
**		File: 
**		Name: adftrUserU
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:		Description:
**		--------	--------	-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger adftrUserU'
GO
CREATE TRIGGER adftrUserU ON [dbo].[User] FOR UPDATE
AS
	IF EXISTS(SELECT COUNT(*) FROM [User] WHERE [Locked]= 0 AND [NTLogin] IS NOT NULL GROUP BY [NTLogin] HAVING COUNT(*) > 1)
	BEGIN
		RAISERROR('#UserLoginMustBeUnique', 16, -1)
		ROLLBACK TRANSACTION
		RETURN
	END
	IF EXISTS(SELECT COUNT(*) FROM [User] WHERE [Locked]= 0 AND [SQLLogin] IS NOT NULL GROUP BY [SQLLogin] HAVING COUNT(*) > 1)
	BEGIN
		RAISERROR('#UserLoginMustBeUnique', 16, -1)
		ROLLBACK TRANSACTION
		RETURN
	END
	
GO

