IF EXISTS (SELECT * FROM sysobjects WHERE type = 'V' AND name = 'adfvwTransitionTemplate')
	BEGIN
		PRINT 'Dropping View adfvwTransitionTemplate'
		DROP  View adfvwTransitionTemplate
	END
GO

/******************************************************************************
**		File: 
**		Name: adfvwTransitionTemplate
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**		22.11.12	SAP				  PreProcessMethod  PostProcessMethod
**									 TransitionTemplate 
*******************************************************************************/

PRINT 'Creating View adfvwTransitionTemplate'
GO
CREATE VIEW adfvwTransitionTemplate
AS
	SELECT
		[TransitionTemplate].[ID], 
		[TransitionTemplate].[Class], 
		[TransitionTemplate].[FromState], 
		[TransitionTemplate].[ToState], 
		ISNULL([TransitionTemplateGlobal].[Name], [TransitionTemplate].[Name]) as [Name], 
		[TransitionTemplate].[UICommandID], 
		[TransitionTemplate].[RightID], 
		[TransitionTemplate].[ActionID], 
		[TransitionTemplate].[SPValidate], 
		[TransitionTemplate].[SPBefore], 
		[TransitionTemplate].[SPAfter], 
		ISNULL([TransitionTemplateGlobal].[ConfirmationMessage], [TransitionTemplate].[ConfirmationMessage]) as [ConfirmationMessage], 
		ISNULL([TransitionTemplateGlobal].[Comments], [TransitionTemplate].[Comments]) as [Comments], 
		[TransitionTemplate].[Created], 
		[TransitionTemplate].[CreatedBy], 
		[TransitionTemplate].[Modified], 
		[TransitionTemplate].[ModifiedBy],
		[TransitionTemplate].[PreProcessMethod], 
        [TransitionTemplate].[PostProcessMethod]

	FROM
		[TransitionTemplate] LEFT OUTER JOIN [TransitionTemplateGlobal]
			ON ([TransitionTemplate].[ID]=[TransitionTemplateGlobal].[ID] AND 
				[TransitionTemplateGlobal].[Language] = dbo.adfGetLanguage())

GO
  