IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'Norm') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: Norm */
/*==============================================================*/
create table Norm (
	   ID                   TIdentifier          identity,
	   Class                TClass               not null,
	   State                TState               not null,
	   Flag                 TFlag                not null,
	   Code                 TCode                not null,
	   FileAs               TName                not null,
	   Created              TSysDateTime         not null default GETDATE(),
	   CreatedBy            TUserID              not null,
	   Modified             TSysDateTime         not null default GETDATE(),
	   ModifiedBy           TUserID              not null,
	   Comments             TNotes               null,
	   Timestamp            timestamp            not null,
	   constraint NormPK primary key  (ID)
	)
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'NormValue') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: NormValue */
/*==============================================================*/
create table NormValue (
	   NormID              TIdentifier          not null,
	   Year                smalldatetime        not null,
	   UtilizationHours    int	                not null,
	   RealizationHours    int                  not null,
	   Revenue             decimal(18,2)        null,
	   constraint NormValuePK primary key  (NormID, Year)
	)
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'EmployeeNormEntry') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: EmployeeNormEntry */
/*==============================================================*/
create table EmployeeNormEntry (
	Class				TClass               not null,
	ID                  TIdentifier          identity,
	State               TState               not null,
	Flag                TFlag                not null,
	FileAs				TName                not null,
	EmployeeID			TIdentifier          not null,
	StartDate			datetime			 not null,
	NormID				TIdentifier	         not null,
	Created             TSysDateTime         not null default GETDATE(),
	CreatedBy           TUserID              not null,
	Modified            TSysDateTime         not null default GETDATE(),
	ModifiedBy          TUserID              not null,
	Timestamp           timestamp            not null,
	[Comments]			TNotes				 NULL,
	constraint EmployeeNormEntryPK primary key  (ID)
	)
GO

IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'Comments' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='EmployeeNormEntry')
BEGIN
	ALTER TABLE [EmployeeNormEntry]
		ADD [Comments] TNotes null
END
GO

