SET ANSI_NULLS, ANSI_PADDING, ANSI_WARNINGS, ARITHABORT, CONCAT_NULL_YIELDS_NULL, QUOTED_IDENTIFIER ON;

SET NUMERIC_ROUNDABORT OFF;



GO
PRINT N'   [activitymonitorservice]...';

GO
CREATE ROLE [activitymonitorservice] AUTHORIZATION [dbo];

GO
PRINT N'   [activitymonitorsite]...';

GO
CREATE ROLE [activitymonitorsite] AUTHORIZATION [dbo];


GO
PRINT N'  [pjmams]...';

GO
CREATE SCHEMA [pjmams] AUTHORIZATION [dbo]



GO
PRINT N'  [pjmams].[Module]...';

GO
CREATE TABLE [pjmams].[Module] (
    [ID]          INT            IDENTITY (1, 1) NOT NULL,
    [CategoryID]  INT            NOT NULL,
    [Name]        NVARCHAR (MAX) NOT NULL,
    [Description] NVARCHAR (MAX) NULL,
    [Version]     NVARCHAR (32)  NULL,
    [Lang]        NVARCHAR (32)  NULL,
    [Active]      BIT            NOT NULL,
    PRIMARY KEY CLUSTERED ([ID] ASC)
);


GO
PRINT N'  [pjmams].[Window]...';

GO
CREATE TABLE [pjmams].[Window] (
    [ID]        INT            IDENTITY (1, 1) NOT NULL,
    [ProcessID] INT            NOT NULL,
    [HWND]      INT            NOT NULL,
    [Caption]   NVARCHAR (MAX) NOT NULL,
    [Created]   DATETIME       NOT NULL,
	[Duration]	INT			   NOT NULL DEFAULT 0
    PRIMARY KEY CLUSTERED ([ID] ASC)
);


GO
PRINT N'  [pjmams].[Process]...';

GO
CREATE TABLE [pjmams].[Process] (
    [ID]        INT            IDENTITY (1, 1) NOT NULL,
    [SessionID] INT            NULL,
    [ModuleID]  INT            NULL,
    [PID]       INT            NOT NULL,
    [UserName]  NVARCHAR (128) NOT NULL,
    [Created]   DATETIME       NOT NULL,
    [Closed]    DATETIME       NULL,
    [Idle]      INT            NOT NULL,
    PRIMARY KEY CLUSTERED ([ID] ASC)
);


GO
PRINT N'  [pjmams].[Category]...';

GO
CREATE TABLE [pjmams].[Category] (
    [ID]   INT            IDENTITY (1, 1) NOT NULL,
    [Name] NVARCHAR (256) NOT NULL,
    PRIMARY KEY CLUSTERED ([ID] ASC)
);


GO
PRINT N'  [pjmams].[Session]...';

GO
CREATE TABLE [pjmams].[Session] (
    [ID]              INT            IDENTITY (1, 1) NOT NULL,
    [MachineName]     NVARCHAR (128) NOT NULL,
    [SessionStart]    DATETIME       NOT NULL,
    [SessionEnd]      DATETIME       NOT NULL,
    [UserStatus]      INT            NOT NULL,
    [RemoteSession]   TINYINT        NOT NULL,
    [WinDir]          NVARCHAR (256) NULL,
    [ProgramFiles]    NVARCHAR (256) NULL,
    [ActiveProcessID] INT            NULL,
    [UserStatusTime]  DATETIME       NOT NULL,
    [UserName]        NVARCHAR (128) NULL,
	[ActiveWindowID]  INT            NULL,
    PRIMARY KEY CLUSTERED ([ID] ASC)
);



GO
PRINT N'      [pjmams].[Module]....';


GO
ALTER TABLE [pjmams].[Module]
    ADD DEFAULT (1) FOR [CategoryID];


GO
PRINT N'      [pjmams].[Module]....';


GO
ALTER TABLE [pjmams].[Module]
    ADD DEFAULT (1) FOR [Active];


GO
PRINT N'      [pjmams].[Window]....';


GO
ALTER TABLE [pjmams].[Window]
    ADD DEFAULT (getdate()) FOR [Created];


GO
PRINT N'      [pjmams].[Process]....';


GO
ALTER TABLE [pjmams].[Process]
    ADD DEFAULT (getdate()) FOR [Created];


GO
PRINT N'      [pjmams].[Process]....';


GO
ALTER TABLE [pjmams].[Process]
    ADD DEFAULT (0) FOR [Idle];


GO
PRINT N'      [pjmams].[Session]....';


GO
ALTER TABLE [pjmams].[Session]
    ADD DEFAULT (getdate()) FOR [SessionStart];


GO
PRINT N'      [pjmams].[Session]....';


GO
ALTER TABLE [pjmams].[Session]
    ADD DEFAULT (getdate()) FOR [SessionEnd];


GO
PRINT N'      [pjmams].[Session]....';


GO
ALTER TABLE [pjmams].[Session]
    ADD DEFAULT (0) FOR [UserStatus];


GO
PRINT N'      [pjmams].[Session]....';


GO
ALTER TABLE [pjmams].[Session]
    ADD DEFAULT (0) FOR [RemoteSession];


GO
PRINT N'      [pjmams].[Session]....';


GO
ALTER TABLE [pjmams].[Session]
    ADD DEFAULT (getdate()) FOR [UserStatusTime];


GO
PRINT N'  FK_Module_Category...';


GO
ALTER TABLE [pjmams].[Module]
    ADD CONSTRAINT [FK_Module_Category] FOREIGN KEY ([CategoryID]) REFERENCES [pjmams].[Category] ([ID]);


GO
PRINT N'  FK_Window_Process...';


GO
ALTER TABLE [pjmams].[Window]
    ADD CONSTRAINT [FK_Window_Process] FOREIGN KEY ([ProcessID]) REFERENCES [pjmams].[Process] ([ID]);


GO
PRINT N'  FK_Process_Module...';


GO
ALTER TABLE [pjmams].[Process]
    ADD CONSTRAINT [FK_Process_Module] FOREIGN KEY ([ModuleID]) REFERENCES [pjmams].[Module] ([ID]);


GO
PRINT N'  FK_Process_Session...';


GO
ALTER TABLE [pjmams].[Process]
    ADD CONSTRAINT [FK_Process_Session] FOREIGN KEY ([SessionID]) REFERENCES [pjmams].[Session] ([ID]);