﻿
if exists (select * from dbo.sysobjects where id = object_id(N'[exch].[CompanyGetOrCreate]') and objectproperty(id, N'IsProcedure') = 1)
begin
	print 'Dropping procedure CompanyGetOrCreate'
	drop procedure [exch].[CompanyGetOrCreate]
end
go

print 'Creating procedure CompanyGetOrCreate'
go

create procedure [exch].[CompanyGetOrCreate]
	@FileAs TName,
	@UserID TIdentifier,
	@ID TIdentifier OUT
as
begin
	set nocount on;
	declare @LegalCode TCode, @Comments TNotes, @UserName TName, @Class TClass

	set @ID = null;
	if @FileAs is not null
	begin
		select @ID = [ID] from [Company] where [FileAs] = @FileAs or [LegalName] = @FileAs;

		if @ID is null
		begin
		
			select @UserName = [FileAs] from [Employee] where [UserID] = @UserID;

			SET @Comments = 'Компания создана ' + convert(nvarchar(8), getdate(), 4)  + ' в результате синхронизации с Microsoft Exchange' +
				(case when @UserName is not null and @UserName != '' THEN  ' почтового ящика пользователя ''' + @UserName +  '''' ELSE '' END)

			SET @Class = dbo.adfGetClassByName('Adf.Company')
		
			insert into [Company]
				([State], [FileAs], [LegalName], [Own], [Comments])
			values
				(1, @FileAs, @FileAs, 0, @Comments);

			if @@error != 0
			begin
				return 1;
			end

			set @ID = scope_identity()

			insert into [ExtendedProperties] 
				([ID], [Class], [ExtendedProperties])
			values
				(@ID, @Class, NULL);	

			if @@error != 0
			begin
				return 1;
			end
		
			insert into [BusinessCard] 
				([ID], [Class], [State], [FileAs], [Flag])
			values 
				(@ID, @Class, 1, @FileAs, 0);
		
			if @@error != 0
			begin
				return 1;
			end
		
			insert into [UserContact] 
				([UserID], [BusinessCardClass], [BusinessCardID])
			values
				(@UserID, @Class, @ID)
	
			if @@error != 0
			begin
				return 1;
			end
		end
	end
	return 0;
end

go

grant execute on [exch].[CompanyGetOrCreate] to [projectmateservice];
go
