﻿if exists (select * from dbo.sysobjects where id = object_id(N'[exch].[UpdateEmail]') and objectproperty(id, N'IsProcedure') = 1)
begin
	print 'Dropping procedure UpdateEmail'
	drop procedure [exch].[UpdateEmail]
end
go

print 'Creating procedure UpdateEmail'
go

create procedure [exch].[UpdateEmail] @XContact xml, @Class TClass, @ID TIdentifier
as
begin
	set nocount on;

	update [dbo].[Email]
	set
		[Email] = [S].[Email]
	from
		[dbo].[Email] as [P] inner join (
		select
			@Class as [Class],
			@ID as [ID],
			T.C.value('(@TypeID)[1]', 'int') as [TypeID],
			T.C.value('(@Email)[1]', 'nvarchar(256)') as [Email]
		from
			@XContact.nodes('Contact/Email') as T(C)) as [S]
		on ([P].[BusinessCardClass] = [S].[Class] and [P].[BusinessCardID]=[S].[ID] and [P].[EmailTypeID] = [S].[TypeID])


	insert into [dbo].[Email]	
		([BusinessCardClass], [BusinessCardID], [EmailTypeID], [Email])
	select
		@Class,
		@ID,
		T.C.value('(@TypeID)[1]', 'int'),
		T.C.value('(@Email)[1]', 'nvarchar(256)')
	from
		@XContact.nodes('Contact/Email') as T(C)
	where
		T.C.value('(@TypeID)[1]', 'int') not in (select [EmailTypeID] from [Email] 
												 where [BusinessCardClass] = @Class 
												 and [BusinessCardID] = @ID);
	return 0;
end
GO


