IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5AddressAsEnString]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5AddressAsString'
		DROP FUNCTION [dbo].[fnPjm5AddressAsEnString]
	END

GO

PRINT 'Creating function fnPjm5AddressAsEnString'
GO
/******************************************************************************
**		File: 
**		Name: AddressAsString
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5AddressAsEnString
	(
	@Street				TName,
	@City				TCity,
	@Region				TName,
	@PostalCode			TPostalCode,
	@Country			TName
	)
RETURNS TName
AS
BEGIN
	DECLARE
		@result TName
	SET @result = ISNULL(@Country, '')
	IF @PostalCode IS NOT NULL
		SET @result = @PostalCode + ', ' + @result
	IF @Region IS NOT NULL
		SET @result = @Region + ', ' + @result
	IF @City IS NOT NULL
		SET @result = @City + ', ' + @result
	IF @Street IS NOT NULL
		SET @result = @Street + ', ' + @result

	RETURN @result
END
GO

GRANT EXEC ON fnPjm5AddressAsEnString TO PUBLIC
GO
