IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5GetPhoneList]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5GetPhoneList'
		DROP FUNCTION [dbo].[fnPjm5GetPhoneList]
	END

GO

PRINT 'Creating function fnPjm5GetPhoneList'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5GetTaskListByAssignment
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5GetPhoneList(@ID TIdentifier, @Class TClass)
RETURNS TName
AS
BEGIN
	
	DECLARE
		@PhoneTypeID int,
		@Phone		varchar(256),
		@Counter	int,
		@PhoneList	nvarchar(2048),
		@LastSymbol	char(8)		
			
	DECLARE my_cursor CURSOR READ_ONLY FAST_FORWARD LOCAL FOR
		SELECT
			[Phone].[PhoneTypeID],
			[Phone].[Phone],
			COUNT(*)
		FROM 
			[Phone] 				
			INNER JOIN	[BusinessCard]
				ON [Phone].[BusinessCardID] = [BusinessCard].[ID] AND
					[Phone].[BusinessCardClass] = [BusinessCard].[Class]
		WHERE
			[Phone].[BusinessCardID] = @ID AND
			[Phone].[BusinessCardClass] = @Class
		GROUP BY
			[Phone].[PhoneTypeID],
			[Phone].[Phone]
			
	OPEN my_cursor
	FETCH NEXT FROM my_cursor INTO @PhoneTypeID, @Phone, @Counter
	
	WHILE @@FETCH_STATUS = 0
	BEGIN
		IF @Counter > 0
		BEGIN
			IF @PhoneList IS NULL
				SET @PhoneList = CASE @PhoneTypeID
										WHEN 1 THEN N'.' + @Phone
										WHEN 2 THEN N'.' + @Phone
										WHEN 3 THEN N'.' + @Phone
										WHEN 4 THEN N'.' + @Phone
										WHEN 5 THEN N'.' + @Phone
										WHEN 6 THEN N'2.' + @Phone
										WHEN 7 THEN N'.' + @Phone
										WHEN 8 THEN N'..' + @Phone
										WHEN 9 THEN N'..' + @Phone
										WHEN 10 THEN N'..' + @Phone
										WHEN 11 THEN N'.' + @Phone										
									END	
			ELSE
				SET @PhoneList = CASE @PhoneTypeID
										WHEN 1 THEN @PhoneList + N'; ' + N'.' + @Phone
										WHEN 2 THEN @PhoneList + N'; ' + N'.' + @Phone
										WHEN 3 THEN @PhoneList + N'; ' + N'.' + @Phone
										WHEN 4 THEN @PhoneList + N'; ' + N'.' + @Phone
										WHEN 5 THEN @PhoneList + N'; ' + N'.' + @Phone
										WHEN 6 THEN @PhoneList + N'; ' + N'2.' + @Phone
										WHEN 7 THEN @PhoneList + N'; ' + N'.' + @Phone
										WHEN 8 THEN @PhoneList + N'; ' + N'..' + @Phone
										WHEN 9 THEN @PhoneList + N'; ' + N'..' + @Phone
										WHEN 10 THEN @PhoneList + N'; ' + N'..' + @Phone
										WHEN 11 THEN @PhoneList + N'; ' + N'.' + @Phone										
									END					
		END
		FETCH NEXT FROM my_cursor INTO @PhoneTypeID, @Phone, @Counter
	END
	IF @PhoneList IS NOT NULL
	BEGIN
		SET @PhoneList = RTRIM(@PhoneList)
		SET @LastSymbol = RIGHT(@PhoneList,1)
			IF @LastSymbol != '.'
			BEGIN
				SET @PhoneList = @PhoneList + N'.'
			END
	END
	CLOSE my_cursor
	DEALLOCATE my_cursor	
	RETURN(@PhoneList)
END
GO

GRANT EXEC ON fnPjm5GetPhoneList TO PUBLIC
GO
