﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].fnPjm6GetBudgetTotalDiscount') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetBudgetTotalDiscount'
		DROP FUNCTION [dbo].fnPjm6GetBudgetTotalDiscount
	END

GO

PRINT 'Creating function fnPjm6GetBudgetTotalDiscount'
GO
/******************************************************************************
**		File:	fnPjm6GetBudgetTotalDiscount.sql
**		Name: 	fnPjm6GetBudgetTotalDiscount
**		Desc:	returns formatted time interval
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**    	10.11.09		PAM		first version
*******************************************************************************/

CREATE FUNCTION fnPjm6GetBudgetTotalDiscount(
	@DiscountView		TBool,
	@DiscountPercent	TMoney,
	@DiscountTotal		TMoney,
	@Total				TMoney)
RETURNS TMoney
BEGIN
	IF (@DiscountTotal IS NULL AND @DiscountPercent IS  NULL)
		RETURN 0
	
	DECLARE
		@Discount			TMoney
		
	IF @DiscountView = 1
		IF @DiscountTotal < 0
			SET @Discount = (CASE WHEN @Total < ABS(@DiscountTotal) THEN -@Total ELSE @DiscountTotal END)
		ELSE
			SET @Discount = @DiscountTotal
	ELSE
		SET @Discount = @DiscountPercent * @Total
		
	RETURN @Discount
END
GO

GRANT EXEC ON fnPjm6GetBudgetTotalDiscount TO PUBLIC
GO