IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5CurrencyToString]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5CurrencyToString'
		DROP FUNCTION [dbo].[fnPjm5CurrencyToString]
	END

GO

PRINT 'Creating function fnPjm5CurrencyToString'
GO
/******************************************************************************
**		File: 
**		Name: MoneyToString
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5CurrencyToString(
	@Value		TMoney,
	@Currency	TCode
	)
RETURNS TName
AS
BEGIN
	DECLARE 
		@Result				TName,
		@IntValue			BIGINT,
		@Val				Tvariant,
		@NationalCurrency	TCode3
	
	SELECT @Val = [Value] FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Name] = 'NationalCurrency' AND
		[Group] = 'CommonBusiness'
	SET @NationalCurrency = CAST(@Val as nvarchar(3))

	SET @IntValue = (ROUND(ABS(@Value) + 0.5, 0) - 1)
		
	SELECT 
		@Result = CASE UPPER(@Currency)
			WHEN 'RUB' THEN 
				CASE 
					WHEN @NationalCurrency = 'BYR' THEN dbo.fnPjm5ThreeDigitName(@IntValue, ' ', '  ', ' ')
					ELSE dbo.fnPjm5ThreeDigitName(@IntValue, '', '', '')
				END
			WHEN 'USD' THEN dbo.fnPjm5ThreeDigitName(@IntValue, ' ', ' ', ' ')
			WHEN 'EUR' THEN dbo.fnPjm5ThreeDigitName(@IntValue, '', '', '')
			WHEN 'UAH' THEN dbo.fnPjm5ThreeDigitName(@IntValue, '', '', '')
			WHEN 'KZT' THEN dbo.fnPjm5ThreeDigitName(@IntValue, '', '', '')
			WHEN 'BYR' THEN dbo.fnPjm5ThreeDigitName(@IntValue, ' ', ' ', ' ')
			WHEN 'KGS' THEN dbo.fnPjm5ThreeDigitName(@IntValue, '', '', '')
			WHEN 'AZN' THEN dbo.fnPjm5ThreeDigitName(@IntValue, ' ', ' ', ' ')
			WHEN 'LVL' THEN dbo.fnPjm5ThreeDigitName(@IntValue, '', '', '')
			WHEN 'TMM' THEN dbo.fnPjm5ThreeDigitName(@IntValue, '', '', '')
			WHEN 'TMT' THEN dbo.fnPjm5ThreeDigitName(@IntValue, '', '', '')
			ELSE dbo.fnPjm5ThreeDigitName(@IntValue, @Currency, @Currency, @Currency)
		END
		
	RETURN LTRIM(RTRIM(@Result))
END
GO

GRANT EXEC ON fnPjm5CurrencyToString TO PUBLIC
GO
    