IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5GetEmployeeListProjectForDate]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5GetEmployeeListProjectForDate'
		DROP FUNCTION [dbo].[fnPjm5GetEmployeeListProjectForDate]
	END

GO

PRINT 'Creating function fnPjm5GetEmployeeListProjectForDate'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5GetTaskListByAssignment
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5GetEmployeeListProjectForDate(@ProjectID TIdentifier, @Date datetime, @DecimalSeparator varchar(1),@DivisionID TIdentifier,@DivisionSelector int)
RETURNS nvarchar(4000)
AS
BEGIN
	DECLARE @EmployeeName	nvarchar(4000),
			@tmpName		TName,
			@tmpStrTime		TName,
			@tmpPlanned		decimal(18,1)
			
	DECLARE employee CURSOR READ_ONLY FAST_FORWARD LOCAL FOR
	SELECT
		ISNULL([Employee].[Initials],[Employee].[FileAs]),
		SUM(ROUND((([BusyEntry].[Planned] - [BusyEntry].[Canceled]) / 60.0), 2))
	FROM 
		[Employee]
		INNER JOIN [BusyEntry]
			ON [BusyEntry].[EmployeeID] = [Employee].[ID]
		INNER JOIN [Task]
			ON [BusyEntry].[TaskID] = [Task].[ID]
		LEFT OUTER JOIN [Division] 
			ON [Employee].[DivisionID] = [Division].[ID]			
	WHERE
		[Employee].[State] = 1 AND
		(
			@DivisionSelector = 0 OR 
			(@DivisionSelector = 1 AND [Employee].[DivisionID] IS NULL) OR
			(@DivisionSelector = 2 AND ([Employee].[DivisionID] = @DivisionID OR (@DivisionID IS NULL AND [Employee].[DivisionID] IS NOT NULL)))
		)AND 
		[BusyEntry].[ProjectID] = @ProjectID AND 
		[BusyEntry].[Date] = @Date AND 
		([BusyEntry].[Planned] - [BusyEntry].[Canceled]) != 0.00 AND
		[Task].[State] in (2,5,8)
	GROUP BY 
		[Employee].[FileAs],
		[Employee].[Initials]
			
	OPEN employee
	FETCH NEXT FROM employee INTO @tmpName, @tmpPlanned
	WHILE @@FETCH_STATUS = 0
	BEGIN
		--------------
		SET @tmpStrTime = CAST(@tmpPlanned AS varchar(256))
		SET @tmpStrTime = LEFT(@tmpStrTime, LEN(@tmpStrTime) - 2) + @DecimalSeparator + RIGHT(@tmpStrTime, 1)
		SELECT @EmployeeName = ISNULL(@EmployeeName + ', ', '') + @tmpName + '(' + @tmpStrTime + ')'
		--------------
		FETCH NEXT FROM employee INTO @tmpName, @tmpPlanned
	END
	CLOSE employee
	DEALLOCATE employee
	RETURN(@EmployeeName)
END
GO

GRANT EXEC ON fnPjm5GetEmployeeListProjectForDate TO PUBLIC
GO
