IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5HasFinansDataAccess]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5HasFinansDataAccess'
		DROP FUNCTION [dbo].[fnPjm5HasFinansDataAccess]
	END

GO

PRINT 'Creating function fnPjm5HasFinansDataAccess'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5HasFinansDataAccess
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		01.04.13	SOV				 , -   . -
**		03.04.13	SOV				    . - 
**									     " "
**		09.09.13	SOV				,   . -    -  
*******************************************************************************/
CREATE FUNCTION fnPjm5HasFinansDataAccess(
	@ProjectID	TIdentifier,
	@EmployeeID TIdentifier,
	@Class		TClass,
	@Parameter	TVariant
	)
RETURNS TBool
AS
BEGIN
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance')) = 1 
		RETURN 1

	DECLARE @CurrentEmployeeID TIdentifier
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()

	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ViewFinance')) = 1 
	BEGIN
		IF EXISTS(SELECT * FROM [vwAssignment]  WHERE [ProjectID] = @ProjectID AND 	[EmployeeID] = @CurrentEmployeeID AND [State] = 1
			AND	[FinanceManagement] = 1)
			RETURN 1
	END
	
	DECLARE @IsFinanceManager TBool
	SET @IsFinanceManager = dbo.fnPjm7IsFinanceManager(@ProjectID, @CurrentEmployeeID)
	
	IF EXISTS (
		SELECT [ID] FROM [Project] 
		WHERE 
			[ID] = @ProjectID AND 
			([ProjectManagerEmployeeID] = @CurrentEmployeeID OR 
			@IsFinanceManager = 1)
			)
		RETURN 1

	DECLARE @IsManagerAssistant TBool
	SET @IsManagerAssistant = dbo.fnPjm7IsManagerAssistant(@ProjectID, @CurrentEmployeeID)

	IF @Class = dbo.adfGetClassByName('Pjm5.Expense')
	BEGIN
		IF @CurrentEmployeeID = @EmployeeID OR
			EXISTS(
				SELECT * FROM [vwAssignment] 
				WHERE 
					[ProjectID] = @ProjectID AND 
					[EmployeeID] = @CurrentEmployeeID AND 
					([Approver] = 1 OR [Administrator] = 1 OR 
					@IsManagerAssistant = 1) AND
					[State] = 1
					)
			RETURN 1
		IF CAST(@Parameter AS int) = dbo.adfGetCurrentUserID() -- CreatedBy
			RETURN 1
	END
	
	IF @Class = dbo.adfGetClassByName('Pjm5.TimeEntry')
	BEGIN
		IF @CurrentEmployeeID = @EmployeeID AND 
			CAST(@Parameter AS int) = 1 -- ShowRates
			RETURN 1
	END

	RETURN 0
END
GO
GRANT EXEC ON fnPjm5HasFinansDataAccess TO PUBLIC
GO
  