﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm7GetStringFormatedWithoutWhiteSpaces]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm7GetStringFormatedWithoutWhiteSpaces'
		DROP FUNCTION [dbo].[fnPjm7GetStringFormatedWithoutWhiteSpaces]
	END

GO

PRINT 'Creating function fnPjm7GetStringFormatedWithoutWhiteSpaces'
GO
/******************************************************************************
**		File: fnPjm7GetStringFormatedWithoutWhiteSpaces.sql
**		Name: fnPjm7GetStringFormatedWithoutWhiteSpaces
**		Desc: Функция удаляющая из строки все ковычки и множественные пробелы 
**				(необходима для приведения наименования компании к виду, по которому
**				можно производить поиск по наименованию)
**
**		This template can be customized:
**              
**		Return values: Отформатированная строка
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      @IntputString					@OutputString
**
**		Auth: Anton.Paramonov
**		Date: 19.10.2011 11:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm7GetStringFormatedWithoutWhiteSpaces(@IntputString TName)
RETURNS TName
AS
BEGIN
	Declare @OutputString TName

	SET @OutputString = @IntputString
	--удаление кавычек из строки
	SET @OutputString = REPLACE(@OutputString, '"', '')
	SET @OutputString = REPLACE(@OutputString, '''', '')
	--удаление пробелов в начале и конце строки
	SET @OutputString = LTRIM(@OutputString)
	SET @OutputString = RTRIM(@OutputString)
	--удаление множественных пробелов (максимум 65535 пробелов)
	SET @OutputString = REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(@OutputString,
							'                                ',' '),
							'                ', ' '),
							'        ', ' '),
							'    ', ' '),
							'  ', ' '), 
							'  ', ' ')
	
	RETURN(@OutputString)
END
GO