IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnReportGetFinDocumentCurrency]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnReportGetFinDocumentCurrency'
		DROP FUNCTION [dbo].[fnReportGetFinDocumentCurrency]
	END
GO

PRINT 'Creating function fnReportGetFinDocumentCurrency'
GO

/******************************************************************************
**		File: fnReportGetFinDocumentCurrency.sql
**		Name: fnReportGetFinDocumentCurrency
**
**              
**		Return values:
**
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------

**		
**		Auth: MAN
**		Date: 26/08/2010 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		21.09.2010	MAN				First Version
*******************************************************************************/
CREATE FUNCTION dbo.fnReportGetFinDocumentCurrency
(
	@CurrencyCode TCode3,
	@DocumentID	   TIdentifier,
	@DocumentClass TClass,
	@ToCurrencyCode TCode3
)
RETURNS TMoney
AS
BEGIN 
	DECLARE
		@Result TMoney
		IF(@CurrencyCode <> @ToCurrencyCode)
		BEGIN

				SELECT TOP 1
					@Result = 	1/[Invoice].[BaseCurrencyRate]
				FROM
					[Invoice]
				WHERE
					[Invoice].[ID] IN
					(
						SELECT
							[InvoiceLine].[InvoiceID] 
						FROM
							[InvoiceLine]
						WHERE
							[Invoice].[ID] = [InvoiceLine].[InvoiceID]
							AND
							[InvoiceLine].[DocumentID] = @DocumentID
							AND
							[InvoiceLine].[DocumentClass] = @DocumentClass
					)
		IF @Result IS NULL
				SELECT TOP 1
					@Result =	1/[Statement].[BaseCurrencyRate]
				FROM
					[Statement]
				WHERE
					[Statement].[ID] IN
					(
						SELECT
							[StatementLine].[StatementID] 
						FROM
							[StatementLine]
						WHERE
							[StatementLine].[StatementID] = [Statement].[ID]
							AND
							[StatementLine].[DocumentID] = @DocumentID
							AND
							[StatementLine].[DocumentClass] = @DocumentClass
					)
		IF @Result IS NULL

				SELECT TOP 1
					@Result = dbo.pjm6fnCurrencyGetRate(@CurrencyCode,[Calculation].[Date],@ToCurrencyCode)
				FROM
					[Calculation]
				WHERE
					[Calculation].[ID] IN
					(
						SELECT
							[CalculationLine].[CalculationID] 
						FROM
							[CalculationLine]
						WHERE
							[CalculationLine].[CalculationID] = [Calculation].[ID]
							AND
							[CalculationLine].[DocumentID] = @DocumentID
							AND
							[CalculationLine].[DocumentClass] = @DocumentClass
					)
		END
	IF @Result IS NULL 
	SET @Result = 1	
RETURN @Result	
END	
GO
