IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnReportGetPeriodName]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnReportGetPeriodName'
		DROP FUNCTION [dbo].[fnReportGetPeriodName]
	END

GO

PRINT 'Creating function fnReportGetPeriodName'
GO
/******************************************************************************
**		File: 
**		Name: fnReport7GetPeriodName
**		Desc:    	
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Sergey Pelevin
**		Date: 18.04.14
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnReportGetPeriodName(@PeriodStart TDateTime, @PeriodEnd TDateTime, @LangCode TCode3, @Short bit, @WithYear bit)
RETURNS varchar(50)
AS
BEGIN
	DECLARE 
		@res varchar(50),		
		@StartMonthName varchar(16),
		@StartMonthNumber int,
		@StartYear varchar(16)
		
	IF(@LangCode IS NULL OR @LangCode NOT IN ('en', 'ru'))
		SET @LangCode = 'ru'	-- set to russian language as default
	
	SET @StartYear = DATENAME(year,@PeriodStart)
	SET @StartMonthNumber = DATEPART(month,@PeriodStart)
	SET @StartMonthName = [dbo].[fnReportGetMonthNameByNumber](@StartMonthNumber,@LangCode,@Short)

		
	IF @PeriodEnd IS NULL
	BEGIN
		IF @WithYear = 1	
			SET @res = @StartMonthName + ' '  + @StartYear
		ELSE
			SET @res = @StartMonthName
	END
	ELSE
	BEGIN
		DECLARE
			@EndMonthName varchar(16),
			@EndMonthNumber int,
			@EndYear varchar(16)
		
		SET @EndYear = DATENAME(year,@PeriodEnd)
		SET @EndMonthNumber = DATEPART(month,@PeriodEnd)
		SET @EndMonthName = [dbo].[fnReportGetMonthNameByNumber](@EndMonthNumber,@LangCode,@Short)

		
		SET @res = @StartMonthName + ' ' + @StartYear + ' - ' + @EndMonthName + ' ' + @EndYear			
	END


	RETURN @res
END
GO

GRANT EXEC ON fnReportGetPeriodName TO PUBLIC
GO
 