IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetCreateRecurrence]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetCreateRecurrence'
		DROP PROCEDURE [dbo].[pjm6BudgetCreateRecurrence]
	END
GO

PRINT 'Creating procedure pjm6BudgetCreateRecurrence'
GO

/******************************************************************************
**		File: pjm6BudgetCreateRecurrence.sql
**		Name: pjm6BudgetCreateRecurrence
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 24/09/2010 14:20:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		02.12.13	SAP				      
**									  
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetCreateRecurrence]
@SourceBudgetID	TIdentifier
AS
	DECLARE
		@State									TState,
		@SourceBudgetClass						TClass,
		@SourceBudgetDocumentID					TIdentifier,
		@SourceBudgetStartDate					TDate,
		@SourceBudgetEndDate					TDate,
		@SourceBudgetRecurrenceID				TIdentifier,
		@SourceBudgetCalculateBudgetPatternID	Tidentifier,
		@rv					int
	
	SELECT
		@SourceBudgetClass = [Class],
		@SourceBudgetStartDate = [StartDate],
		@SourceBudgetEndDate	= [EndDate],
		@SourceBudgetCalculateBudgetPatternID = [CalculateBudgetPatternID],
		@SourceBudgetDocumentID = [DocumentID]
	FROM
		[Budget]
	WHERE
		[ID] = @SourceBudgetID
		
	SELECT
		@SourceBudgetRecurrenceID = [RecurrencePatternID]
	FROM
		[Document]
	WHERE
		[Class] = @SourceBudgetClass AND [ID] = @SourceBudgetID
	
	IF @SourceBudgetRecurrenceID IS NULL
		RETURN 0

	--   
	DECLARE -- RECURRENCE
		@RecurrenceType TIdentifier, 
		@Occurrences TCount
		
	SELECT
		@RecurrenceType = [RecurrenceType], 
		@Occurrences = [Occurrences]
	FROM
		[RecurrencePattern]
	WHERE
		[ID] = @SourceBudgetRecurrenceID
		
	IF @Occurrences IS NOT NULL AND @Occurrences = 0
		RETURN 0

	--  
	DECLARE 
		@ReceiveBudgetID			TIdentifier,
		@ReceiveBudgetStartDate		TDatetime,
		@ReceiveBudgetEndDate		TDatetime,
		@CurrentDate				TDatetime

	--SET @CurrentDate = GETDATE()
	--SET @ReceiveBudgetStartDate = CAST(CONVERT(varchar(8), DATEADD(DAY, 1, @SourceBudgetEndDate), 112) AS DATETIME)
	--SET @ReceiveBudgetEndDate = DATEADD(month, DATEDIFF(month, @SourceBudgetStartDate, @ReceiveBudgetStartDate), @SourceBudgetEndDate)
	
	SET @CurrentDate = GETDATE()
	SET @ReceiveBudgetStartDate = CAST(CONVERT(varchar(8), DATEADD(DAY, 1, @SourceBudgetEndDate), 112) AS DATETIME)
	SET @ReceiveBudgetEndDate = DATEADD(DAY, -1, DATEADD(month, DATEDIFF(month, @SourceBudgetStartDate, @ReceiveBudgetStartDate), @ReceiveBudgetStartDate))
	
	IF EXISTS(SELECT *FROM [Budget] WHERE [DocumentID] = @SourceBudgetDocumentID AND ((@ReceiveBudgetStartDate Between [Budget].[StartDate] AND [Budget].[EndDate])
		OR (@ReceiveBudgetEndDate Between [Budget].[StartDate] AND [Budget].[EndDate]) OR 
		([Budget].[StartDate] Between @ReceiveBudgetStartDate AND @ReceiveBudgetEndDate)
		OR ([Budget].[EndDate] Between @ReceiveBudgetStartDate AND @ReceiveBudgetEndDate)))
		RETURN 0

	SET @State = dbo.adfwfGetInitialState('8E95426E-83B7-4486-8EAD-0191CB63891A')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	BEGIN TRANSACTION

	INSERT INTO [Budget]
		([Flag],[State], [FileAs], [CurrencyCode], [DocumentClass], [DocumentID], [BudgetTypeID], [StartDate],
		[EndDate], [WorkBudgetBottom], [WorkBudgetHigh], [WorkBudgetBottomEqualsPlan], [WorkBudgetHighEqualsPlan],
		[ExpenseBudgetBottom], [ExpenseBudgetHigh], [ExpenseBudgetBottomEqualsPlan], [ExpenseBudgetHighEqualsPlan],
		[SupervisorEmployeeID], [VATRate], [VATIsIncluded],
		[DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [DiscountViewExpense], [DiscountPercentExpense],
		[DiscountTotalExpense], [PlanningActivityForWork], [PlanningEmployeeForWork], [PlanningQualificationForWork],
		[PlanningRateForWork], [PlanningDateForWork], [PlanningExpenseTypeForExpense], [PlanningEmployeeForExpense], [PlanningPriceForExpense],
		[PlanningDateForExpense], [TimeEntryAccount],[TimeEntrySendingForApprovalAccount], [TimeEntryActualTotalsAccount], [PlanProfitability], [ExpenseAccount],
		[ExpenseSendingForApprovalAccount], [PlanPurchases], [UseWorkPlanning], [UseExpensePlanning], [Comments])
	SELECT
		0,
		@State,
		[FileAs],
		[CurrencyCode],
		[DocumentClass],
		[DocumentID],
		[BudgetTypeID],
		@ReceiveBudgetStartDate,
		@ReceiveBudgetEndDate,
		[WorkBudgetBottom],
		[WorkBudgetHigh],
		[WorkBudgetBottomEqualsPlan],
		[WorkBudgetHighEqualsPlan],
		[ExpenseBudgetBottom],
		[ExpenseBudgetHigh],
		[ExpenseBudgetBottomEqualsPlan],
		[ExpenseBudgetHighEqualsPlan],
		[SupervisorEmployeeID],
		[VATRate],
		[VATIsIncluded],
		[DiscountViewWork],
		[DiscountPercentWork],
		[DiscountTotalWork],
		[DiscountViewExpense],
		[DiscountPercentExpense],
		[DiscountTotalExpense],
		[PlanningActivityForWork],
		[PlanningEmployeeForWork],
		[PlanningQualificationForWork],
		[PlanningRateForWork],
		[PlanningDateForWork],
		[PlanningExpenseTypeForExpense],
		[PlanningEmployeeForExpense],
		[PlanningPriceForExpense],
		[PlanningDateForExpense],
		[TimeEntryAccount],
		[TimeEntrySendingForApprovalAccount],
		[TimeEntryActualTotalsAccount],
		[PlanProfitability],
		[ExpenseAccount],
		[ExpenseSendingForApprovalAccount],
		[PlanPurchases],
		[UseWorkPlanning],
		[UseExpensePlanning],
		[Comments]
	FROM
		[Budget]
	WHERE
		[Budget].[ID] = @SourceBudgetID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	SET @ReceiveBudgetID = SCOPE_IDENTITY()
	
		--   
	IF @SourceBudgetCalculateBudgetPatternID IS NOT NULL
	BEGIN
		DECLARE
			@CRStartDate		TDate,
			@CREndDate			TDate,
			@CROccurrences		TCount,
			@CRRecurrenceType	TIdentifier,
			@CRInterval			TCount,
			@CRDayOfWeekMask	TIdentifier,
			@CRInstance			TIdentifier,
			@CRMonthOfYear		TCount,
			@CRDayOfMonth		TCount,
			@CRDayTransferRule	TCount
		
		SELECT
			@CRStartDate		= [StartDate],
			@CREndDate			= [EndDate],
			@CROccurrences		= [Occurrences],
			@CRRecurrenceType	= [RecurrenceType],
			@CRInterval			= [Interval],
			@CRDayOfWeekMask	= [DayOfWeekMask],
			@CRInstance			= [Instance],
			@CRMonthOfYear		= [MonthOfYear],
			@CRDayOfMonth		= [DayOfMonth],
			@CRDayTransferRule	= [DayTransferRule]
		FROM 
			[AssistantRecurrencePattern]
		WHERE
			[AssistantRecurrencePattern].[ID] = @SourceBudgetCalculateBudgetPatternID

		EXEC @rv = pjm6BudgetCalcRecurrenceInsert @ReceiveBudgetID, 
											@CRStartDate,		
											@CREndDate,		
											@CROccurrences,		
											@CRRecurrenceType,	
											@CRInterval,			
											@CRDayOfWeekMask,	
											@CRInstance,			
											@CRMonthOfYear,		
											@CRDayOfMonth,		
											@CRDayTransferRule
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	--   
	DECLARE @CurrenctDate TDate

	SET @CurrenctDate = GETDATE()
	EXEC @rv = pjm6BudgetNextCalcDateGet @ReceiveBudgetID, @CurrenctDate
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END


	-- 
	DECLARE
		@NextCalculationDate TDate,
		@WorkTimeStart TCount,
		@value TVariant,
		@ReminderState int, 
		@ReminderInterval TTimeSpan,
		@CurentUserID TIdentifier

	SET @CurentUserID = dbo.adfGetCurrentUserID()

	SELECT
		@NextCalculationDate = [NextCalculationDate]
	FROM
		[Budget]
	WHERE
		[ID] = @ReceiveBudgetID

	SELECT
		@ReminderState = [UserReminder].[State]
	FROM
		[Budget]
		LEFT OUTER JOIN [Reminder]
			ON ([Reminder].[DocumentClass] = [Budget].[Class] AND
				[Reminder].[DocumentID] = [Budget].[ID] AND
				[Reminder].[Subtype] = 'BC')
		LEFT OUTER JOIN [UserReminder]
			ON ([Reminder].[ID] = [UserReminder].[ReminderID] AND
				[UserReminder].[UserID] = @CurentUserID)
	WHERE
		[Budget].[ID] = @SourceBudgetID

	IF @ReminderState IS NULL
		SET @ReminderState = 0

	EXEC adfParameterGet 'WorkTimeStart1', 'Pjm5', @value OUTPUT	
	SET  @WorkTimeStart = CAST(@value AS int)

	SET @ReminderInterval = -@WorkTimeStart
	EXEC @rv = pjm7BudgetReminderCreate @ReceiveBudgetID,
		@NextCalculationDate, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END

	--  
	EXEC @rv = pjm6BudgetSystemGroupsInsert @ReceiveBudgetID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END

	--    
	EXEC @rv = pjm6BudgetLineAndGroupCopy @SourceBudgetID, @ReceiveBudgetID, @SourceBudgetDocumentID, 0
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	--    
	EXEC @rv = adfDocumentCategoryCopy @SourceBudgetClass, @SourceBudgetID, @ReceiveBudgetID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END

	EXEC @rv = adfDocumentContactCopy @SourceBudgetClass, @SourceBudgetID, @ReceiveBudgetID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	EXEC @rv = pjm6BudgetChangeState @ReceiveBudgetID, 2
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	--     
	UPDATE
		[Document]
	SET
		[RecurrencePatternID] = @SourceBudgetRecurrenceID
	WHERE
		[Class] = @SourceBudgetClass AND [ID] = @ReceiveBudgetID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	--DECLARE @Occurrences TCount
	SELECT @Occurrences = [Occurrences] FROM [RecurrencePattern] WHERE [ID] = @SourceBudgetRecurrenceID
	IF ISNULL(@Occurrences, 0) > 0
	BEGIN
		UPDATE
			[RecurrencePattern]
		SET
			[Occurrences] = @Occurrences - 1
		WHERE
			[ID] = @SourceBudgetRecurrenceID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	COMMIT TRANSACTION
	
	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetCreateRecurrence TO PUBLIC
GO
