IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineGroupDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineGroupDelete'
		DROP PROCEDURE [dbo].[pjm6BudgetLineGroupDelete]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineGroupDelete'
GO

/******************************************************************************
**		File: pjm6BudgetLineGroupDelete.sql
**		Name: pjm6BudgetLineGroupDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 10/10/2010 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetLineGroupDelete
	@ID	TIdentifier
	
AS
	SET NOCOUNT ON
	
	IF((SELECT [State] FROM [BudgetLineGroup] WHERE [ID] =  @ID) IN (2))
	BEGIN
		RAISERROR('#systemgroup', 18, -1)
		RETURN 1
	END

	IF dbo.fnPjm6CanEditBudget((SELECT [BudgetID] FROM [BudgetLineGroup] WHERE [ID] =  @ID)) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	DECLARE
		@Order	TCount
	SET @Order = (SELECT [Order] FROM [BudgetLineGroup] WHERE [ID] = @ID)
	BEGIN TRANSACTION

	DELETE FROM [BudgetLineGroup] WHERE [BudgetLineGroup].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetLineGroupDelete TO PUBLIC
GO