﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetTemplateChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetTemplateChangeState'
		DROP PROCEDURE [dbo].[pjm6BudgetTemplateChangeState]
	END
GO

PRINT 'Creating procedure pjm6BudgetTemplateChangeState'
GO

/******************************************************************************
**		File: pjm6BudgetTemplateChangeState.sql
**		Name: pjm6BudgetTemplateChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 09/12/2010 16:15:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetTemplateChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass,
			@result INT
	
	SET NOCOUNT ON
	
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageBudgetTemplates')) != 1 
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END		

	SELECT
		@Class = [Budget].[Class],
		@FromState = [Budget].[State]
	FROM
		[Budget]
	WHERE
		[Budget].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	BEGIN TRANSACTION
	
	
	UPDATE
		[Budget]
	SET
		[Budget].[State] = @ToState,
		[Budget].[Modified] = DEFAULT,
		[Budget].[ModifiedBy] = DEFAULT
	WHERE
		[Budget].[ID] = @ID
	AND
		[Budget].[State] = @FromState

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	UPDATE
		[Document]
	SET
		[Document].[State] = @ToState,
		[Document].[Modified] = DEFAULT,
		[Document].[ModifiedBy] = DEFAULT
	WHERE
		[Document].[Class] = dbo.adfGetClassByName('Pjm6.BudgetTemplate') AND
		[Document].[ID] = @ID
	AND
		[Document].[State] = @FromState

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetTemplateChangeState TO PUBLIC
GO
 