﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetTemplateCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetTemplateCreate'
		DROP PROCEDURE [dbo].[pjm6BudgetTemplateCreate]
	END
GO

PRINT 'Creating procedure pjm6BudgetTemplateCreate'
GO

/******************************************************************************
**		File: pjm6BudgetTemplateCreate.sql
**		Name: pjm6BudgetTemplateCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 09/12/2010 16:01:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		28.02.13	MAB				Отказ от OPENXML
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetTemplateCreate]
	@Xml	XML
AS
	DECLARE
		@ID							TIdentifier,
		@State						TState,
		@FileAs						TName,
		@BudgetTypeID				TIdentifier,
		@UseWorkPlanning			TBool,
		@UseExpensePlanning			TBool,
		@CurrencyCode				TCode3,
		@VATIsIncluded				TBool,
		@VATRate					TPercent,
		@CalculateBudgetPatternID	TIdentifier,
		@SupervisorEmployeeID		TIdentifier,
		@Comments					TNotes,
		@value						TVariant,
		@PlanProfitability			TPercent

	SET NOCOUNT ON
	
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageBudgetTemplates')) != 1 
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END	

	DECLARE @TemplateClass TClass,
			@BudgetClass TClass
	SET @TemplateClass =  dbo.adfGetClassByName('Pjm6.BudgetTemplate')
	SET @BudgetClass = dbo.adfGetClassByName('Pjm6.Budget')
		
	SET @State = dbo.adfwfGetInitialState('b2b821f5-dc00-4f6c-a446-1fcfa8aa71a1')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	EXEC adfParameterGet @Name='VATRate', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @VATRate = CAST(@value as decimal(18,4))

	EXEC adfParameterGet @Name='PlanProfitability', @Group='Pjm7', @Value = @value OUTPUT
	SET @PlanProfitability = CAST(@value as decimal(18,4))

	SELECT
		@ID							= @XML.value('(/pjm6BudgetTemplateGet/BudgetTemplate/ID)[1]','int'),
		@FileAs						= @XML.value('(/pjm6BudgetTemplateGet/BudgetTemplate/FileAs)[1]','nvarchar(256)'),
		@BudgetTypeID				= @XML.value('(/pjm6BudgetTemplateGet/BudgetTemplate/BudgetTypeID)[1]','int'),
		@UseWorkPlanning			= @XML.value('(/pjm6BudgetTemplateGet/BudgetTemplate/UseWorkPlanning)[1]','bit'),
		@UseExpensePlanning			= @XML.value('(/pjm6BudgetTemplateGet/BudgetTemplate/UseExpensePlanning)[1]','bit'),
		@CurrencyCode				= @XML.value('(/pjm6BudgetTemplateGet/BudgetTemplate/CurrencyCode)[1]','char(3)'),
		@VATIsIncluded				= @XML.value('(/pjm6BudgetTemplateGet/BudgetTemplate/VATIsIncluded)[1]','bit'),
		@CalculateBudgetPatternID	= @XML.value('(/pjm6BudgetTemplateGet/BudgetTemplate/CalculateBudgetPatternID)[1]','int'),
		@SupervisorEmployeeID		= @XML.value('(/pjm6BudgetTemplateGet/BudgetTemplate/SupervisorEmployeeID)[1]','int'),
		@Comments					= @XML.value('(/pjm6BudgetTemplateGet/BudgetTemplate/Comments)[1]','nvarchar(max)')
	
	IF @UseWorkPlanning = 0 AND @UseExpensePlanning = 0 
	BEGIN
		RAISERROR('#BudgetMustHaveItemForPlanning', 18, -1)
		RETURN 1
	END
	BEGIN TRANSACTION

	INSERT INTO [Budget]
		([State], [Flag], [FileAs], [CurrencyCode], [BudgetTypeID], [UseWorkPlanning], [UseExpensePlanning],
		[WorkBudgetBottom], [WorkBudgetHigh], [WorkBudgetBottomEqualsPlan], [WorkBudgetHighEqualsPlan],
		[ExpenseBudgetBottom], [ExpenseBudgetHigh], [ExpenseBudgetBottomEqualsPlan], [ExpenseBudgetHighEqualsPlan],
		[VATRate], [VATIsIncluded], [CalculateBudgetPatternID],
		[DiscountViewWork], [DiscountPercentWork], [DiscountViewExpense], [DiscountPercentExpense], 
		[PlanningActivityForWork], [PlanningEmployeeForWork], [PlanningQualificationForWork], [PlanningRateForWork],
		[PlanningExpenseTypeForExpense], [PlanningEmployeeForExpense], [PlanningPriceForExpense],
		[PlanningDateForWork], [PlanningDateForExpense], [TimeEntryAccount], [ExpenseAccount],
		[TimeEntrySendingForApprovalAccount], [PlanProfitability], [ExpenseSendingForApprovalAccount],
		[Comments], [SupervisorEmployeeID]
		)
	VALUES
		(@State, 0, @FileAs, @CurrencyCode, @BudgetTypeID, @UseWorkPlanning, @UseExpensePlanning,
		 0,0,1,1,
		 0,0,1,1, 
		 @VATRate, @VATIsIncluded, @CalculateBudgetPatternID,
		 0, NULL, 0, NULL,
		 0, 0, 0, 1, 
		 1, 0, 1,
		 0, 0, 0, 1,
		 1, @PlanProfitability, 1,
		 @Comments, @SupervisorEmployeeID
		)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	INSERT INTO [Document]
		([Class], [ID], [State], [Flag], [FileAs], [Created], [CreatedBy],
		 [Modified], [ModifiedBy], [Timestamp])
	SELECT
		@TemplateClass,
		[ID],
		[State],
		[Flag],
		[FileAs],
		[Created],
		[CreatedBy],
		[Modified],
		[ModifiedBy],
		[Timestamp]
	FROM
		[Document]
	WHERE
		([ID] = @ID) AND ([Class] = @BudgetClass)

	COMMIT TRANSACTION

	EXEC pjm6BudgetTemplateGet @ID

	RETURN 0
GO

GRANT EXECUTE ON [pjm6BudgetTemplateCreate] TO PUBLIC
GO  