IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetsGetForCalculation]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetsGetForCalculation'
		DROP PROCEDURE [dbo].[pjm6BudgetsGetForCalculation]
	END
GO

PRINT 'Creating procedure pjm6BudgetsGetForCalculation'
GO

/******************************************************************************
**		File: BudgetsGetForCalculation.sql
**		Name: pjm6BudgetsGetForCalculation
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: anton.paramonov
**		Date: 31.03.2011
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/

CREATE PROCEDURE [pjm6BudgetsGetForCalculation]
	@BudgetsXML XML
	
AS
	SET NOCOUNT ON
	
	DECLARE @budgets TABLE
	(
		[ID] int
	)
		
	INSERT INTO @budgets (ID)
	SELECT
		Budgets.BudgetID.value('ID[1]','int')
	FROM
		@BudgetsXML.nodes('/Budgets/Budget') AS Budgets(BudgetID)

	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()
	
	SELECT
		[Budget].[ID],
		CASE @Lang
			WHEN 'en' THEN 'Budget for project ''' + [Project].[Number] + '''' ELSE
			'   ''' + [Project].[Number] + '''' END as [FileAs],
		1 AS [SubBudget]
	FROM
		[Budget]
		INNER JOIN @budgets AS Budgets
			ON [Budget].[ID] = Budgets.ID
		LEFT OUTER JOIN [Project]
			ON [Project].[ID] = [Budget].[DocumentID] AND [Project].[Class] = [Budget].[DocumentClass]
	WHERE
		[Budget].[State] = 2 AND
		(dbo.fnPjm6CanEditBudget([Budget].[ID]) = 1 OR dbo.fnPjm6CanViewBudget([Budget].[ID]) = 1)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm6BudgetsGetForCalculation] TO PUBLIC
GO