IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CaseBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CaseBrowse'
		DROP PROCEDURE [dbo].[pjm5CaseBrowse]
	END
GO

PRINT 'Creating procedure pjm5CaseBrowse'
GO

/******************************************************************************
**		File: pjm5CaseBrowse.sql
**		Name: pjm5CaseBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5CaseBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	DECLARE
		@internal TName,
		@incoming TName,
		@outgoing TName
	IF dbo.adfGetLanguage() != 'ru'
	BEGIN
		SET @internal = 'Internal'
		SET @incoming = 'Incoming'
		SET @outgoing = 'Outgoing'
	END
	ELSE
	BEGIN
		SET @internal = ''
		SET @incoming = ''
		SET @outgoing = ''
	END

	SELECT
		[Case].[Class],
		[Case].[ID],
		[Case].[State],
		[Case].[Flag],
		[Case].[Code],
		[Case].[FileAs],
		[Case].[CompanyID],
		[Case].[EmployeeID],
		[Case].[StartDate],
		[Case].[EndDate],
		[Case].[NumberTemplate],
		[Case].[CurrentNumber],
		[Case].[Increment],
		[Case].[AllowInternal],
		[Case].[AllowIncoming],
		[Case].[AllowOutgoing],
		CASE
			WHEN [Case].[AllowInternal] = 1 THEN @internal
			WHEN [Case].[AllowIncoming] = 1 THEN @incoming
			WHEN [Case].[AllowOutgoing] = 1 THEN @outgoing
			ELSE NULL
		END AS [DocumentClass],
		[Case].[AllowFolder],
		[Case].[Comments],
		[Case].[Created],
		[Case].[CreatedBy],
		[Case].[Modified],
		[Case].[ModifiedBy],
		[Case].[Timestamp]
	FROM
		[Case]
	WHERE
		(
			(@StateSelector = 0) OR 
			(@StateSelector = 1 AND [Case].[State] IN (1, 100)) OR
			(@StateSelector = 2 AND [Case].[State] = 2) OR
			(@StateSelector = 3 AND [Case].[State] = 4)
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5CaseBrowse] TO PUBLIC
GO
