 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CreditMemoCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CreditMemoCreate'
		DROP PROCEDURE [dbo].[pjm5CreditMemoCreate]
	END
GO

PRINT 'Creating procedure pjm5CreditMemoCreate'
GO

/******************************************************************************
**		File: pjm5CreditMemoCreate.sql
**		Name: pjm5CreditMemoCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		27.03.13	SAP				  OPENXML	
*******************************************************************************/
CREATE PROCEDURE [pjm5CreditMemoCreate]
	@Xml XML
AS
	DECLARE 
		@State TState,
		@ID TIdentifier,
		@FileAs TName,
		@Date TDate,
		@Number TCode,
		@VAT TMoney,
		@PaymentTypeID TIdentifier,
		@PayeeCompanyID TIdentifier,
		@PayeeBankAccountID TIdentifier,
		@PayerCompanyID TIdentifier,
		@ProjectID TIdentifier,
		@Value TMoney,
		@CurrencyCode TCode3,
		@ProjectCurrencyCode TCode3,
		@BaseCurrencyRate TMoney,
		@CurrencyRate TMoney,
		@Reason TName,
		@Payer TName,
		@Comments TNotes,		
		@val TVariant,
		@TotalPC TMoney,
		@TotalWithVATPC TMoney,
		@TotalBC TMoney,
		@TotalWithVATBC TMoney
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('cac22366-ee83-4e23-9c88-8ee437b068ca')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SELECT 
		@Date = CONVERT(datetime, T.c.value('Date[1]','nvarchar(19)')),
		@FileAs = T.c.value('FileAs[1]','nvarchar(512)'),
		@Number = T.c.value('Number[1]','varchar(32)'),
		@PaymentTypeID = T.c.value('PaymentTypeID[1]','int'),
		@CurrencyCode = ISNULL([BankAccount].[CurrencyCode], T.c.value('CurrencyCode[1]','char(3)')),
		@ProjectCurrencyCode = [Project].[CurrencyCode],
		@PayeeCompanyID = T.c.value('SupplierCompanyID[1]','int'),
		@PayeeBankAccountID = T.c.value('PayeeBankAccountID[1]','int'),
		@PayerCompanyID = T.c.value('CustomerCompanyID[1]','int'),
		@ProjectID = T.c.value('ProjectID[1]','int'),
		@Value = T.c.value('Value[1]','money'),
		@VAT = T.c.value('VAT[1]','money'),
		@CurrencyRate = T.c.value('CurrencyRate[1]','money'),
		@BaseCurrencyRate = T.c.value('BaseCurrencyRate[1]','money'),
		@Comments = T.c.value('Comments[1]','nvarchar(max)'),
		@Reason = T.c.value('Reason[1]','nvarchar(256)'),
		@Payer = T.c.value('Payer[1]','nvarchar(256)')
	FROM
		@Xml.nodes('/pjm5CreditMemoGet/CreditMemo') AS T(c)		
		LEFT JOIN [BankAccount]
			ON [BankAccount].[ID] = T.c.value('PayeeBankAccountID[1]','int')
		LEFT JOIN [Project]
			ON [Project].[ID] = T.c.value('ProjectID[1]','int')
	
	DECLARE 
		@BaseCurrencyCode TCode3,
		@NationalCurrency TCode3
	EXEC adfParameterGet @Name='BaseCurrency', @Group='CommonBusiness', @Value = @val OUTPUT
	SET @BaseCurrencyCode = CAST(@val as varchar(3))

	EXEC adfParameterGet 'NationalCurrency', 'CommonBusiness', @val OUTPUT	
	SET @NationalCurrency = CAST(@val AS varchar(8))
	
	IF @BaseCurrencyCode = @CurrencyCode
	BEGIN
		SET @BaseCurrencyRate = 1.0
	END
	
	IF @ProjectCurrencyCode = @CurrencyCode
	BEGIN
		SET @CurrencyRate = 1.0
	END
		
	IF @BaseCurrencyRate IS NULL
	BEGIN
		SELECT 
			@BaseCurrencyRate = [Rate]
		FROM
			[CurrencyRate]
		WHERE
			[FromCurrencyCode] = @BaseCurrencyCode AND
			[ToCurrencyCode] = @CurrencyCode AND
			(@Date BETWEEN [ValidFrom] AND [ValidTo])
	END
	
	SET	@TotalPC = ROUND(CASE 
						WHEN @CurrencyCode = @NationalCurrency THEN (@Value - @VAT) / @CurrencyRate
						ELSE (@Value - @VAT) * @CurrencyRate
					END, 2)
	SET	@TotalWithVATPC = ROUND(CASE 
						WHEN @CurrencyCode = @NationalCurrency
							THEN @Value / @CurrencyRate
						ELSE @Value * @CurrencyRate
					END, 2)

	SET	@TotalBC = ROUND(CASE 
						WHEN @CurrencyCode = @NationalCurrency
							THEN (@Value - @VAT) / @BaseCurrencyRate
						ELSE (@Value - @VAT) * @BaseCurrencyRate
					END, 2)
	SET	@TotalWithVATBC= ROUND(CASE 
						WHEN @CurrencyCode = @NationalCurrency
							THEN @Value / @BaseCurrencyRate
						ELSE @Value * @BaseCurrencyRate
					END, 2)

	BEGIN TRANSACTION
	
	INSERT INTO [CreditMemo]
		([Flag], [State],
		 [FileAs], [Date], [Number],
		 [VAT], [PaymentTypeID], [PayeeCompanyID],
		 [PayeeBankAccountID], [PayerCompanyID], [ProjectID],
		 [Value], [CurrencyCode], [CurrencyRate], [BaseCurrencyRate], 
		 [Comments], [Reason], [Payer],
		 [TotalPC], [TotalWithVATPC], [TotalBC], [TotalWithVATBC])
	VALUES
		(0, @State,
		 @FileAs, @Date, @Number,
		 @VAT, @PaymentTypeID, @PayeeCompanyID,
		 @PayeeBankAccountID, @PayerCompanyID, @ProjectID,
		 @Value, @CurrencyCode, @CurrencyRate, @BaseCurrencyRate, 
		 @Comments, @Reason, @Payer,
		 @TotalPC, @TotalWithVATPC, @TotalBC, @TotalWithVATBC)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	SET @ID = SCOPE_IDENTITY()
	
	COMMIT TRANSACTION
	
	EXEC pjm5CreditMemoGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5CreditMemoCreate TO PUBLIC
GO
