IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentCardInitialize]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentCardInitialize'
		DROP PROCEDURE [dbo].[pjm5DocumentCardInitialize]
	END
GO

PRINT 'Creating procedure pjm5DocumentCardInitialize'
GO

/******************************************************************************
**		File: pjm5DocumentCardInitialize.sql
**		Name: pjm5DocumentCardInitialize
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5DocumentCardInitialize
	@ID TIdentifier,
	@CaseID TIdentifier
AS
	SET NOCOUNT ON
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('AccessToPublicFolders')) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	BEGIN TRANSACTION
	IF @CaseID IS NOT NULL
	BEGIN
		DECLARE @HasToBeSentBack TBool
		SELECT @HasToBeSentBack = [HasToBeSentBack] FROM [Case] WHERE[ID] = @CaseID
		UPDATE 
			[DocumentCard]
		SET
			[CaseID] = @CaseID,
			[HasToBeSentBack] = @HasToBeSentBack,
			[Modified] = DEFAULT,
			[ModifiedBy] = DEFAULT
		WHERE
			[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		UPDATE
			[Note]
		SET
			[DocumentClass] = [DocumentCard].[Class],
			[DocumentID] = [DocumentCard].[ID]
		FROM
			[Note]
			INNER JOIN [DocumentItem]
				ON [Note].[DocumentClass] = [DocumentItem].[Class] AND
					[Note].[DocumentID] = [DocumentItem].[ID]
			INNER JOIN [DocumentCard]
				ON [DocumentCard].[ID] = [DocumentItem].[DocumentCardID]
		WHERE
			[DocumentCard].[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		UPDATE
			[Attachment]
		SET
			[DocumentClass] = [DocumentCard].[Class],
			[DocumentID] = [DocumentCard].[ID]
		FROM
			[Attachment]
			INNER JOIN [DocumentItem]
				ON [Attachment].[DocumentClass] = [DocumentItem].[Class] AND
					[Attachment].[DocumentID] = [DocumentItem].[ID]
			INNER JOIN [DocumentCard]
				ON [DocumentCard].[ID] = [DocumentItem].[DocumentCardID]
		WHERE
			[DocumentCard].[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		UPDATE
			[Attachment]
		SET
			[LinkDocumentClass] = [DocumentCard].[Class],
			[LinkDocumentID] = [DocumentCard].[ID]
		FROM
			[Attachment]
			INNER JOIN [DocumentItem]
				ON [Attachment].[LinkDocumentClass] = [DocumentItem].[Class] AND
					[Attachment].[LinkDocumentID] = [DocumentItem].[ID]
			INNER JOIN [DocumentCard]
				ON [DocumentCard].[ID] = [DocumentItem].[DocumentCardID]
		WHERE
			[DocumentCard].[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		UPDATE
			[MailItem]
		SET
			[DocumentClass] = [DocumentCard].[Class],
			[DocumentID] = [DocumentCard].[ID]
		FROM
			[MailItem]
			INNER JOIN [DocumentItem]
				ON [MailItem].[DocumentClass] = [DocumentItem].[Class] AND
					[MailItem].[DocumentID] = [DocumentItem].[ID]
			INNER JOIN [DocumentCard]
				ON [DocumentCard].[ID] = [DocumentItem].[DocumentCardID]
		WHERE
			[DocumentCard].[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	ELSE
	BEGIN
		UPDATE 
			[DocumentCard]
		SET

			[NumberIn] = NULL,
			[DateIn] = NULL,
			[NumberOut] = NULL,
			[DateOut] = NULL,
			[CaseID] = NULL,
			[CorrespondentCompanyID] = NULL,
			[CorrespondentContactID] = NULL,
			[DocumentSendTypeID] = NULL,
			[SentTime] = NULL,
			[HasToBeSentBack] = 0,
			[DocumentSendBackTypeID] = NULL,
			[SentBackTime] = NULL,
			[Modified] = DEFAULT,
			[ModifiedBy] = DEFAULT
		WHERE
			[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		UPDATE
			[Note]
		SET
			[DocumentClass] = [DocumentItem].[Class],
			[DocumentID] = [DocumentItem].[ID]
		FROM
			[Note]
			INNER JOIN [DocumentCard]
				ON [Note].[DocumentClass] = [DocumentCard].[Class] AND
					[Note].[DocumentID] = [DocumentCard].[ID]
			INNER JOIN [DocumentItem]
				ON [DocumentCard].[ID] = [DocumentItem].[DocumentCardID]
		WHERE
			[DocumentCard].[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		UPDATE
			[Attachment]
		SET
			[DocumentClass] = [DocumentItem].[Class],
			[DocumentID] = [DocumentItem].[ID]
		FROM
			[Attachment]
			INNER JOIN [DocumentCard]
				ON [Attachment].[DocumentClass] = [DocumentCard].[Class] AND
					[Attachment].[DocumentID] = [DocumentCard].[ID]
			INNER JOIN [DocumentItem]
				ON [DocumentCard].[ID] = [DocumentItem].[DocumentCardID]
		WHERE
			[DocumentCard].[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		UPDATE
			[Attachment]
		SET
			[LinkDocumentClass] = [DocumentItem].[Class],
			[LinkDocumentID] = [DocumentItem].[ID]
		FROM
			[Attachment]
			INNER JOIN [DocumentCard]
				ON [Attachment].[LinkDocumentClass] = [DocumentCard].[Class] AND
					[Attachment].[LinkDocumentID] = [DocumentCard].[ID]
			INNER JOIN [DocumentItem]
				ON [DocumentCard].[ID] = [DocumentItem].[DocumentCardID]
		WHERE
			[DocumentCard].[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		UPDATE
			[MailItem]
		SET
			[DocumentClass] = [DocumentItem].[Class],
			[DocumentID] = [DocumentItem].[ID]
		FROM
			[MailItem]
			INNER JOIN [DocumentCard]
				ON [MailItem].[DocumentClass] = [DocumentCard].[Class] AND
					[MailItem].[DocumentID] = [DocumentCard].[ID]
			INNER JOIN [DocumentItem]
				ON [DocumentCard].[ID] = [DocumentItem].[DocumentCardID]
		WHERE
			[DocumentCard].[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END	
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentCardInitialize TO PUBLIC
GO

