IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentCardUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentCardUpdate'
		DROP PROCEDURE [dbo].[pjm5DocumentCardUpdate]
	END
GO

PRINT 'Creating procedure pjm5DocumentCardUpdate'
GO

/******************************************************************************
**		File: pjm5DocumentCardUpdate.sql
**		Name: pjm5DocumentCardUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		19.02.13	SAP				  OPENXML
*******************************************************************************/
CREATE PROCEDURE pjm5DocumentCardUpdate
	@Xml XML
AS
	SET NOCOUNT ON
	DECLARE
		@ID TIdentifier
	
	DECLARE 
		@FileAs TName,
		@FileName TName,
		@DocumentCardClassID TIdentifier,
		@DocumentCardID TIdentifier,
		@Number TCode,
		@Date TDate,
		@NumberIn TCode,
		@DateIn TDate,
		@NumberOut TCode,
		@DateOut TDate,
		@CompanyID TIdentifier,
		@ContactID TIdentifier,
		@CorrespondentCompanyID TIdentifier,
		@CorrespondentContactID TIdentifier,
		@DivisionID TIdentifier,
		@CaseID TIdentifier,
		@SentTime TDateTime,
		@DocumentSendTypeID TIdentifier,
		@Comments TNotes,
		@Package TCode,
		@Copy TBool,
		@AppendixCount TCount,
		@PageCount TCount,
		@StorePeriod TCount,
		@CardOwnerID TIdentifier,
		@CustodyPlaceID TIdentifier,
		
		@HasToBeSentBack TBool,
		@SentBackTime TDateTime,
		@DocumentSendBackTypeID TIdentifier,

		@DocumentItemID TIdentifier,
		@DocumentItemFileName TName,
		@Extension TName

		DECLARE @t TABLE
		([ID] int)
		
		INSERT INTO @t
		SELECT 
			@Xml.value('(/pjm5DocumentCardGet/DocumentCard/ID)[1]','int')

		
	SELECT
		@ID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/ID)[1]','int'),
		@FileAs = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/FileAs)[1]','nvarchar(512)'),
		@FileName = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/FileName)[1]','nvarchar(512)'),

		@DocumentItemID = [DocumentItem].[ID],
		@DocumentItemFileName = [DocumentItem].[FileName],
		@Extension = [DocumentItem].[Extension],

		@DocumentCardClassID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/DocumentCardClassID)[1]','int'),
		@DocumentCardID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/DocumentCardID)[1]','int'),
		@Number = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/Number)[1]','varchar(32)'),
		@Date = CAST(@Xml.value('(/pjm5DocumentCardGet/DocumentCard/Date)[1]','nvarchar(19)') AS datetime),
		@NumberIn = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/NumberIn)[1]','varchar(32)'),
		@DateIn = CAST(@Xml.value('(/pjm5DocumentCardGet/DocumentCard/DateIn)[1]','nvarchar(19)') AS datetime),
		@NumberOut = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/NumberOut)[1]','varchar(32)'),
		@DateOut = CAST(@Xml.value('(/pjm5DocumentCardGet/DocumentCard/DateOut)[1]','nvarchar(19)') AS datetime),
		@CompanyID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/CompanyID)[1]','int'),
		@ContactID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/ContactID)[1]','int'),
		@CorrespondentCompanyID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/CorrespondentCompanyID)[1]','int'),
		@CorrespondentContactID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/CorrespondentContactID)[1]','int'),
		@DivisionID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/DivisionID)[1]','int'),
		@CaseID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/CaseID)[1]','int'),
		@DocumentSendTypeID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/DocumentSendTypeID)[1]','int'),
		@SentTime = CAST(@Xml.value('(/pjm5DocumentCardGet/DocumentCard/SentTime)[1]','nvarchar(19)') AS datetime),
		@Comments = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/Comments)[1]','nvarchar(max)'),

		@Package = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/Package)[1]','varchar(32)'),
		@Copy = CASE @Xml.value('(/pjm5DocumentCardGet/DocumentCard/Copy)[1]','varchar(5)')
					WHEN 'true' THEN 1 
					WHEN 'false' THEN 0 
					ELSE NULL 
				END,
		@AppendixCount = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/AppendixCount)[1]','int'),
		@PageCount = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/PageCount)[1]','int'),
		@StorePeriod = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/StorePeriod)[1]','int'),
		@CardOwnerID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/CardOwnerID)[1]','int'),
		@HasToBeSentBack = CASE 
								WHEN @Xml.value('(/pjm5DocumentCardGet/DocumentCard/HasToBeSentBack)[1]','varchar(5)') = 'false' THEN 0 
								ELSE 1 
						   END,
		@SentBackTime = CAST(@Xml.value('(/pjm5DocumentCardGet/DocumentCard/SentBackTime)[1]','nvarchar(19)') AS datetime),
		@DocumentSendBackTypeID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/DocumentSendBackTypeID)[1]','int'),
		@CustodyPlaceID = @Xml.value('(/pjm5DocumentCardGet/DocumentCard/CustodyPlaceID)[1]','int')
	FROM 
		@t
		LEFT OUTER JOIN [DocumentItem]
			ON [DocumentItem].[DocumentCardID] = [@t].[ID]


	
	IF @DocumentItemID IS NOT NULL
	BEGIN
		IF UPPER(@Extension) != UPPER(RIGHT(@FileName, LEN(@Extension)))
		BEGIN
			RAISERROR('#wrongfileextension', 18, -1)
			RETURN 1
		END	
	END
	
	BEGIN TRANSACTION
	IF @DocumentItemID IS NOT NULL AND
		UPPER(@DocumentItemFileName) != UPPER(@FileName)
	BEGIN
		UPDATE
			[DocumentItem]
		SET
			[FileAs] = @FileAs,
			[FileName] = @FileName
		WHERE
			[DocumentCardID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	UPDATE 
		[DocumentCard]
	SET
		[FileAs] = @FileAs, 
		[DocumentCardClassID] = @DocumentCardClassID,
		[DocumentCardID] = @DocumentCardID,
		[Number] = @Number,
		[Date] = @Date,
		[NumberIn] = @NumberIn,
		[DateIn] = @DateIn,
		[NumberOut] = @NumberOut,
		[DateOut] = @DateOut,
		[CompanyID] = @CompanyID,
		[ContactID] = @ContactID,
		[CorrespondentCompanyID] = @CorrespondentCompanyID,
		[CorrespondentContactID] = @CorrespondentContactID,
		[DivisionID] = @DivisionID,
		[CaseID] = @CaseID,
		[DocumentSendTypeID] = @DocumentSendTypeID,
		[SentTime] = @SentTime,
		[Comments] = @Comments,
		[Package] = @Package,
		[Copy] = @Copy,
		[AppendixCount] = @AppendixCount,
		[PageCount] = @PageCount,
		[StorePeriod] = @StorePeriod, 
		[CardOwnerID] = @CardOwnerID,
		[CustodyPlaceID] = @CustodyPlaceID,
		[HasToBeSentBack] = @HasToBeSentBack,
		[SentBackTime] = @SentBackTime,
		[DocumentSendBackTypeID] = @DocumentSendBackTypeID,
		[Modified] = DEFAULT,
		[ModifiedBy] = DEFAULT
	WHERE
		[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	
	COMMIT TRANSACTION
	EXEC pjm5DocumentCardGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentCardUpdate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5IncomingDocumentUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5IncomingDocumentUpdate'
		DROP PROCEDURE [dbo].[pjm5IncomingDocumentUpdate]
	END
GO

 
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5OutgoingDocumentUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5OutgoingDocumentUpdate'
		DROP PROCEDURE [dbo].[pjm5OutgoingDocumentUpdate]
	END
GO

