IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentItemReadProtocol]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentItemReadProtocol'
		DROP PROCEDURE [dbo].[pjm5DocumentItemReadProtocol]
	END
GO

PRINT 'Creating procedure pjm5DocumentItemReadProtocol'
GO

/******************************************************************************
**		File: pjm5DocumentItemReadProtocol.sql
**		Name: pjm5DocumentItemReadProtocol
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5DocumentItemReadProtocol
	@ID TIdentifier,
	@Version TCount
AS
	SET NOCOUNT ON
	DECLARE @UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	
	INSERT INTO [DocumentItemReadProtocol] ([ID], [Version], [UserID]) VALUES (@ID, @Version, @UserID)
	IF @@error != 0
		RETURN 1
		
	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentItemReadProtocol TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentItemReadProtocolBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentItemReadProtocolBrowse'
		DROP PROCEDURE [dbo].[pjm5DocumentItemReadProtocolBrowse]
	END
GO

PRINT 'Creating procedure pjm5DocumentItemReadProtocolBrowse'
GO

/******************************************************************************
**		File: pjm5DocumentItemReadProtocolBrowse.sql
**		Name: pjm5DocumentItemReadProtocolBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5DocumentItemReadProtocolBrowse
	@ID TIdentifier
AS
	SET NOCOUNT ON
	SELECT
		[DocumentItem].[Class],
		[DocumentItem].[ID],
		0 AS [State],
		[DocumentItemReadProtocol].[Version],
		[DocumentItemReadProtocol].[UserID],
		[DocumentItemReadProtocol].[Created],
		[Trustee].[Name],
		[Trustee].[DisplayName] AS [User]
	FROM
		[DocumentItem]
		INNER JOIN [DocumentItemReadProtocol]
			ON [DocumentItemReadProtocol].[ID] = [DocumentItem].[ID]
		INNER JOIN [Trustee]
			ON [DocumentItemReadProtocol].[UserID] = [Trustee].[ID]
	WHERE
		[DocumentItem].[ID] = @ID
	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentItemReadProtocolBrowse TO PUBLIC
GO
