IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FactureCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FactureCreate'
		DROP PROCEDURE [dbo].[pjm5FactureCreate]
	END
GO

PRINT 'Creating procedure pjm5FactureCreate'
GO

/******************************************************************************
**		File: pjm5FactureCreate.sql
**		Name: pjm5FactureCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		25.03.13	SOV				 OpenXml  Xml.
*******************************************************************************/
CREATE PROCEDURE [pjm5FactureCreate]
	@Xml XML
AS
	SET NOCOUNT ON

	DECLARE
		@FileAs TName,
		@Date TDate,
		@Number TCode,

		@ProjectID TIdentifier,
		@CurrencyCode TCode,
		@CurrencyRate TAmount,
		@Scale TCount,

		@SupplierCompanyID TIdentifier,
		@SupplierAddress TNotes,
		@SupplierINN TName,
		@SupplierKPP TCode,
		@CustomerCompanyID TIdentifier,
		@CustomerAddress TNotes,
		@CustomerINN TName,
		@CustomerKPP TCode,
		@Sender TNotes,
		@Recipient TNotes,
		@DocumentNumber TName,
		@DocumentDate TDate,
		@Chief TName,
		@Accountant TName,
		@Comments TNotes,
		@Advance TBool,
		@ExchangeBanned TBool,
		
		@value TVariant

	DECLARE @State TState,
			@ID TIdentifier
	
	SET @State = dbo.adfwfGetInitialState('55bf9030-b268-4094-8610-0408eef8a713')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SELECT 
		@FileAs = ISNULL([XMLTable].value('FileAs[1]', 'varchar(512)'), '  '),
		@Date = CONVERT(datetime, [XMLTable].value('Date[1]', 'varchar(19)')),
		@Number = ISNULL([XMLTable].value('Number[1]', 'varchar(32)'), ''),

		@ProjectID = [XMLTable].value('ProjectID[1]', 'int'),
		@CurrencyCode = [XMLTable].value('CurrencyCode[1]', 'varchar(3)'),
		@CurrencyRate = [XMLTable].value('CurrencyRate[1]', 'decimal(18,4)'),
		@Scale = [Project].[Scale],

		@SupplierCompanyID = [XMLTable].value('SupplierCompanyID[1]', 'int'),
		@SupplierAddress = [XMLTable].value('SupplierAddress[1]', 'varchar(512)'),
		@SupplierINN = [XMLTable].value('SupplierINN[1]', 'varchar(512)'),
		@SupplierKPP = [XMLTable].value('SupplierKPP[1]', 'varchar(512)'),
		@CustomerCompanyID = [XMLTable].value('CustomerCompanyID[1]', 'int'),
		@CustomerAddress = [XMLTable].value('CustomerAddress[1]', 'varchar(512)'),
		@CustomerINN = [XMLTable].value('CustomerINN[1]', 'varchar(512)'),
		@CustomerKPP = [XMLTable].value('CustomerKPP[1]', 'varchar(512)'),
		@Sender = [XMLTable].value('Sender[1]', 'varchar(512)'),
		@Recipient = [XMLTable].value('Recipient[1]', 'varchar(512)'),
		@DocumentNumber = [XMLTable].value('DocumentNumber[1]', 'varchar(512)'),
		@DocumentDate = [XMLTable].value('DocumentDate[1]', 'varchar(19)'),
		@Comments = [XMLTable].value('Comments[1]', 'nvarchar(max)'),
		@Advance = CASE [XMLTable].value('Advance[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END,
		@ExchangeBanned = CASE [XMLTable].value('ExchangeBanned[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END
	FROM
		@Xml.nodes('/pjm5FactureGet/Facture') AS List(XmlTable)
		INNER JOIN [Project]
			ON [Project].[ID] = [XMLTable].value('ProjectID[1]', 'int')

	DECLARE @payments TABLE([PaymentID] int)
	INSERT INTO @payments 
	SELECT 
		[XmlTable].value('PaymentID[1]', 'int') 
	FROM 
		@Xml.nodes('/pjm5FactureGet/Payment')	AS List(XmlTable)
	
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllInvoices')) = 0 AND
		dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, NULL, NULL) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END	
	
	SELECT
		@Chief = COALESCE(
			dbo.adfPropertyValueGetText([Chief].[Class], [Chief].[ID], '00000002-0000-0000-0000-000000000000'),
			[Chief].[LastName] + ISNULL(' ' + [Chief].[FirstName], '') + ISNULL(' ' + [Chief].[MiddleName], ''), 
			[Chief].[FileAs]), 
		@Accountant = COALESCE(
			dbo.adfPropertyValueGetText([Accountant].[Class], [Accountant].[ID], '00000002-0000-0000-0000-000000000000'), 
			[Accountant].[LastName] + ISNULL(' ' + [Accountant].[FirstName], '') + ISNULL(' ' + [Accountant].[MiddleName], ''), 
			[Accountant].[FileAs])
	FROM
		[Company]
		LEFT OUTER JOIN [Employee] AS [Chief]
			ON [Chief].[ID] = [Company].[ExecutiveEmployeeID]
		LEFT OUTER JOIN [Employee] AS [Accountant]
			ON [Accountant].[ID] = [Company].[AccountantEmployeeID]
	WHERE		
		[Company].[ID] = @SupplierCompanyID
	
	DECLARE @PaymentClass TClass, @FactureClass TClass
	SET @FactureClass = dbo.adfGetClassByName('Pjm5.Facture')
	SET @PaymentClass = dbo.adfGetClassByName('Adf.Payment')
	
	BEGIN TRANSACTION
	INSERT INTO [Facture]
		([Flag], [State], [FileAs], [Date], [Number], [SupplierCompanyID], [SupplierAddress], [SupplierINN], [SupplierKPP], [CustomerCompanyID], [CustomerAddress], [CustomerINN], [CustomerKPP], [Sender], [Recipient], [DocumentNumber], [DocumentDate], [Chief], [Accountant], [Comments],
		[ProjectID], [CurrencyCode], [CurrencyRate], [Scale],
		[Total], [TotalWithVAT], [TotalPC], [TotalWithVATPC],[Advance], [ExchangeBanned])
	VALUES
		(0, @State, @FileAs, @Date, @Number, @SupplierCompanyID, @SupplierAddress, @SupplierINN, @SupplierKPP, @CustomerCompanyID, @CustomerAddress, @CustomerINN, @CustomerKPP, @Sender, @Recipient, @DocumentNumber, @DocumentDate, @Chief, @Accountant, @Comments,
		@ProjectID, @CurrencyCode, @CurrencyRate, @Scale,
		0,0,0,0,
		@Advance, @ExchangeBanned)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()
	
	INSERT INTO [FacturePayment]([FactureID], [PaymentID]) SELECT @ID, [PaymentID] FROM @payments
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	INSERT INTO [Attachment]
		(
		[DocumentClass], [DocumentID], [Name],
		[LinkDocumentClass], [LinkDocumentID], [AttachmentTypeID]
		)
	SELECT
		@PaymentClass, [PaymentID], '-',
		@FactureClass, [FactureID], 3	
	FROM
		[FacturePayment]
	WHERE
		[FactureID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	EXEC pjm5FactureGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5FactureCreate TO PUBLIC
GO
 