IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FolderDeleteNotification]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5FolderDeleteNotification'
	DROP PROCEDURE [dbo].[pjm5FolderDeleteNotification]
END
GO

PRINT 'Creating procedure pjm5FolderDeleteNotification'
GO

/******************************************************************************
**		File: pjm5FolderDeleteNotification.sql
**		Name: pjm5FolderDeleteNotification
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FolderDeleteNotification]
	@FolderID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE 
		@FromID TIdentifier,
		@Language TCode
		
	SET @FromID = dbo.adfGetCurrentUserID()
	SET @Language = dbo.adfGetLanguage()

	
	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	SELECT
		1,
		0,
		CASE @Language 
			WHEN 'en' THEN 'Folder ''' + [Folder].[FileAs] + ''' has been deleted.'
			ELSE ' ''' + [Folder].[FileAs] + '''  .'
		END,
		N'KickMail',
		@FromID,
		[FolderNotificationSettings].[TrusteeID],
		[ParentFolder].[Class],
		[ParentFolder].[ID],
		0,
		CASE @Language 
			WHEN 'en' THEN 'Folder ''' + [Folder].[FileAs] + ''' has been deleted.'
			ELSE ' ''' + [Folder].[FileAs] + '''  .'
		END,
		CASE @Language 
			WHEN 'en' THEN 'Element contains parent folder.'
			ELSE '   '
		END
	FROM
		[Folder]
		INNER JOIN [Folder] AS [ParentFolder]
			ON [ParentFolder].[ID] = [Folder].[FolderID]
		INNER JOIN [FolderNotificationSettings]
			ON [FolderNotificationSettings].[FolderID] = [Folder].[ID] AND
				[FolderNotificationSettings].[TrusteeID] != @FromID AND
				([FolderNotificationSettings].[FolderSettings] & 0x0010) = 0x0010
	WHERE
		[Folder].[ID] = @FolderID AND
		dbo.fnFolderHasRightAccess([ParentFolder].[ID], [FolderNotificationSettings].[TrusteeID], 'FOLDERVISIBLE') = 1
		
	RETURN 0
GO
  
GRANT EXECUTE ON [pjm5FolderDeleteNotification] TO [public]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FolderRenameNotification]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5FolderRenameNotification'
	DROP PROCEDURE [dbo].[pjm5FolderRenameNotification]
END
GO

PRINT 'Creating procedure pjm5FolderRenameNotification'
GO

/******************************************************************************
**		File: pjm5FolderRenameNotification.sql
**		Name: pjm5FolderRenameNotification
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FolderRenameNotification]
	@FolderID TIdentifier,
	@PrevFileAs TName
AS
	SET NOCOUNT ON
	
	DECLARE 
		@FromID TIdentifier,
		@Language TCode
		
	SET @FromID = dbo.adfGetCurrentUserID()
	SET @Language = dbo.adfGetLanguage()

	
	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	SELECT
		1,
		0,
		CASE @Language 
			WHEN 'en' THEN 'Folder ''' + @PrevFileAs + ''' has been renamed to ''' + [Folder].[FileAs] + '''.'
			ELSE ' ''' + @PrevFileAs + '''    ''' + [Folder].[FileAs] + '''.'
		END,
		N'KickMail',
		@FromID,
		[FolderNotificationSettings].[TrusteeID],
		[Folder].[Class],
		[Folder].[ID],
		0,
		CASE @Language 
			WHEN 'en' THEN 'Folder ''' + @PrevFileAs + ''' has been renamed to ''' + [Folder].[FileAs] + '''.'
			ELSE ' ''' + @PrevFileAs + '''    ''' + [Folder].[FileAs] + '''.'
		END,
		CASE @Language 
			WHEN 'en' THEN 'Element contains folder.'
			ELSE '  '
		END
	FROM
		[Folder]
		INNER JOIN [FolderNotificationSettings]
			ON [FolderNotificationSettings].[FolderID] = [Folder].[ID] AND
				[FolderNotificationSettings].[TrusteeID] != @FromID AND
				([FolderNotificationSettings].[FolderSettings] & 0x0001) = 0x0001
	WHERE
		[Folder].[ID] = @FolderID AND
		dbo.fnFolderHasRightAccess([Folder].[ID], [FolderNotificationSettings].[TrusteeID], 'FOLDERVISIBLE') = 1
		
	RETURN 0
GO
  
GRANT EXECUTE ON [pjm5FolderRenameNotification] TO [public]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FolderCreateSubfolderNotification]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5FolderCreateSubfolderNotification'
	DROP PROCEDURE [dbo].[pjm5FolderCreateSubfolderNotification]
END
GO

PRINT 'Creating procedure pjm5FolderCreateSubfolderNotification'
GO

/******************************************************************************
**		File: pjm5FolderCreateSubfolderNotification.sql
**		Name: pjm5FolderCreateSubfolderNotification
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FolderCreateSubfolderNotification]
	@FolderID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE 
		@FromID TIdentifier,
		@Language TCode
		
	SET @FromID = dbo.adfGetCurrentUserID()
	SET @Language = dbo.adfGetLanguage()

	
	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	SELECT
		1,
		0,
		CASE @Language 
			WHEN 'en' THEN 'Subfolder ''' + REPLACE([Folder].[FileAs], '&', ' and ') + ''' has been created in folder ''' + REPLACE([ParentFolder].[FileAs], '&', ' and ') + '''.'
			ELSE ' ''' + REPLACE([Folder].[FileAs], '&', ' and ') + '''     ''' + REPLACE([ParentFolder].[FileAs], '&', ' and ') + '''.'
		END,
		N'KickMail',
		@FromID,
		[FolderNotificationSettings].[TrusteeID],
		[ParentFolder].[Class],
		[ParentFolder].[ID],
		0,
		CASE @Language 
			WHEN 'en' THEN 'Subfolder ''' + REPLACE([Folder].[FileAs], '&', ' and ') + ''' has been created in folder ''' + REPLACE([ParentFolder].[FileAs], '&', ' and ') + '''.'
			ELSE ' ''' + REPLACE([Folder].[FileAs], '&', ' and ') + '''     ''' + REPLACE([ParentFolder].[FileAs], '&', ' and ') + '''.'
		END,
		CASE @Language 
			WHEN 'en' THEN 'Element contains parent folder.'
			ELSE '   '
		END
	FROM
		[Folder]
		INNER JOIN [Folder] AS [ParentFolder]
			ON [ParentFolder].[ID] = [Folder].[FolderID]
		INNER JOIN [FolderNotificationSettings]
			ON [FolderNotificationSettings].[FolderID] = [ParentFolder].[ID] AND
				[FolderNotificationSettings].[TrusteeID] != @FromID AND
				([FolderNotificationSettings].[FolderSettings] & 0x0100) = 0x0100
	WHERE
		[Folder].[ID] = @FolderID AND
		dbo.fnFolderHasRightAccess([ParentFolder].[ID], [FolderNotificationSettings].[TrusteeID], 'FOLDERVISIBLE') = 1
		
	RETURN 0
GO
  
GRANT EXECUTE ON [pjm5FolderCreateSubfolderNotification] TO [public]
GO
