 IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmCalendarResources')
	BEGIN
		PRINT 'Dropping Procedure lmCalendarResources'
		DROP  Procedure  lmCalendarResources
	END

GO

PRINT 'Creating Procedure lmCalendarResources'
GO
/******************************************************************************
**		File: 
**		Name: lmCalendarResources
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure lmCalendarResources
AS
	SET NOCOUNT ON

	DECLARE @EmployeeID TIdentifier,
			@UserID TIdentifier
	
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @UserID = dbo.adfGetCurrentUserID()
	
	SELECT
		[Resource].[ID],
		[Resource].[Code],
		[Resource].[FileAs] as [Name],
		[ResourceType].[FileAs] as [ResourceType],
		CAST((CASE WHEN [CalendarResource].[ResourceID] IS NULL THEN 0 ELSE 1 END) AS BIT) as [Selected]
	FROM
		[Resource] INNER JOIN [ResourceType]
			ON ([Resource].[ResourceTypeID] = [ResourceType].[ID])
		LEFT OUTER JOIN [CalendarResource]
			ON ([Resource].[ID] = [CalendarResource].[ResourceID] AND [CalendarResource].[UserID] = @UserID)
	WHERE
		[Resource].[State] = 1
		
	RETURN 0
GO

GRANT EXEC ON lmCalendarResources TO PUBLIC
GO
  