IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmExpenseCodeDefaults')
	BEGIN
		PRINT 'Dropping Procedure lmExpenseCodeDefaults'
		DROP  Procedure  lmExpenseCodeDefaults
	END

GO

PRINT 'Creating Procedure lmExpenseCodeDefaults'
GO
/******************************************************************************
**		File: 
**		Name: lmExpenseTypeDefaults
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		21.04.11	SPV				    
**									 .
**									 JOIN   
**									pjm6GetAvailableProjectsForBrowse.
*******************************************************************************/
CREATE Procedure lmExpenseCodeDefaults
AS
	SET NOCOUNT ON
	
	DECLARE @IsAssistant TBool
	SET @IsAssistant = dbo.fnPjm5IsAssistant()	

	SELECT DISTINCT
		[ExpenseCodeDefaults].[ExpenseCodeID],
		[ExpenseCodeDefaults].[Subject],
		[ExpenseCodeDefaults].[Comments],
		[ExpenseCodeDefaults].[LanguageCode]
	FROM
		[ExpenseCodeDefaults]
		INNER JOIN [ProjectExpenseCode]
			ON [ExpenseCodeDefaults].[ExpenseCodeID] = [ProjectExpenseCode].[ExpenseCodeID]
	WHERE
		[ProjectExpenseCode].[Actively] = 1 AND 
		([ProjectExpenseCode].[ProjectID] IN (SELECT [ID] FROM dbo.fnPjm6GetAvailableProjectsForProjectMemberAndManager())
		 OR @IsAssistant = 1)
	RETURN 0
GO

GRANT EXEC ON lmExpenseCodeDefaults TO PUBLIC
GO
 