IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmFolder')
	BEGIN
		PRINT 'Dropping Procedure lmFolder'
		DROP  Procedure  lmFolder
	END

GO

PRINT 'Creating Procedure lmFolder'
GO
/******************************************************************************
**		File: 
**		Name: lmFolder
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure lmFolder
AS
	SET NOCOUNT ON

	DECLARE @res int
	EXEC @res = lmCheckTimestamp 'lmFolder', 'Folder'
	IF @res = 0
		RETURN 0

	;WITH FolderTable([ID], [FolderID], [CompanyID], [Name]) AS (
		SELECT 
			[ID], [FolderID], [CompanyID], CAST([FileAs] AS varchar(max))
		FROM
			[Folder] 
		WHERE [FolderID] IS NULL
		UNION ALL
		SELECT 
			f.[ID], f.[FolderID], f.[CompanyID], CAST([FolderTable].[Name]+'\'+ f.[FileAs] AS varchar(max))
		FROM
			[Folder] f
			INNER JOIN [FolderTable]
				ON f.[FolderID] = [FolderTable].[ID]
	)
	SELECT
		[FolderTable].[ID],
		[FolderTable].[Name],
		[FolderTable].[CompanyID]
	FROM 
		[FolderTable]	
	
	EXEC lmSaveTimestamp 'lmFolder', 'Folder'
	RETURN 0
GO

GRANT EXEC ON lmFolder TO PUBLIC
GO
   