IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmNotificationMessageToken')
	BEGIN
		PRINT 'Dropping Procedure lmNotificationMessageToken'
		DROP  Procedure  lmNotificationMessageToken
	END

GO

PRINT 'Creating Procedure lmNotificationMessageToken'
GO
/******************************************************************************
**		File: 
**		Name: lmNotificationMessageToken
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure lmNotificationMessageToken
AS
	SET NOCOUNT ON
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[NotificationMessageTemplateToken].[ID],
		[NotificationMessageTemplateToken].[Code],
		ISNULL ([NotificationMessageTemplateTokenGlobal].[FileAs],
			[NotificationMessageTemplateToken].[FileAs]) AS [FileAs],
		[NotificationMessageTemplateToken].[TokenText],
		[NotificationMessageTemplateToken].[Aggregatable]
	FROM
		[NotificationMessageTemplateToken]
		LEFT OUTER JOIN [NotificationMessageTemplateTokenGlobal]
				ON ([NotificationMessageTemplateToken].[ID] = [NotificationMessageTemplateTokenGlobal].[ID]
					AND [NotificationMessageTemplateTokenGlobal].[Language] = @Lang)
		
	RETURN 0
GO

GRANT EXEC ON lmNotificationMessageToken TO PUBLIC
GO
 