﻿IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmReminderDescription')
	BEGIN
		PRINT 'Dropping Procedure lmReminderDescription'
		DROP  Procedure  lmReminderDescription
	END

GO

PRINT 'Creating Procedure lmReminderDescription'
GO
/******************************************************************************
**		File: 
**		Name: lmBudgetTypes
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 11.04.2012 17:15
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure lmReminderDescription
AS
	SET NOCOUNT ON

	DECLARE 
		@Lang			TLanguage
	
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[ReminderDescription].[Subtype],
		[ReminderDescription].[Class],
		[ReminderDescription].[Description]
	FROM
		[ReminderDescription]
	WHERE
		[ReminderDescription].[Language] = @Lang

	RETURN 0
GO

GRANT EXEC ON lmReminderDescription TO PUBLIC
GO