IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6MsAssignmentUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6MsAssignmentUpdate'
		DROP PROCEDURE [dbo].[pjm6MsAssignmentUpdate]
	END
GO

PRINT 'Creating procedure pjm6MsAssignmentUpdate'
GO

SET QUOTED_IDENTIFIER ON
GO
/******************************************************************************
**		File: pjm6MsAssignmentUpdate.sql
**		Name: pjm6MsAssignmentUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 20.06.2006 19:57
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6MsAssignmentUpdate] @Xml XML
AS
	
	SET NOCOUNT ON

	DECLARE @ID TIdentifier,
			@MsProjectID TIdentifier,
			@MsTaskID TIdentifier,
			@MsResourceID TIdentifier,
			@Guid TGuid,
			@ProjectGuid TGuid,
			@TaskGuid TGuid,
			@ResourceGuid TGuid,
			@TaskID TIdentifier,
			@AssignmentID TIdentifier,
			@ProjectID TIdentifier,
			@EmployeeID TIdentifier,
			@rv int
	
	SELECT 
		@MsProjectID = T.c.value('ProjectID[1]', 'int'),
		@ProjectGuid = T.c.value('ProjectGuid[1]', 'uniqueidentifier'),
		@TaskGuid = T.c.value('TaskGuid[1]', 'uniqueidentifier'),
		@ResourceGuid = T.c.value('ResourceGuid[1]', 'uniqueidentifier'),
		@Guid = T.c.value('Guid[1]', 'uniqueidentifier')
	FROM 
		@Xml.nodes('Assignment') T(c);
		
	
	SELECT @MsTaskID = [ID] FROM [MsTask] WHERE [Guid] = @TaskGuid AND [ProjectID] = @MsProjectID
	SELECT @MsResourceID = [ID] FROM [MsResource] WHERE [Guid] = @ResourceGuid AND [ProjectID] = @MsProjectID
	SELECT @ID = [ID] 
	FROM [MsAssignment]
	WHERE [ProjectID] = @MsProjectID AND [TaskID] = @MsTaskID AND [ResourceID] = @MsResourceID
										
	SELECT
		@TaskID = [Task].[ID],
		@ProjectID = [Task].[ProjectID]
	FROM
		[Task]
		INNER JOIN [MsTask]
			ON [Task].[MsTaskID] = [MsTask].[ID]
	WHERE
		[MsTask].[ID] = @MsTaskID
	
	SELECT
		@AssignmentID = [Assignment].[ID],
		@EmployeeID = [Assignment].[EmployeeID]
	FROM
		[vwAssignment] as [Assignment]
	WHERE 
		[Assignment].[MsResourceID] = @MsResourceID

	BEGIN TRANSACTION
	
	IF @ID IS NULL
	BEGIN
		INSERT INTO [MsAssignment]
			   ([ProjectID], [TaskID], [ResourceID], [UniqueID], [Guid], [Units], 
			   [Work], [Cost], [OvertimeWork], [OvertimeCost],
			   [ActualWork], [ActualCost], [ActualOvertimeWork], [ActualOvertimeCost],
			   [RemainingWork], [RemainingCost], [RemainingOvertimeWork], [RemainingOvertimeCost],
			   [PercentWorkComplete])
		SELECT 
			@MsProjectID,
			@MsTaskID,
			@MsResourceID,
			T.c.value('UniqueID[1]', 'int'),
			T.c.value('Guid[1]', 'uniqueidentifier'),
			T.c.value('Units[1]', 'double precision'),
			T.c.value('Work[1]', 'double precision'),
			T.c.value('Cost[1]', 'double precision'),
			T.c.value('OvertimeWork[1]', 'double precision'),
			T.c.value('OvertimeCost[1]', 'double precision'),
			T.c.value('ActualWork[1]', 'double precision'),
			T.c.value('ActualCost[1]', 'double precision'),
			T.c.value('ActualOvertimeWork[1]', 'double precision'),
			T.c.value('ActualOvertimeCost[1]', 'double precision'),
			T.c.value('RemainingWork[1]', 'double precision'),
			T.c.value('RemainingCost[1]', 'double precision'),
			T.c.value('RemainingOvertimeWork[1]', 'double precision'),
			T.c.value('RemainingOvertimeCost[1]', 'double precision'),
			T.c.value('PercentWorkComplete[1]', 'decimal(18,4)')
		FROM 
			@Xml.nodes('Assignment') T(c);
			
		IF @@ERROR != 0
		BEGIN	
			ROLLBACK TRANSACTION
			RETURN 1
		END
			
		SELECT @ID = SCOPE_IDENTITY();

		DECLARE
			@Work TCount,
			@Units TPercent,
			@RemainingWork TAmount,
			@RemainingOvertimeWork TAmount
		
		SELECT
			@Work = [MsAssignment].[Work],
			@Units = [MsAssignment].[Units],
			@RemainingWork = [MsAssignment].[RemainingWork],
			@RemainingOvertimeWork = [MsAssignment].[RemainingOvertimeWork]
		FROM
			[MsAssignment]
		WHERE
			[MsAssignment].[ID] = @ID

		DELETE [TaskAssignment]
		WHERE
			[TaskAssignment].[TaskID]= @TaskID AND
			[TaskAssignment].[AssignmentID] = @AssignmentID
		IF @@ERROR != 0
		BEGIN	
			ROLLBACK TRANSACTION
			RETURN 1
		END

		INSERT INTO [TaskAssignment]
           ([TaskID] ,[AssignmentID] ,[Work] ,[Units], [MsAvailable], [RemainingWork], [RemainingOvertimeWork])
		VALUES
			(@TaskID, @AssignmentID, @Work, @Units, 1, @RemainingWork, @RemainingOvertimeWork)

		IF @@ERROR != 0
		BEGIN	
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	ELSE
	BEGIN
		UPDATE [MsAssignment]
		SET
			@MsProjectID = [ProjectID],
			@MsTaskID = [TaskID],
			@MsResourceID = [ResourceID],
			[Guid] = T.c.value('Guid[1]', 'uniqueidentifier'),
			[UniqueID] = T.c.value('UniqueID[1]', 'int'),
			[Units] = T.c.value('Units[1]', 'double precision'),
			[Work] = T.c.value('Work[1]', 'double precision'),
			[Cost] = T.c.value('Cost[1]', 'double precision'),
			[OvertimeWork] = T.c.value('OvertimeWork[1]', 'double precision'),
			[OvertimeCost] = T.c.value('OvertimeCost[1]', 'double precision'),
			[ActualWork] = T.c.value('ActualWork[1]', 'double precision'),
			[ActualCost] = T.c.value('ActualCost[1]', 'double precision'),
			[ActualOvertimeWork] = T.c.value('ActualOvertimeWork[1]', 'double precision'),
			[ActualOvertimeCost] = T.c.value('ActualOvertimeCost[1]', 'double precision'),
			[RemainingWork] = T.c.value('RemainingWork[1]', 'double precision'),
			[RemainingCost] = T.c.value('RemainingCost[1]', 'double precision'),
			[RemainingOvertimeWork] = T.c.value('RemainingOvertimeWork[1]', 'double precision'),
			[RemainingOvertimeCost] = T.c.value('RemainingOvertimeCost[1]', 'double precision'),
			[PercentWorkComplete] = T.c.value('PercentWorkComplete[1]', 'decimal(18,4)')
		FROM 
			[MsAssignment] INNER JOIN @Xml.nodes('Assignment') T(c)
				ON [MsAssignment].[ID] = @ID

		IF @@ERROR != 0
		BEGIN	
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		UPDATE 
			[TaskAssignment]
		SET 
			[TaskAssignment].[Work] = [MsAssignment].[Work],
			[TaskAssignment].[Units] = [MsAssignment].[Units],
			[TaskAssignment].[RemainingWork] = [MsAssignment].[RemainingWork],
			[TaskAssignment].[RemainingOvertimeWork] = [MsAssignment].[RemainingOvertimeWork],
			[TaskAssignment].[MsAvailable] = 1,
			[TaskAssignment].[State] = 1
		FROM 
			[TaskAssignment]
			INNER JOIN [Assignment]
				ON [TaskAssignment].[AssignmentID] = [Assignment].[ID]
			INNER JOIN [MsAssignment]
				ON [MsAssignment].[ResourceID] = [Assignment].[MsResourceID]
		WHERE
			[TaskAssignment].[AssignmentID] = @AssignmentID AND
			[TaskAssignment].[TaskID] = @TaskID AND
			[MsAssignment].[ID] = @ID
		
		IF @@ERROR != 0
		BEGIN	
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
	END	
	
	DELETE [MsTimephasedData] WHERE [ProjectID] = @MsProjectID AND [TaskID] = @MsTaskID 
		AND [ResourceID] = @MsResourceID AND [AssignmentID] = @ID
	
	IF @@ERROR != 0
	BEGIN	
		ROLLBACK TRANSACTION
		RETURN 1
	END

	BEGIN
		exec @rv = pjm6TaskPercentUpdate @TaskID
	END
	IF @rv !=0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	-- this Table will be deleted
	/*
	INSERT INTO [MsTimephasedData]	
		([ProjectID], [TaskID], [ResourceID], [AssignmentID], [Type], [StartDate], [EndDate], [Value])
	SELECT
		@MsProjectID,
		@MsTaskID,
		@MsResourceID,
		@ID,
		T.c.value('Type[1]', 'int'),
		T.c.value('StartDate[1]', 'datetime'),
		T.c.value('EndDate[1]', 'datetime'),
		T.c.value('Value[1]', 'double precision')
	FROM
		@Xml.nodes('Assignment/TimephasedData/TimeScaleValue') T(c)
	IF @@ERROR != 0
	BEGIN	
		ROLLBACK TRANSACTION
		RETURN 1
	END
	*/
	---------------------------------
	
	DELETE [BusyEntry] WHERE [ProjectID] = @ProjectID AND [TaskID] = @TaskID 
		AND [AssignmentID] = @AssignmentID AND [ActualWork] = 0 AND [ActualOvertimeWork] = 0
	IF @@ERROR != 0
	BEGIN	
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DECLARE @t TABLE
	(
		[Type] TInt32,
		[StartDate] TDate, 
		[EndDate] TDate,
		[Value] TCount
	)
	
	INSERT INTO @t	
		([Type], [StartDate], [EndDate], [Value])
	SELECT
		T.c.value('Type[1]', 'int'),
		T.c.value('StartDate[1]', 'datetime'),
		T.c.value('EndDate[1]', 'datetime'),
		T.c.value('Value[1]', 'double precision')
	FROM
		@Xml.nodes('Assignment/TimephasedData/MsTimeScaleValue') T(c)
	IF @@ERROR != 0
	BEGIN	
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	UPDATE [BusyEntry]
	SET [BusyEntry].[Planned] = [MsTimephasedData].[Value]
	FROM
		[BusyEntry]
		INNER JOIN @t AS [MsTimephasedData]
			ON [BusyEntry].[Date] = [MsTimephasedData].[StartDate] 
	WHERE		
		[BusyEntry].[ProjectID] = @ProjectID AND
		[BusyEntry].[TaskID] = @TaskID AND
		[BusyEntry].[AssignmentID] = @AssignmentID 
	DELETE @t
	FROM
		@t AS [TimephaseData]
			INNER JOIN [BusyEntry]
			ON [TimephaseData].[StartDate] = [BusyEntry].[Date]
	WHERE
		[BusyEntry].[ProjectID] = @ProjectID AND
		[BusyEntry].[TaskID] = @TaskID AND
		[BusyEntry].[AssignmentID] = @AssignmentID
		
	INSERT INTO [BusyEntry]
           ([ProjectID] 
           ,[TaskID]
           ,[AssignmentID]
           ,[Date]
           ,[EmployeeID]
           ,[Planned]
           ,[Canceled]
           ,[Committed]
           ,[Work]
           ,[OvertimeWork]
           )
	SELECT 
			@ProjectID,
			@TaskID,
			@AssignmentID,
			[MsTimephasedData].[StartDate],
			@EmployeeID,
			SUM(CASE WHEN [MsTimephasedData].[Type] = 0 THEN [MsTimephasedData].[Value] ELSE 0 END),
			0,
			0,
			SUM(CASE WHEN [MsTimephasedData].[Type] = 0 THEN [MsTimephasedData].[Value] ELSE 0 END),
			SUM(CASE WHEN [MsTimephasedData].[Type] = 0 THEN 0 ELSE [MsTimephasedData].[Value] END)
	FROM
		@t AS [MsTimephasedData]
	GROUP BY 
		[MsTimephasedData].[StartDate]
		
	IF @@ERROR != 0
	BEGIN	
		ROLLBACK TRANSACTION
		RETURN 1
	END

SELECT @ID

	COMMIT TRANSACTION
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm6MsAssignmentUpdate] TO PUBLIC
GO
    