IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6MsProjectUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6MsProjectUpdate'
		DROP PROCEDURE [dbo].[pjm6MsProjectUpdate]
	END
GO

PRINT 'Creating procedure pjm6MsProjectUpdate'
GO

SET QUOTED_IDENTIFIER ON
GO
/******************************************************************************
**		File: pjm6MsProjectUpdate.sql
**		Name: pjm6MsProjectUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 20.06.2006 19:57
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6MsProjectUpdate] @Xml XML
AS
	
	SET NOCOUNT ON

	DECLARE @ID TIdentifier,
			@Guid TGuid,
			@EmployeeID TIdentifier,
			@MsParentID TIdentifier,
			@ParentID TIdentifier,
			@TaskID TIdentifier,
			@MsTaskID TIdentifier,
			@ProjectID TIdentifier
	
SET @EmployeeID = dbo.adfGetCurrentEmployeeID();
	
	IF @EmployeeID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1);
		RETURN 1;
	END
	
	--       .
	IF dbo.adfHasAccessRightByName('ManageProject') = 0
	BEGIN
		RAISERROR('#NotEnoughPermissions', 18, -1)
		RETURN 1
	END
	
	IF dbo.adfHasAccessRightByName('MsProjectSync') = 0
	BEGIN
		RAISERROR('#NotEnoughPermissions', 18, -1)
		RETURN 1
	END
	
		DECLARE
			@Start TDate,
			@Name TName,
			@val TVariant,
			@CompanyID TIdentifier,
			@PriorityID TIdentifier,
			@CurrencyCode TCode3,
			@InvoiceExpirationPeriod TCount,
			@InvoiceExpirationPeriodType TIdentifier,
			@ProjectTypeID TIdentifier,
			@Notes TNotes,
			@RoundingInterval TCount,
			@RoundingMode TIdentifier,
			@Work TCount,
			@Cost TMoney,
			@Scale TCount,
			@ProjectName TName,
			@FileCreateDate TDate,
			@ParentSummaryGuid TGuid,
			@Finish DateTime,
			@ApplyVAT TBool,
			@Currency TCode3,
			@PercentComplete TPercent,
			@GroupCalculationLines TBool,
			@Instance TGuid,
			@OldProjectID TIdentifier,
			@DatabaseGuid TGuid,
			@CheckTaskWorkOverdraft TBool
		
		EXEC adfParameterGet @Name='InvoiceExpirationPeriod', @Group='Pjm5', @Value = @val OUTPUT
		SET @InvoiceExpirationPeriod = CAST(@val as int)
		
		EXEC adfParameterGet @Name='InvoiceExpirationPeriodType', @Group='Pjm5', @Value = @val OUTPUT
		SET @InvoiceExpirationPeriodType = CAST(@val as int)
		
		EXEC adfParameterGet @Name='DefaultProjectType', @Group='Pjm5', @Value = @val OUTPUT
		SET @ProjectTypeID = CAST(@val as int)

		EXEC adfParameterGet @Name='RoundInterval', @Group='Pjm5', @Value = @val OUTPUT
		SET @RoundingInterval = CAST(@val as int)
		
		EXEC adfParameterGet @Name='RoundingMode', @Group='Pjm5', @Value = @val OUTPUT
		SET @RoundingMode = CAST(@val as int)
		
		EXEC adfParameterGet @Name='ApplyVAT', @Group='CommonBusiness', @Value = @val OUTPUT
		SET @ApplyVAT = CAST(@val as bit)
		
		EXEC adfParameterGet @Name='GroupCalculationLines', @Group='Pjm5', @Value = @val OUTPUT
		SET @GroupCalculationLines = CAST(@val as bit)
		
		EXEC adfParameterGet @Name='CheckTaskWorkOverdraft', @Group='Pjm6', @Value = @val OUTPUT
		SET @CheckTaskWorkOverdraft = ISNULL(CAST(@val as bit), 0)

		EXEC adfParameterGet @Name='Instance', @Group='Instance', @Value = @val OUTPUT
		SET @Instance = CAST(@val as uniqueidentifier)
		
		SELECT
			@CompanyID = [CompanyID]
		FROM
			[Employee]
		WHERE
			[ID] = @EmployeeID
	
	SELECT 
			@MsParentID = T.c.value('ParentID[1]', 'int'),
			@ParentSummaryGuid = T.c.value('ParentSummaryGuid[1]', 'uniqueidentifier'),
			@Currency = T.c.value('CurrencyCode[1]', 'nvarchar(3)'),
			@OldProjectID = T.c.value('ProjectID[1]', 'int'),
			@DatabaseGuid = T.c.value('DatabaseGuid[1]', 'uniqueidentifier')
	FROM 
			@Xml.nodes('Project') T(c);
	
	SELECT @ParentID = [ID] FROM [Project] WHERE [MsProjectID] = @MsParentID
	SELECT @MsTaskID = [ID] FROM [MsTask] WHERE [Guid] = @ParentSummaryGuid AND [ProjectID] = @MsParentID
	SELECT @TaskID = [ID] FROM [Task] WHERE [Task].[MsTaskID] = @MsTaskID
	SELECT @ProjectID = [ID],
			@ID = [MsProjectID] FROM [Project] WHERE [Project].[ID] = @OldProjectID AND @DatabaseGuid = @Instance
	
	SELECT @CurrencyCode = [Code]
	FROM [Currency]
	WHERE [Code] = @Currency
	IF (@CurrencyCode IS NULL)
	BEGIN
		SET @Currency = NULL
		EXEC adfParameterGet @Name='BaseCurrency', @Group='CommonBusiness', @Value = @val OUTPUT
		SET @CurrencyCode = CAST(@val as char(3))
	END

	BEGIN TRANSACTION
	IF(@ID IS NOT NULL)
	BEGIN		
		UPDATE [MsProject]
		SET
			[Guid] = T.c.value('Guid[1]', 'uniqueidentifier'),
			[PriorityID] = T.c.value('PriorityID[1]', 'int'),
			[CurrencyCode] = @CurrencyCode,
			[Name] = T.c.value('Name[1]', 'nvarchar(256)'),
			[FullName] = T.c.value('FullName[1]', 'nvarchar(256)'),
			[Notes] = T.c.value('Notes[1]', 'nvarchar(max)'),
			[CurrencySymbol] = T.c.value('CurrencySymbol[1]', 'nvarchar(256)'),
			[CurrencyDigits] = T.c.value('CurrencyDigits[1]', 'smallint'),
			[CurrencySymbolPosition] = T.c.value('CurrencySymbolPosition[1]', 'int'),
			[StartWeekOn] = T.c.value('StartWeekOn[1]', 'int'),
			[StartYearIn] = T.c.value('StartYearIn[1]', 'int'),
			[DaysPerMonth] = T.c.value('DaysPerMonth[1]', 'int'),
			[HoursPerDay] = T.c.value('HoursPerDay[1]', 'double precision'),
			[HoursPerWeek] = T.c.value('HoursPerWeek[1]', 'double precision'),
			[FixedCost] = T.c.value('FixedCost[1]', 'double precision'),
			[FixedDuration] = T.c.value('FixedDuration[1]', 'bit'),
			[Start] = T.c.value('Start[1]', 'datetime'),
			[Finish] = T.c.value('Finish[1]', 'datetime'),
			[Duration] = T.c.value('Duration[1]', 'int'),
			[ActualStart] = T.c.value('ActualStart[1]', 'datetime'),
			[ActualFinish] = T.c.value('ActualFinish[1]', 'datetime'),
			[Work] = T.c.value('Work[1]', 'double precision'),
			[Cost] = T.c.value('Cost[1]', 'double precision'),
			[OvertimeWork] = T.c.value('OvertimeWork[1]', 'double precision'),
			[OvertimeCost] = T.c.value('OvertimeCost[1]', 'double precision'),
			[ActualWork] = T.c.value('ActualWork[1]', 'double precision'),
			[ActualCost] = T.c.value('ActualCost[1]', 'double precision'),
			[ActualDuration] = T.c.value('ActualDuration[1]', 'int'),
			[ActualOvertimeWork] = T.c.value('ActualOvertimeWork[1]', 'double precision'),
			[ActualOvertimeCost] = T.c.value('ActualOvertimeCost[1]', 'double precision'),
			[RemainingWork] = T.c.value('RemainingWork[1]', 'double precision'),
			[RemainingCost] = T.c.value('RemainingCost[1]', 'double precision'),
			[RemainingDuration] = T.c.value('RemainingDuration[1]', 'int'),
			[RemainingOvertimeWork] = T.c.value('RemainingOvertimeWork[1]', 'double precision'),
			[RemainingOvertimeCost] = T.c.value('RemainingOvertimeCost[1]', 'double precision'),
			[PercentComplete] = T.c.value('PercentComplete[1]', 'decimal(18,4)'),
			[PercentWorkComplete] = T.c.value('PercentWorkComplete[1]', 'decimal(18,4)'),
			[FileVersion] = T.c.value('FileVersion[1]', 'nvarchar(256)'),
			[FileCreateDate] = GetDate(),
			[Modified] = DEFAULT,
			[ModifiedBy] = DEFAULT
		FROM 
			[MsProject] INNER JOIN @Xml.nodes('Project') T(c)
				ON [MsProject].[ID] = @ID
			
		IF @@ERROR !=0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
			
		UPDATE [Project]
		SET
			[Project].[Date] = [MsProject].[Start],
			[Project].[PriorityID] = 
			CASE WHEN [MsProject].[PriorityID] BETWEEN 0 AND 49 THEN 0 ELSE
					 CASE WHEN [MsProject].[PriorityID] BETWEEN 50 AND 549 THEN 500 ELSE 1000 END END,
			[Project].[Comments] = [MsProject].[Notes],
			[Project].[CurrencyCode] =
				CASE WHEN @Currency IS NOT NULL THEN @CurrencyCode ELSE [Project].[CurrencyCode] END
		FROM 
			[MsProject]
			INNER JOIN [Project]
				ON [MsProject].[ID] = [Project].[MsProjectID]
		WHERE 
			[Project].[MsProjectID] = @ID
		IF @@ERROR !=0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		UPDATE [ProjectDetail]
		SET
			[DueDate] = [MsProject].[Finish],
			[PlannedManHour] = [MsProject].[Work],
			[PlannedBudget] = [MsProject].[Cost],
			[PercentComplete] = [MsProject].[PercentWorkComplete]/100.0
		FROM 
			[MsProject]
			INNER JOIN [Project]
				ON [MsProject].[ID] = [Project].[MsProjectID]
			INNER JOIN [ProjectDetail]
				ON [ProjectDetail].[ID] = [Project].[ID]
		WHERE 
			[Project].[MsProjectID] = @ID

		IF @@ERROR !=0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	ELSE
	BEGIN
	INSERT INTO [MsProject]
			   ([PriorityID], [CurrencyCode],[UniqueID], [Guid], [Name], [FullName], [Notes],
			   [CurrencySymbol], [CurrencyDigits], [CurrencySymbolPosition],
			   [StartWeekOn], [StartYearIn], [DaysPerMonth], [HoursPerDay], [HoursPerWeek], [FixedCost], [FixedDuration],
			   [Start], [Finish], [Duration], [ActualStart], [ActualFinish],
			   [Work], [Cost], [OvertimeWork], [OvertimeCost],
			   [ActualWork], [ActualCost], [ActualDuration], [ActualOvertimeWork], [ActualOvertimeCost],
			   [RemainingWork], [RemainingCost], [RemainingDuration], [RemainingOvertimeWork], [RemainingOvertimeCost],
			   [PercentComplete], [PercentWorkComplete], [FileVersion], [FileCreateDate], [LastDateSync])
		SELECT 
			T.c.value('PriorityID[1]', 'int'),
			@CurrencyCode,
			T.c.value('UniqueID[1]', 'int'),
			T.c.value('Guid[1]', 'uniqueidentifier'),
			T.c.value('Name[1]', 'nvarchar(256)'),
			T.c.value('FullName[1]', 'nvarchar(256)'),
			T.c.value('Notes[1]', 'nvarchar(max)'),
			T.c.value('CurrencySymbol[1]', 'nvarchar(256)'),
			T.c.value('CurrencyDigits[1]', 'smallint'),
			T.c.value('CurrencySymbolPosition[1]', 'int'),
			T.c.value('StartWeekOn[1]', 'int'),
			T.c.value('StartYearIn[1]', 'int'),
			T.c.value('DaysPerMonth[1]', 'int'),
			T.c.value('HoursPerDay[1]', 'double precision'),
			T.c.value('HoursPerWeek[1]', 'double precision'),
			T.c.value('FixedCost[1]', 'double precision'),
			T.c.value('FixedDuration[1]', 'bit'),
			T.c.value('Start[1]', 'datetime'),
			T.c.value('Finish[1]', 'datetime'),
			T.c.value('Duration[1]', 'int'),
			T.c.value('ActualStart[1]', 'datetime'),
			T.c.value('ActualFinish[1]', 'datetime'),
			T.c.value('Work[1]', 'double precision'),
			T.c.value('Cost[1]', 'double precision'),
			T.c.value('OvertimeWork[1]', 'double precision'),
			T.c.value('OvertimeCost[1]', 'double precision'),
			T.c.value('ActualWork[1]', 'double precision'),
			T.c.value('ActualCost[1]', 'double precision'),
			T.c.value('ActualDuration[1]', 'int'),
			T.c.value('ActualOvertimeWork[1]', 'double precision'),
			T.c.value('ActualOvertimeCost[1]', 'double precision'),
			T.c.value('RemainingWork[1]', 'double precision'),
			T.c.value('RemainingCost[1]', 'double precision'),
			T.c.value('RemainingDuration[1]', 'int'),
			T.c.value('RemainingOvertimeWork[1]', 'double precision'),
			T.c.value('RemainingOvertimeCost[1]', 'double precision'),
			T.c.value('PercentComplete[1]', 'decimal(18,4)'),
			T.c.value('PercentWorkComplete[1]', 'decimal(18,4)'),
			T.c.value('FileVersion[1]', 'nvarchar(256)'),
			GetDate(),
			GetDate()
		FROM 
			@Xml.nodes('Project') T(c);
		IF @@ERROR !=0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
			SELECT @ID = SCOPE_IDENTITY();
		
		-- insert information into table [Project]
		
		SELECT
			@Start = T.c.value('Start[1]', 'datetime'),
			@Name = T.c.value('Name[1]', 'nvarchar(256)'),
			@PriorityID = 
			CASE WHEN T.c.value('PriorityID[1]', 'int') BETWEEN 0 AND 49 THEN 0 ELSE
				 CASE WHEN T.c.value('PriorityID[1]', 'int') BETWEEN 50 AND 549 THEN 500 ELSE 1000 END END,
			@Notes = T.c.value('Notes[1]', 'nvarchar(max)'),
			@Work = T.c.value('Work[1]', 'double precision'),
			@Cost = T.c.value('Cost[1]', 'double precision'),
			@Scale = T.c.value('CurrencyDigits[1]', 'smallint'),
			@Finish = T.c.value('Finish[1]','datetime'),
			@PercentComplete = T.c.value('PercentWorkComplete[1]','decimal(18,4)')/100.0
		FROM 
			@Xml.nodes('Project') T(c)
		
		
		INSERT INTO [Project]
       (
		[MsProjectID],[State],[Flag],[Date],[Number],[InvoiceCurrency],[FactureCurrency]
       ,[StatementCurrency],[Scale],[BaseInitialBalance],[FileAs],[InitialBalance]
       ,[ProjectTypeID],[SupplierCompanyID],[ProjectManagerEmployeeID]
       ,[PaymentCurrencyPoint],[PriorityID],[CurrencyCode]
       ,[Balance],[Billable],[RoundingInterval],[RoundingMode],[ContractNumber]
       ,[ContractSubject], [ContractDate], [ApplyVAT],[RatesWithVAT],[InvoiceExpirationPeriod]
       ,[InvoiceExpirationPeriodType],[SupportsRequestManagement],[Comments], [GroupCalculationLines]
       ,[CheckTaskWorkOverdraft])
		VALUES
		(
		@ID, 1, 1, @Start, CAST(@Name as nvarchar(32)), 0, 0,
		0, @Scale, 0, @Name, 0,
		@ProjectTypeID, @CompanyID,@EmployeeID,
		0, @PriorityID, @CurrencyCode, 
		0,1, dbo.fnPjm5GetRoundInterval(@RoundingInterval), @RoundingMode, CAST(@Name as nvarchar(32)),
		@Name, @Start, @ApplyVAT, 0, @InvoiceExpirationPeriod, 
		@InvoiceExpirationPeriodType, 0, @Notes, @GroupCalculationLines
		,@CheckTaskWorkOverdraft);
		IF @@ERROR !=0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		SELECT @ProjectID = [ID] FROM [Project] WHERE [MsProjectID] = @ID
		
		INSERT INTO [ProjectDetail] 
			([ID], [DueDate], [PercentComplete], [PlannedBudget], [PlannedManHour])
		VALUES 
			(@ProjectID, @Finish, @PercentComplete, @Cost, @Work)
		IF @@ERROR !=0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		
		INSERT INTO [ProjectActivityType]
		([ProjectID], [ActivityTypeID], [Billable], [Actively])
		SELECT
			@ProjectID,
			[ID],
			[Billable],
			1
		FROM
			[ActivityType]
		WHERE
			([ProjectTypeID] = 1 OR [ProjectTypeID] IS NULL)
		AND
			[AddToNewProject] = 1 AND [State] = 1
	
		IF @@ERROR !=0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		INSERT INTO [ProjectExpenseCode]
			([ProjectID], [ExpenseCodeID], [Billable], [Actively])
		SELECT
			@ProjectID,
			[ID],
			[Billable],
			1
		FROM
			[ExpenseCode]
		WHERE
			([ProjectTypeID] = @ProjectTypeID OR [ProjectTypeID] IS NULL)
		AND
			[AddToNewProject] = 1 AND [State] = 1
			
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
		-- update information in the [Project] table
	
	UPDATE
		 [MsTask]
	SET
		[SubprojectID] = @ID
	WHERE
		[MsTask].[ID] = @MsTaskID
	
	IF @@ERROR !=0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
	END

	UPDATE
		 [Task]
	SET
		[SubprojectID] = @ProjectID
	WHERE
		[Task].[ID] = @TaskID

	IF @@ERROR !=0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
	END	

	SELECT
		@ID as [ID],
		@ProjectID as [ProjectID],
		@Instance as [Instance],
		[MsProject].[DocumentItemID],
		[Project].[Number],
		[Project].[CurrencyCode]
	FROM 
		[MsProject] 
		INNER JOIN [Project]
			ON [Project].[MsProjectID] = [MsProject].[ID]
	WHERE
		[MsProject].[ID] = @ID

	SELECT 
		[MsResource].[ID]
	FROM
		[MsResource]
			INNER JOIN [Assignment]
				ON [MsResource].[ID] = [Assignment].[MsResourceID]
	WHERE
		[MsResource].[ProjectID] = @ID AND
		[Assignment].[State] != 2
	
	SELECT
		[MsTask].[ID]
	FROM
		[MsTask]
			INNER JOIN [Task]
				ON [Task].[MsTaskID] = [MsTask].[ID]
	WHERE 
		[MsTask].[ProjectID] = @ID AND
		[Task].[State] != 6
	
	COMMIT TRANSACTION


	RETURN 0
GO

GRANT EXECUTE ON [pjm6MsProjectUpdate] TO PUBLIC
GO
  