IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6UpdateDocumentItemID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6UpdateDocumentItemID'
		DROP PROCEDURE [dbo].[pjm6UpdateDocumentItemID]
	END
GO

PRINT 'Creating procedure pjm6UpdateDocumentItemID'
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [pjm6UpdateDocumentItemID] @MsProjectID TIdentifier, @DocumentItemID TIdentifier
AS
	
	SET NOCOUNT ON

	UPDATE [MsProject]
	SET [DocumentItemID] = @DocumentItemID
	WHERE [ID] = @MsProjectID

	RETURN 0
GO

GRANT EXECUTE ON [pjm6UpdateDocumentItemID] TO PUBLIC
GO
  

/******************************************************************************
**		File: UpdateDocumentItemID
**		Name: pjm6MsProjectSyncLastDateUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6MsProjectSyncLastDateUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6MsProjectSyncLastDateUpdate'
		DROP PROCEDURE [dbo].[pjm6MsProjectSyncLastDateUpdate]
	END
GO

PRINT 'Creating procedure pjm6MsProjectSyncLastDateUpdate'
GO


CREATE PROCEDURE [pjm6MsProjectSyncLastDateUpdate]
	@MsProjectID TIdentifier


AS
	
	SET NOCOUNT ON

	UPDATE [MsProject]
	SET [LastDateSync] = GetDate()
	WHERE [ID] = @MsProjectID
					
	RETURN 0
GO

GRANT EXECUTE ON [pjm6MsProjectSyncLastDateUpdate] TO PUBLIC
GO 

/******************************************************************************
**		File: UpdateDocumentItemID
**		Name: pjm6MsProjectFileVersionUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6MsProjectFileVersionUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6MsProjectFileVersionUpdate'
		DROP PROCEDURE [dbo].[pjm6MsProjectFileVersionUpdate]
	END
GO

PRINT 'Creating procedure pjm6MsProjectFileVersionUpdate'
GO


CREATE PROCEDURE [pjm6MsProjectFileVersionUpdate]
	@MsProjectID TIdentifier,
	@FileVersion TCode


AS
	
	SET NOCOUNT ON

	UPDATE [MsProject]
	SET [FileVersion] = @FileVersion
	WHERE [ID] = @MsProjectID
					
	RETURN 0
GO

GRANT EXECUTE ON [pjm6MsProjectFileVersionUpdate] TO PUBLIC
GO 