/*==========================================================*/
/* Database View:             */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwAssignProjectManager]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwAssignProjectManager]
go

create view pjm5vwAssignProjectManager
as
	SELECT
		[Project].[Class] as [DocumentClass],
		[Project].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Project].[ID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		[Employee].[UserID] as [Value],
		[Project].[ModifiedBy] as [OwnerUserID]
	FROM
		[Project]
		LEFT OUTER JOIN [Employee]
			ON [Employee].[ID] = [Project].[ProjectManagerEmployeeID]
	WHERE
		[Project].[State] NOT IN (5, 6)
go

/*==========================================================*/
/* Database View:           */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwExclusionFromProjectManager]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwExclusionFromProjectManager]
go

create view pjm5vwExclusionFromProjectManager
as
	SELECT
		[Project].[Class] as [DocumentClass],
		[Project].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Project].[ID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		[Employee].[UserID] as [Value],
		[Project].[ModifiedBy] as [OwnerUserID]
	FROM
		[Project]
		LEFT OUTER JOIN [Employee]
			ON [Employee].[ID] = [Project].[ProjectManagerEmployeeID]
	WHERE
		[Project].[State] NOT IN (5, 6)
go 


/*==========================================================*/
/* Database View:                */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwAssignOnProject]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwAssignOnProject]
go

create view pjm5vwAssignOnProject
as
	SELECT
		[Project].[Class] as [DocumentClass],
		[Project].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Project].[ID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		NULL as [Value],
		[Assignment].[ModifiedBy] as [OwnerUserID]
	FROM
		[Project]
		INNER JOIN [Assignment]
			ON [Assignment].[ProjectID] = [Project].[ID]
		INNER JOIN [AssignmentEntry]
			ON [Assignment].[ID] = [AssignmentEntry].[AssignmentID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [AssignmentEntry].[EmployeeID]
	WHERE
		GETDATE() BETWEEN [AssignmentEntry].[ValidFrom] AND ISNULL([AssignmentEntry].[ValidTo], GETDATE())
		AND	[Project].[State] NOT IN (5, 6) AND [Employee].[UserID] IS NOT NULL
go

/*==========================================================*/
/* Database View:              */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwExclusionFromProject]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwExclusionFromProject]
go

create view pjm5vwExclusionFromProject
as
	SELECT
		[Project].[Class] as [DocumentClass],
		[Project].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Project].[ID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		NULL as [Value],
		[Assignment].[ModifiedBy] as [OwnerUserID]
	FROM
		[Project]
		INNER JOIN [Assignment]
			ON [Assignment].[ProjectID] = [Project].[ID]
		INNER JOIN [AssignmentEntry]
			ON [Assignment].[ID] = [AssignmentEntry].[AssignmentID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [AssignmentEntry].[EmployeeID]
		LEFT OUTER JOIN [ProjectTemplate]
			ON [ProjectTemplate].[ID] = [Project].[ID]
	WHERE
		GETDATE() BETWEEN [AssignmentEntry].[ValidFrom] AND ISNULL([AssignmentEntry].[ValidTo], GETDATE())
		AND	[Project].[State] NOT IN (5, 6) AND [Employee].[UserID] IS NOT NULL
go

/*=====================================================*/
/* Database View:               */
/*=====================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwStopProject]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwStopProject]
go

create view pjm5vwStopProject
as
	SELECT
		[Project].[Class] as [DocumentClass],
		[Project].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Project].[ID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[Project].[ModifiedBy] as [OwnerUserID]
	FROM
		[Project]
	WHERE
		[Project].[State] = 3
go

/*=================================================================*/
/* Database View:       */
/*=================================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwRecipientStopProject]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwRecipientStopProject]
go

create view pjm5vwRecipientStopProject
as
	SELECT
		[Project].[Class] as [DocumentClass],
		[Project].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Project].[ID] as [ContainerID],
		[Employee].[UserID] as [UserID]
	FROM
		[Project]
		INNER JOIN [Assignment]
			ON [Assignment].[ProjectID] = [Project].[ID]
		INNER JOIN [AssignmentEntry]
			ON [Assignment].[ID] = [AssignmentEntry].[AssignmentID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [AssignmentEntry].[EmployeeID]
	WHERE
		[Project].[State] = 3 AND
		GETDATE() BETWEEN [AssignmentEntry].[ValidFrom] AND ISNULL([AssignmentEntry].[ValidTo], GETDATE())
go

/*=====================================================*/
/* Database View:                       */
/*=====================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwOpenProject]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwOpenProject]
go

create view pjm5vwOpenProject
as
	SELECT
		[Project].[Class] as [DocumentClass],
		[Project].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Project].[ID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[Project].[ModifiedBy] as [OwnerUserID]
	FROM
		[Project]
	WHERE
		[Project].[State] = 2
go

/*=======================================================*/
/* Database View:     */
/*=======================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwRecipientOpenProject]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwRecipientOpenProject]
go

create view pjm5vwRecipientOpenProject
as
	SELECT
		[Project].[Class] as [DocumentClass],
		[Project].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Project].[ID] as [ContainerID],
		[Employee].[UserID] as [UserID]
	FROM
		[Project]
		INNER JOIN [Assignment]
			ON [Assignment].[ProjectID] = [Project].[ID]
		INNER JOIN [AssignmentEntry]
			ON [Assignment].[ID] = [AssignmentEntry].[AssignmentID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [AssignmentEntry].[EmployeeID]
	WHERE
		[Project].[State] = 2 AND
		GETDATE() BETWEEN [AssignmentEntry].[ValidFrom] AND ISNULL([AssignmentEntry].[ValidTo], GETDATE())
go

/*=====================================================*/
/* Database View:                     */
/*=====================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwCloseProject]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwCloseProject]
go

create view pjm5vwCloseProject
as
	SELECT
		[Project].[Class] as [DocumentClass],
		[Project].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Project].[ID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[Project].[ModifiedBy] as [OwnerUserID]
	FROM
		[Project]
	WHERE
		[Project].[State] = 4
go

/*=========================================================*/
/* Database View:     */
/*=========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwRecipientCloseProject]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwRecipientCloseProject]
go

create view pjm5vwRecipientCloseProject
as
	SELECT
		[Project].[Class] as [DocumentClass],
		[Project].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Project].[ID] as [ContainerID],
		[Employee].[UserID] as [UserID]
	FROM
		[Project]
		INNER JOIN [Assignment]
			ON [Assignment].[ProjectID] = [Project].[ID]
		INNER JOIN [AssignmentEntry]
			ON [Assignment].[ID] = [AssignmentEntry].[AssignmentID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [AssignmentEntry].[EmployeeID]
	WHERE
		[Project].[State] = 4 AND
		GETDATE() BETWEEN [AssignmentEntry].[ValidFrom] AND ISNULL([AssignmentEntry].[ValidTo], GETDATE())
go