/*==========================================================*/
/* Database View:                  */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwResourceRequestSentForApproval]') and OBJECTPROPERTY(id, N'IsView') = 1)
	drop view [dbo].[pjm5vwResourceRequestSentForApproval]
go

create view pjm5vwResourceRequestSentForApproval
as
	SELECT
		[ResourceRequest].[Class] as [DocumentClass],
		[ResourceRequest].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[ResourceRequest].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		[Employee].[UserID] as [Value],
		[ResourceRequest].[ModifiedBy] as [OwnerUserID]
	FROM
		[ResourceRequest] INNER JOIN [Resource]
			ON ([ResourceRequest].[ResourceID] = [Resource].[ID])
		INNER JOIN [Employee]
			ON ([Resource].[ResponsibleEmployeeID] = [Employee].[ID])
	WHERE
		[ResourceRequest].[State] = 2
go

/*==========================================================*/
/* Database View:                               */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwResourceRequestApproved]') and OBJECTPROPERTY(id, N'IsView') = 1)
	drop view [dbo].[pjm5vwResourceRequestApproved]
go

create view pjm5vwResourceRequestApproved
as
	SELECT
		[ResourceRequest].[Class] as [DocumentClass],
		[ResourceRequest].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[ResourceRequest].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		[Employee].[UserID] as [Value],
		[ResourceRequest].[ModifiedBy] as [OwnerUserID]
	FROM
		[ResourceRequest] INNER JOIN [Employee]
			ON ([ResourceRequest].[EmployeeID] = [Employee].[ID])
	WHERE
		[ResourceRequest].[State] = 3
go
 
/*==========================================================*/
/* Database View:                               */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwResourceRequestRejected]') and OBJECTPROPERTY(id, N'IsView') = 1)
	drop view [dbo].[pjm5vwResourceRequestRejected]
go

create view pjm5vwResourceRequestRejected
as
	SELECT
		[ResourceRequest].[Class] as [DocumentClass],
		[ResourceRequest].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[ResourceRequest].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		[Employee].[UserID] as [Value],
		[ResourceRequest].[ModifiedBy] as [OwnerUserID]
	FROM
		[ResourceRequest] INNER JOIN [Employee]
			ON ([ResourceRequest].[EmployeeID] = [Employee].[ID])
	WHERE
		[ResourceRequest].[State] = 4
go
