IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5PaymentSelectorDialog]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5PaymentSelectorDialog'
		DROP PROCEDURE [dbo].[pjm5PaymentSelectorDialog]
	END
GO

PRINT 'Creating procedure pjm5PaymentSelectorDialog'
GO

/******************************************************************************
**		File: ServiceBrowseSelectorDialog.sql
**		Name: pjm5PaymentSelectorDialog
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: MAV
**		Date: 01/18/2005 20:56:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5PaymentSelectorDialog]
	@SupplierID TIdentifier,
	@CustomerID TIdentifier,
	@ProjectID TIdentifier,
	@FactureID TIdentifier,
	@PeriodStart TDate,
	@PeriodEnd TDate,
	@Category TName
AS
	SET NOCOUNT ON
	SELECT
		[Class],
		[ID],
		[State],
		[Flag],
		[Number],
		[Date],
		[FileAs],
		[Value],
		[VAT],
		[CurrencyCode]
	FROM
		[Payment]
	WHERE
		[PayeeCompanyID] = @SupplierID AND
		[PayerCompanyID] = @CustomerID AND
		[Date] BETWEEN @PeriodStart AND @PeriodEnd AND
		[State] IN (2, 3) AND
		([ProjectID] IS NULL OR [ProjectID] = @ProjectID) AND
		(
			@Category IS NULL OR
			LEN(@Category) = 0 OR
			EXISTS(
				SELECT * 
				FROM [DocumentCategory] 
					INNER JOIN [Category]
						ON [Category].[ID] = [DocumentCategory].[CategoryID] 
				WHERE
					[DocumentCategory].[DocumentClass] = [Payment].[Class] AND
					[DocumentCategory].[DocumentID] = [Payment].[ID] AND
					[Category].[FileAs] LIKE @Category
			)
		) AND
		(
			@FactureID IS NULL OR
			NOT EXISTS(SELECT * FROM [FacturePayment] WHERE [FactureID] = @FactureID AND [PaymentID] = [Payment].[ID])
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5PaymentSelectorDialog] TO PUBLIC
GO
