IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5PhoneCallCodeBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5PhoneCallCodeBrowse'
		DROP PROCEDURE [dbo].[pjm5PhoneCallCodeBrowse]
	END
GO

PRINT 'Creating procedure pjm5PhoneCallCodeBrowse'
GO

/******************************************************************************
**		File: pjm5PhoneCallCodeBrowse.sql
**		Name: pjm5PhoneCallCodeBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 11:21:43
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5PhoneCallCodeBrowse]
	@StateSelector INT
AS
	DECLARE @VAT TPercent
	DECLARE @CurrencyCode TCode3

	SET NOCOUNT ON
	
	SET @VAT = dbo.fnPjm5GetVATRate()
	SET @CurrencyCode = dbo.fnPjm5GetAccountingCurrency()
	
	SELECT
		[PhoneCallCode].[Class],
		[PhoneCallCode].[ID],
		[PhoneCallCode].[State],
		[PhoneCallCode].[Flag],
		[PhoneCallCode].[FileAs],
		[PhoneCallCode].[Code],
		[PhoneCallCode].[VATIsIncluded],
		(CASE WHEN [PhoneCallCode].[VATIsIncluded] = 0 THEN [PhoneCallRate].[Price] 
			ELSE CAST(CAST([PhoneCallRate].[Price] / (1 + @VAT) as decimal(19, 2)) as money) 
		END) as [PriceWOVAT],
		(CASE WHEN [PhoneCallCode].[VATIsIncluded] = 1 THEN [PhoneCallRate].[Price]
			ELSE CAST(CAST([PhoneCallRate].[Price] * (1 + @VAT) as decimal(19, 2)) as money)
		END) as [PriceWithVAT],
		@CurrencyCode as [CurrencyCode],
		[PhoneCallCode].[Comments],
		[PhoneCallCode].[Created],
		[PhoneCallCode].[CreatedBy],
		[PhoneCallCode].[Modified],
		[PhoneCallCode].[ModifiedBy],
		[PhoneCallCode].[Timestamp]
	FROM
		[PhoneCallCode] LEFT OUTER JOIN [PhoneCallRate] ON
			([PhoneCallCode].[ID] = [PhoneCallRate].[PhoneCallCodeID] AND
			 [PhoneCallRate].[CurrencyCode] = @CurrencyCode)
	WHERE
		((@StateSelector = 0) OR (@StateSelector != 0 AND [PhoneCallCode].[State] = @StateSelector))
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5PhoneCallCodeBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5PhoneCallCodeGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5PhoneCallCodeGet'
		DROP PROCEDURE [dbo].[pjm5PhoneCallCodeGet]
	END
GO

PRINT 'Creating procedure pjm5PhoneCallCodeGet'
GO

/******************************************************************************
**		File: pjm5PhoneCallCodeGet.sql
**		Name: pjm5PhoneCallCodeGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 11:21:43
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5PhoneCallCodeGet]
	@ID TIdentifier
AS
	DECLARE @VAT TPercent

	SET NOCOUNT ON
	SET @VAT = dbo.fnPjm5GetVATRate()
	
	SELECT
		[PhoneCallCode].[Class],
		[PhoneCallCode].[ID],
		[PhoneCallCode].[State],
		[PhoneCallCode].[Flag],
		[PhoneCallCode].[FileAs],
		[PhoneCallCode].[Code],
		[PhoneCallCode].[VATIsIncluded],
		[PhoneCallCode].[Comments],
		[PhoneCallCode].[Created],
		[PhoneCallCode].[CreatedBy],
		[PhoneCallCode].[Modified],
		[PhoneCallCode].[ModifiedBy],
		[PhoneCallCode].[Timestamp]
	FROM
		[PhoneCallCode]
	WHERE
		[PhoneCallCode].[ID] = @ID
		
	SELECT
		(CASE WHEN [PhoneCallCode].[VATIsIncluded] = 1 THEN [PhoneCallRate].[Price]
			ELSE CAST(CAST([PhoneCallRate].[Price] * (1 + @VAT) as decimal(19, 2)) as money)
		END) as [PriceWithVAT],
		[PhoneCallRate].[CurrencyCode],
		(CASE WHEN [PhoneCallCode].[VATIsIncluded] = 0 THEN [PhoneCallRate].[Price] 
			ELSE CAST(CAST([PhoneCallRate].[Price] / (1 + @VAT) as decimal(19, 2)) as money) 
		END) as [PriceWOVAT],
		((CASE WHEN [PhoneCallCode].[VATIsIncluded] = 1 THEN [PhoneCallRate].[Price]
			ELSE CAST(CAST([PhoneCallRate].[Price] * (1 + @VAT) as decimal(19, 2)) as money)
		END) -
		(CASE WHEN [PhoneCallCode].[VATIsIncluded] = 0 THEN [PhoneCallRate].[Price] 
			ELSE CAST(CAST([PhoneCallRate].[Price] / (1 + @VAT) as decimal(19, 2)) as money) 
		END)) as [VAT]
	FROM
		[PhoneCallRate] INNER JOIN [PhoneCallCode]
			ON ([PhoneCallRate].[PhoneCallCodeID] = [PhoneCallCode].[ID])
	WHERE
		[PhoneCallRate].[PhoneCallCodeID] = @ID
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5PhoneCallCodeGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5PhoneCallCodeCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5PhoneCallCodeCreate'
		DROP PROCEDURE [dbo].[pjm5PhoneCallCodeCreate]
	END
GO

PRINT 'Creating procedure pjm5PhoneCallCodeCreate'
GO

/******************************************************************************
**		File: pjm5PhoneCallCodeCreate.sql
**		Name: pjm5PhoneCallCodeCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 11:21:43
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		11.03.13	SOV				 OpenXml  Xml
*******************************************************************************/
CREATE PROCEDURE [pjm5PhoneCallCodeCreate]
	@Xml XML
AS
	DECLARE @State TState,
			@ID TIdentifier,
			@FileAs TName,
			@Code TCode,
			@Comments TNotes,
			@VATIsIncluded TBool
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('ea0843a1-4822-494d-b667-f9aa4614a111')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SELECT
		@FileAs = [XmlTable].value('FileAs[1]', 'nvarchar(256)'),
		@Code = [XmlTable].value('Code[1]', 'varchar(32)'),
		@Comments = [XmlTable].value('Comments[1]', 'nvarchar(max)'),
		@VATIsIncluded = (CASE [XmlTable].value('VATIsIncluded[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END)
	FROM
		@Xml.nodes('/pjm5PhoneCallCodeGet/PhoneCallCode') AS List(XmlTable)

	BEGIN TRANSACTION
	
	INSERT INTO [PhoneCallCode]
		([Flag], [State], [FileAs], [Code], [Comments], [VATIsIncluded])
	VALUES
		(0, @State, @FileAs, @Code, @Comments, @VATIsIncluded)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()
	
	INSERT INTO [PhoneCallRate]
		([PhoneCallCodeID], [CurrencyCode], [Price])
	SELECT
		@ID,
		[XmlTable].value('CurrencyCode[1]', 'varchar(3)'),
		(CASE WHEN @VATIsIncluded = 1 THEN [XmlTable].value('PriceWithVAT[1]', 'money') 
			ELSE [XmlTable].value('PriceWOVAT[1]', 'money') END)
	FROM
		@Xml.nodes('/pjm5PhoneCallCodeGet/PhoneCallRate') AS List(XmlTable)

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION
		
	EXEC pjm5PhoneCallCodeGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5PhoneCallCodeCreate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5PhoneCallCodeUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5PhoneCallCodeUpdate'
		DROP PROCEDURE [dbo].[pjm5PhoneCallCodeUpdate]
	END
GO

PRINT 'Creating procedure pjm5PhoneCallCodeUpdate'
GO

/******************************************************************************
**		File: pjm5PhoneCallCodeUpdate.sql
**		Name: pjm5PhoneCallCodeUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 11:21:43
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    	11.03.13	SOV				 OpenXml  Xml
*******************************************************************************/
CREATE PROCEDURE pjm5PhoneCallCodeUpdate
	@Xml XML
AS
	DECLARE @ID TIdentifier,
			@FileAs TName,
			@Code TCode,
			@Comments TNotes,
			@VATIsIncluded TBool
	
	SET NOCOUNT ON
	
	SELECT
		@ID = [XmlTable].value('ID[1]', 'int'),
		@FileAs = [XmlTable].value('FileAs[1]', 'nvarchar(256)'),
		@Code = [XmlTable].value('Code[1]', 'varchar(32)'),
		@Comments = [XmlTable].value('Comments[1]', 'nvarchar(max)'),
		@VATIsIncluded = (CASE [XmlTable].value('VATIsIncluded[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END)
	FROM
		@Xml.nodes('/pjm5PhoneCallCodeGet/PhoneCallCode') AS List(XmlTable)
	
	BEGIN TRANSACTION
	
	UPDATE 
		[PhoneCallCode]
	SET
		[PhoneCallCode].[FileAs] = @FileAs,
		[PhoneCallCode].[Code] = @Code,
		[PhoneCallCode].[Comments] = @Comments,
		[PhoneCallCode].[VATIsIncluded] = @VATIsIncluded,
		[PhoneCallCode].[Modified] = DEFAULT,
		[PhoneCallCode].[ModifiedBy] = DEFAULT
	WHERE
		[PhoneCallCode].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE FROM [PhoneCallRate] WHERE [PhoneCallCodeID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	

	INSERT INTO [PhoneCallRate]
		([PhoneCallCodeID], [CurrencyCode], [Price])
	SELECT
		@ID,
		[XmlTable].value('CurrencyCode[1]', 'varchar(3)'),
		(CASE WHEN @VATIsIncluded = 1 THEN [XmlTable].value('PriceWithVAT[1]', 'money') 
			ELSE [XmlTable].value('PriceWOVAT[1]', 'money') END)
	FROM
		@Xml.nodes('/pjm5PhoneCallCodeGet/PhoneCallRate') AS List(XmlTable)

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION
	
	EXEC pjm5PhoneCallCodeGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5PhoneCallCodeUpdate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5PhoneCallCodeDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5PhoneCallCodeDelete'
		DROP PROCEDURE [dbo].[pjm5PhoneCallCodeDelete]
	END
GO

PRINT 'Creating procedure pjm5PhoneCallCodeDelete'
GO

/******************************************************************************
**		File: pjm5PhoneCallCodeDelete.sql
**		Name: pjm5PhoneCallCodeDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 11:21:43
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5PhoneCallCodeDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [PhoneCallCode] WHERE [PhoneCallCode].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5PhoneCallCodeDelete TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5PhoneCallCodeChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5PhoneCallCodeChangeState'
		DROP PROCEDURE [dbo].[pjm5PhoneCallCodeChangeState]
	END
GO

PRINT 'Creating procedure pjm5PhoneCallCodeChangeState'
GO

/******************************************************************************
**		File: pjm5PhoneCallCodeChangeState.sql
**		Name: pjm5PhoneCallCodeChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 11:21:43
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5PhoneCallCodeChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [PhoneCallCode].[Class],
		@FromState = [PhoneCallCode].[State]
	FROM
		[PhoneCallCode]
	WHERE
		[PhoneCallCode].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[PhoneCallCode]
	SET
		[PhoneCallCode].[State] = @ToState,
		[PhoneCallCode].[Modified] = GETDATE(),
		[PhoneCallCode].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[PhoneCallCode].[ID] = @ID
	AND
		[PhoneCallCode].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5PhoneCallCodeChangeState TO PUBLIC
GO
 