 IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'PjmSyncResetDeletedContact')
	BEGIN
		PRINT 'Dropping Procedure PjmSyncResetDeletedContact'
		DROP  Procedure  PjmSyncResetDeletedContact
	END

GO

PRINT 'Creating Procedure PjmSyncResetDeletedContact'
GO

--------------------------------------------------------------------------------------
CREATE Procedure PjmSyncResetDeletedContact
	@DeviceID varchar(40),
	@ItemID varchar(32)
AS
	SET NOCOUNT ON
	
	DECLARE @UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()

	BEGIN TRANSACTION
	 
	DELETE
		[UserContact]
	FROM 
		[UserContact]
		INNER JOIN [ExternalLink]
			ON [ExternalLink].[DocumentClass] = [UserContact].[BusinessCardClass] AND
				[ExternalLink].[DocumentID] = [UserContact].[BusinessCardID]
	WHERE 
		[ExternalLink].[DeviceID] = @DeviceID AND
		[ExternalLink].[ItemID] = @ItemID AND
		[UserContact].[UserID] = @UserID

	IF @@ERROR !=0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [ExternalLink]
	WHERE 
		[ExternalLink].[DeviceID] = @DeviceID AND
		[ExternalLink].[ItemID] = @ItemID 
	
	IF @@ERROR !=0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
		
	COMMIT TRANSACTION
	
	RETURN 0
	
GO

GRANT EXEC ON PjmSyncResetDeletedContact TO PUBLIC
GO  