IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6AddFrequentlyUsed]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6AddFrequentlyUsed'
		DROP PROCEDURE [dbo].[pjm6AddFrequentlyUsed]
	END
GO

PRINT 'Creating procedure pjm6AddFrequentlyUsed'
GO

/******************************************************************************
**		File: pjm6AddFrequentlyUsed.sql
**		Name: pjm6AddFrequentlyUsed
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm6AddFrequentlyUsed
	@ID TIdentifier
AS
	SET NOCOUNT ON

	BEGIN TRANSACTION	

	INSERT INTO [CalendarProject]
	(
		[ProjectID],
		[UserID]
	)	
	VALUES (@ID, dbo.adfGetCurrentUserID())

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm6AddFrequentlyUsed TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6RemoveFrequentlyUsed]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6RemoveFrequentlyUsed'
		DROP PROCEDURE [dbo].[pjm6RemoveFrequentlyUsed]
	END
GO

PRINT 'Creating procedure pjm6RemoveFrequentlyUsed'
GO

/******************************************************************************
**		File: pjm6RemoveFrequentlyUsed
**		Name: pjm6RemoveFrequentlyUsed
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm6RemoveFrequentlyUsed
	@ID TIdentifier
AS
	SET NOCOUNT ON

	BEGIN TRANSACTION	
	
	DELETE FROM [CalendarProject] WHERE [ProjectID] = @ID AND [UserID] = dbo.adfGetCurrentUserID()
	
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm6RemoveFrequentlyUsed TO PUBLIC
GO


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'pjm6CheckFrequentlyUsed') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6CheckFrequentlyUsed'
		DROP PROCEDURE pjm6CheckFrequentlyUsed
	END
GO

PRINT 'Creating procedure pjm6CheckFrequentlyUsed'
GO

/******************************************************************************
**		File: pjm6CheckFrequentlyUsed.sql
**		Name: pjm6CheckFrequentlyUsed
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm6CheckFrequentlyUsed
	@ID TIdentifier
AS
	SET NOCOUNT ON

	BEGIN TRANSACTION	
	
	IF EXISTS (SELECT * FROM [CalendarProject] 
				WHERE [ProjectID] = @ID AND [UserID] = dbo.adfGetCurrentUserID())
		BEGIN
			COMMIT TRANSACTION
			RETURN 3;
		END
	ELSE 
		BEGIN
			COMMIT TRANSACTION
			RETURN 4;
		END
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm6CheckFrequentlyUsed TO PUBLIC
GO


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6AddIssuelyUsed]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6AddIssuelyUsed'
		DROP PROCEDURE [dbo].[pjm6AddIssuelyUsed]
	END
GO

PRINT 'Creating procedure pjm6AddFrequentlyUsed'
GO

/******************************************************************************
**		File: pjm6AddIssuelyUsed.sql
**		Name: pjm6AddIssuelyUsed
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: KOV
**		Date: 30/06/2010 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm6AddIssuelyUsed
	@ID TIdentifier
AS
	SET NOCOUNT ON

	BEGIN TRANSACTION	

	INSERT INTO [IssueProject]
	(
		[ProjectID],
		[UserID]
	)	
	VALUES (@ID, dbo.adfGetCurrentUserID())

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm6AddIssuelyUsed TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6RemoveIssuelyUsed]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6RemoveIssuelyUsed'
		DROP PROCEDURE [dbo].[pjm6RemoveIssuelyUsed]
	END
GO

PRINT 'Creating procedure pjm6RemoveIssuelyUsed'
GO

/******************************************************************************
**		File: pjm6RemoveIssuelyUsed
**		Name: pjm6RemoveIssuelyUsed
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: KOV
**		Date: 30/06/2010
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm6RemoveIssuelyUsed
	@ID TIdentifier
AS
	SET NOCOUNT ON

	BEGIN TRANSACTION	
	
	DELETE FROM [IssueProject] WHERE [ProjectID] = @ID AND [UserID] = dbo.adfGetCurrentUserID()
	
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm6RemoveIssuelyUsed TO PUBLIC
GO


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'pjm6CheckIssuelyUsed') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6CheckIssuelyUsed'
		DROP PROCEDURE [dbo].[pjm6CheckIssuelyUsed]
	END
GO

PRINT 'Creating procedure pjm6CheckIssuelyUsed'
GO

/******************************************************************************
**		File: pjm6CheckIssuelyUsed.sql
**		Name: pjm6CheckIssuelyUsed
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: KOV
**		Date: 30/06/2010
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm6CheckIssuelyUsed
	@ID TIdentifier
AS
	SET NOCOUNT ON

	BEGIN TRANSACTION	
	
	IF EXISTS (SELECT * FROM [IssueProject] 
				WHERE [ProjectID] = @ID AND [UserID] = dbo.adfGetCurrentUserID())
		BEGIN
			COMMIT TRANSACTION
			RETURN 3;
		END
	ELSE 
		BEGIN
			COMMIT TRANSACTION
			RETURN 4;
		END
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm6CheckIssuelyUsed TO PUBLIC
GO