IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportWRCTHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportWRCTHeader'
		DROP  Procedure  ReportWRCTHeader
	END

GO

PRINT 'Creating Procedure ReportWRCTHeader'
GO
--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/

CREATE Procedure ReportWRCTHeader
	@CompanyID		TIdentifier,
	@WeekStart	    Tdatetime,
	@NextDate		Tdatetime,
	@NotLogged		TString
	
AS
	SET NOCOUNT ON
	SET DATEFIRST 7
	DECLARE
		@UserID			TIdentifier,
		@UserName		TName,
		@value			TVariant,
		@WorkTime		decimal(18,2)
		
	EXEC adfParameterGet 'WorkTime', 'Pjm5', @value OUTPUT  
	SET @WorkTime = CAST(@value AS decimal(18,2))
	SET @WorkTime = @WorkTime / 60.00		
		
	SET @UserID = dbo.adfGetCurrentUserID()
		
	SELECT
		@UserName = [Trustee].[DisplayName]
	FROM
		[Trustee]
	WHERE
		[Trustee].[ID] = @UserID
	
	SELECT
		[Company].[LegalName] AS [CompanyName],
		@WeekStart AS [WeekStart],
		DATEADD(second, -1, @NextDate) AS [WeekEnd],
    	@NotLogged AS [NotLogged],
		@UserName AS [UserName],
		dbo.fnPjm5GetWorkingDays(@WeekStart, DATEADD(second, -1, @NextDate)) AS [WorkingDays],
		@WorkTime AS [WorkTime]
	FROM
		[Company]
	WHERE
		[Company].[ID] = @CompanyID	




RETURN 0
GO

GRANT EXEC ON ReportWRCTHeader TO PUBLIC

GO
