IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[SprintReport]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure SprintReport'
		DROP PROCEDURE [dbo].[SprintReport]
	END
GO

PRINT 'Creating procedure SprintReport'
GO

/******************************************************************************
**		File: SprintReport.sql
**		Name: SprintReport
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: yuriy.soldatkin
**		Date: 01/11/2010
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
*******************************************************************************/
CREATE PROCEDURE [dbo].[SprintReport]
	@PeriodStart	TDate,
	@PeriodEnd		TDate,
	@Sprint			TCode

AS
	SET NOCOUNT ON	
	--SET @PeriodStart = '2010-09-19'
	--SET @PeriodEnd = '2010-10-10'
	--SET @Sprint = '27 /%'

	SELECT
		[Issue].[ID] AS [IssueID],
		[Issue].[Number],
		[IssueEmployee].[Initials] AS [IssueEmployee],
		[State].[Name] AS [IssueState],
		[Issue].[FileAs],
		[TimeEntryEmployee].[Initials] AS [TimeEntryEmployee],
		ROUND(
				(
					[Issue].[ManHour] - 
					ISNULL(
						(
						SELECT 
							SUM([TimeEntry].[Duration]) 
						FROM
							[TimeEntry]
						WHERE
							[TimeEntry].[StartTime] < @PeriodStart
							AND
							[TimeEntry].[DocumentClass] = [Issue].[Class]
							AND 
							[TimeEntry].[DocumentID] = [Issue].[ID]
						), 0)
				) / 60.0, 2
			) AS [PlanHour],
		ROUND(SUM(ISNULL([TimeEntry].[Duration], 0)) / 60.0, 2) AS [RealHour],
		[Issue].[UDF2],
		[Resolution].[FileAs] AS [ResolutionFileAs]
	FROM
		[Issue]
		LEFT OUTER JOIN [TimeEntry]
			ON [TimeEntry].[DocumentClass] = [Issue].[Class]
			AND [TimeEntry].[DocumentID] = [Issue].[ID]
		INNER JOIN [State]
			ON [State].[Class] = [Issue].[Class]
			AND [State].[State] = [Issue].[State]
		LEFT OUTER JOIN [Employee] AS [TimeEntryEmployee]
			ON [TimeEntryEmployee].[ID] = [TimeEntry].[EmployeeID]
		LEFT OUTER JOIN [Employee] AS [IssueEmployee]
			ON [IssueEmployee].[ID] = [Issue].[EmployeeID]
		LEFT OUTER JOIN [Resolution]
			ON [Issue].[ResolutionID] = [Resolution].[ID]
		WHERE
			(
				[TimeEntry].[StartTime] >= @PeriodStart
				AND 
				[TimeEntry].[StartTime] <= @PeriodEnd
				AND
				[TimeEntryEmployee].[Initials] 
					IN (SELECT
							[Employee].[Initials]
						FROM
							[Employee]
						INNER JOIN [Position]
							ON [Employee].[PositionID] = [Position].[ID]
						INNER JOIN [Company]
							ON [Employee].[CompanyID] = [Company].[ID]
						WHERE
							[Position].[Code] = ''
							AND
							[Employee].[State] = 1
							AND
							[Company].[Own] = 1)
			)
			OR
			(
				[TimeEntry].[StartTime] IS NULL
				AND
				[Issue].[UDF2] LIKE @Sprint
			)
		GROUP BY
			[Issue].[ID],
			[Issue].[Class],
			[Issue].[Number],
			[IssueEmployee].[Initials],
			[State].[Name],
			[Issue].[FileAs],
			[TimeEntryEmployee].[Initials],
			[Issue].[ManHour],
			[Issue].[UDF2],
			[Resolution].[FileAs]
		ORDER BY [TimeEntryEmployee], [IssueEmployee]
			
	RETURN 0
GO

GRANT EXECUTE ON [SprintReport] TO PUBLIC
GO
 