IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[ServiceRequestBrowseSelectorDialog]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure ServiceRequestBrowseSelectorDialog'
		DROP PROCEDURE [dbo].[ServiceRequestBrowseSelectorDialog]
	END
GO

PRINT 'Creating procedure ServiceRequestBrowseSelectorDialog'
GO

/******************************************************************************
**		File: pjm5ServiceRequestBrowseByCategory.sql
**		Name: pjm5ServiceRequestBrowseByCategory
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/18/2005 14:40:18
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [ServiceRequestBrowseSelectorDialog]
	@EmployeeID TIdentifier,
	@ProjectID TIdentifier,
	@State TIdentifier,
	@View int
AS
	SET NOCOUNT ON
	
	DECLARE 
		@StateClass TClass,
		@ServiceRequestManager int
		
	SET @ServiceRequestManager = dbo.adfHasAccessRightByName('ManageServiceRequest')
	
	IF (@EmployeeID = 0)
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
		
	SELECT
		[ServiceRequest].[ID],
		[ServiceRequest].[State],
		[ServiceRequest].[ProjectID],
		[ServiceRequest].[FileAs],
		[Contract].[ContractSubject] as [Contract],
		[ServiceRequest].[DueDate],
		[Employee].[FileAs] as [Employee]
	FROM
		[ServiceRequest]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [ServiceRequest].[EmployeeID]
		INNER JOIN dbo.fnPjm6GetAvailableProjectsForTimeEntryGet(@EmployeeID, @ProjectID) AS [Project]
			ON [Project].[ID] = [ServiceRequest].[ProjectID]
		INNER JOIN [Project] as [Contract]
			ON [Contract].[ID] = [ServiceRequest].[ProjectID]
	WHERE
		[ServiceRequest].[State] IN (2,3) AND
		(
			@ServiceRequestManager = 1 OR
			[ServiceRequest].[EmployeeID] = @EmployeeID
		) AND 
		(
			@ProjectID = 0 OR
			[ServiceRequest].[ProjectID] = @ProjectID
		) AND
		(
			[ServiceRequest].[State] = @State OR	--   
			@State = 0 --   
		) AND
		(
			@View = 0 OR --   
			[ServiceRequest].[EmployeeID] = @EmployeeID --   
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [ServiceRequestBrowseSelectorDialog] TO PUBLIC
GO