IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceRequestUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceRequestUpdate'
		DROP PROCEDURE [dbo].[pjm5ServiceRequestUpdate]
	END
GO

PRINT 'Creating procedure pjm5ServiceRequestUpdate'
GO

/******************************************************************************
**		File: pjm5ServiceRequestUpdate.sql
**		Name: pjm5ServiceRequestUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: andrew.maklakov
**		Date: 08/02/2005 14:07:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		30.07.10	MAN				 ,     .
*******************************************************************************/
CREATE PROCEDURE pjm5ServiceRequestUpdate
	@Xml XML
AS
	DECLARE @ID TIdentifier,
			@EmployeeID TIdentifier,
			@ProjectID TIdentifier,
			@ExecutorID TIdentifier,
			@PriorityID TIdentifier,
			@Date TDate,
			@Number TCode,
			@FileAs TName,
			@StartDate TDate,
			@DueDate TDate,
			@Billable TBool,
			@VATIsIncluded TBool,
			@ServiceTypeID TIdentifier,
			@Comments TNotes,
			@Description TNotes,
			@RecurrenceID TIdentifier,
			@ReminderState TState,
			@ReminderInterval TTimeSpan,
			@ManHour TCount

	DECLARE -- RECURRENCE
		@RStartDate TDate, 
		@REndDate TDate, 
		@RRecurrenceType TIdentifier, 
		@ROccurrences TCount,
		@RInterval TCount, 
		@RDayOfWeekMask TIdentifier, 
		@RInstance TIdentifier, 
		@RMonthOfYear TCount, 
		@RDayOfMonth TCount,
		@Recurrence TBool
	
	SET NOCOUNT ON
	
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	SELECT
		@ID					= @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/ID)[1]','int'),
		@ProjectID			= @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/ProjectID)[1]','int'),
		@ExecutorID			= @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/EmployeeID)[1]','int'),
		@PriorityID			= @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/PriorityID)[1]','int'),
		@Date				= CONVERT(datetime, @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/Date)[1]','nvarchar(19)')),
		@Number				= ISNULL(@Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/Number)[1]','varchar(32)'), ''),
		@FileAs				= ISNULL(@Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/FileAs)[1]','nvarchar(512)'), ''),
		@StartDate			= @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/StartDate)[1]','nvarchar(19)'),
		@DueDate			= @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/DueDate)[1]','nvarchar(19)'),
		@Billable			= CASE WHEN @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/Billable)[1]','varchar(5)') = 'false' THEN 0 ELSE 1 END,
		@VATIsIncluded		= CASE WHEN @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/VATIsIncluded)[1]','varchar(5)') = 'false' THEN 0 ELSE 1 END,
		@ServiceTypeID		= @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/ServiceTypeID)[1]','int'),
		@Comments			= @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/Comments)[1]','nvarchar(max)'),
		@Description		= @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/Description)[1]','nvarchar(max)'),
		@RecurrenceID		= @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/RecurrencePatternID)[1]','int'),
		@ReminderState		= CASE WHEN @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/ReminderState)[1]','varchar(5)') = 'false' THEN 0 ELSE 1 END,
		@ReminderInterval	= @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/ReminderInterval)[1]','int'),
		@ManHour			= @Xml.value('(/pjm5ServiceRequestGet/ServiceRequest/ManHour)[1]','int')

	SET @Recurrence = 0
	IF (SELECT @Xml.value('(/pjm5ServiceRequestGet/RecurrencePattern/ID)[1]','int')) IS NOT NULL
	BEGIN
		SET @Recurrence = 1
		SELECT
			@RStartDate			= @Xml.value('(/pjm5ServiceRequestGet/RecurrencePattern/StartDate)[1]','varchar(19)'),
			@REndDate			= @Xml.value('(/pjm5ServiceRequestGet/RecurrencePattern/EndDate)[1]','varchar(19)'),
			@RRecurrenceType	= @Xml.value('(/pjm5ServiceRequestGet/RecurrencePattern/RecurrenceType)[1]','int'),
			@ROccurrences		= @Xml.value('(/pjm5ServiceRequestGet/RecurrencePattern/Occurrences)[1]','int'),
			@RInterval			= @Xml.value('(/pjm5ServiceRequestGet/RecurrencePattern/Interval)[1]','int'),
			@RDayOfWeekMask		= @Xml.value('(/pjm5ServiceRequestGet/RecurrencePattern/DayOfWeekMask)[1]','int'), 
			@RInstance			= @Xml.value('(/pjm5ServiceRequestGet/RecurrencePattern/Instance)[1]','int'),
			@RMonthOfYear		= @Xml.value('(/pjm5ServiceRequestGet/RecurrencePattern/MonthOfYear)[1]','int'),
			@RDayOfMonth		= @Xml.value('(/pjm5ServiceRequestGet/RecurrencePattern/DayOfMonth)[1]','int')
	END

	IF dbo.fnPjm5AllowCreateProjectEntry(@ProjectID, NULL) = 0 AND
		dbo.fnPjm5IsProjectMember(@ProjectID, @EmployeeID) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	BEGIN
		IF NOT EXISTS(SELECT * FROM [vwAssignment] WHERE [ProjectID] = @ProjectID AND [EmployeeID] = @ExecutorID AND [State]=1)
		BEGIN
			RAISERROR('#notassignedtospecifiedproject', 18, -1)
			RETURN 1
		END
	END
	
	DECLARE
		@Total TMoney,
		@TotalWithVAT TMoney,
		@VATRate TPercent,
		@value TVariant		
	
	EXEC adfParameterGet @Name='VATRate', @Group='CommonBusiness', @Value = @value OUTPUT
	SET	@VATRate = ISNULL(CAST(@value as decimal(18,4)), 0)
	
	SELECT
		@Total = SUM(CASE @VATIsIncluded
					WHEN 0 THEN ISNULL(([ServiceRequestLine].[FactAmount] * [ServiceRequestLine].[Price]), 0.00) 
					ELSE ISNULL(ROUND(([ServiceRequestLine].[FactAmount] * [ServiceRequestLine].[Price] / (1 + @VATRate)), 2), 0.00)
				END),	
		@TotalWithVAT = SUM(CASE @VATIsIncluded
					WHEN 0 THEN ISNULL(ROUND(([ServiceRequestLine].[FactAmount] * [ServiceRequestLine].[Price] * (1 + @VATRate)), 2), 0.00)
					ELSE ISNULL(([ServiceRequestLine].[FactAmount] * [ServiceRequestLine].[Price]), 0.00)
				END)
	FROM
		[ServiceRequestLine]
	WHERE
		[ServiceRequestLine].[ServiceRequestID] = @ID
	
	DECLARE 
		@Class TClass,
		@State TState
	SELECT
		@State = [State],
		@Class = [Class]
	FROM
		[ServiceRequest]
	WHERE
		[ID] = @ID

	BEGIN TRANSACTION
	IF @State IN (1, 2)
	BEGIN
		IF @Recurrence = 0 AND @RecurrenceID IS NOT NULL
		BEGIN
			UPDATE [Document] SET [RecurrencePatternID] = NULL WHERE [Class] = @Class AND [ID] = @ID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE IF @Recurrence = 1 AND @RecurrenceID IS NULL
		BEGIN
			INSERT INTO [RecurrencePattern]
				([StartDate], [EndDate], [RecurrenceType], [Occurrences],
				[Interval], [DayOfWeekMask], [Instance], [MonthOfYear], [DayOfMonth])
			VALUES
				(@RStartDate, @REndDate, @RRecurrenceType, @ROccurrences,
				@RInterval, @RDayOfWeekMask, @RInstance, @RMonthOfYear, @RDayOfMonth)
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			SET @RecurrenceID = SCOPE_IDENTITY()
			
			UPDATE [Document] SET [RecurrencePatternID] = @RecurrenceID WHERE [Class] = @Class AND [ID] = @ID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE IF @Recurrence = 1 AND @RecurrenceID IS NOT NULL
		BEGIN
			UPDATE
				[RecurrencePattern]
			SET
				[StartDate] = @RStartDate, 
				[EndDate] = @REndDate, 
				[RecurrenceType] = @RRecurrenceType, 
				[Occurrences] = @ROccurrences,
				[Interval] = @RInterval, 
				[DayOfWeekMask] = @RDayOfWeekMask, 
				[Instance] = @RInstance, 
				[MonthOfYear] = @RMonthOfYear, 
				[DayOfMonth] = @RDayOfMonth
			WHERE
				[ID] = @RecurrenceID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END

	UPDATE 
		[ServiceRequest]
	SET
		[ServiceRequest].[ProjectID] = @ProjectID,
		[ServiceRequest].[EmployeeID] = @ExecutorID,
		[ServiceRequest].[PriorityID] = @PriorityID,
		[ServiceRequest].[Date] = @Date,
		[ServiceRequest].[Number] = @Number,
		[ServiceRequest].[FileAs] = @FileAs,
		[ServiceRequest].[StartDate] = @StartDate,
		[ServiceRequest].[DueDate] = @DueDate,
		[ServiceRequest].[Billable] = @Billable,
		[ServiceRequest].[VATIsIncluded] = @VATIsIncluded,
		[ServiceRequest].[ServiceTypeID] = @ServiceTypeID,
		[ServiceRequest].[Total] = ISNULL(@Total, 0),
		[ServiceRequest].[TotalWithVAT] = ISNULL(@TotalWithVAT, 0),
		[ServiceRequest].[Comments] = @Comments,
		[ServiceRequest].[Description] = @Description,
		[ServiceRequest].[Modified] = GETDATE(),
		[ServiceRequest].[ModifiedBy] = dbo.adfGetCurrentUserID(),
		[ServiceRequest].[ManHour] = ISNULL(@ManHour, 0)
	WHERE
		[ServiceRequest].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DECLARE @rv int
	EXEC @rv = pjm7ServiceRequestReminderCreate @ID,
		@DueDate, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	COMMIT TRANSACTION
	
	EXEC pjm5ServiceRequestGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ServiceRequestUpdate TO PUBLIC
GO 