IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[lmServiceRequest]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure lmServiceRequest'
		DROP PROCEDURE [dbo].[lmServiceRequest]
	END
GO

PRINT 'Creating procedure lmServiceRequest'
GO

/******************************************************************************
**		File: lmServiceRequest.sql
**		Name: lmServiceRequest
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [lmServiceRequest]
AS
	SET NOCOUNT ON
	
	DECLARE @EmployeeID TIdentifier,
		@ServiceRequestManager int
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()	
	SET @ServiceRequestManager = dbo.adfHasAccessRightByName('ManageServiceRequest')
	

	SELECT
		[ServiceRequest].[ID],
		[ServiceRequest].[State],
		[ServiceRequest].[FileAs] AS [Name],
		[ServiceRequest].[ProjectID]
	FROM
		[ServiceRequest]
		INNER JOIN dbo.fnPjm5GetAvailableProjects() as [Projects]
			ON [ServiceRequest].[ProjectID] = [Projects].[ID]
	WHERE
		[ServiceRequest].[State] IN (2, 3, 4) AND
		(
			@ServiceRequestManager = 1 OR
			[ServiceRequest].[EmployeeID] = @EmployeeID
		)
	
	RETURN 0
GO

GRANT EXECUTE ON [lmServiceRequest] TO PUBLIC
GO
 