 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskActiveBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskActiveBrowse'
		DROP PROCEDURE [dbo].[pjm5TaskActiveBrowse]
	END
GO

PRINT 'Creating procedure pjm5TaskActiveBrowse'
GO

/******************************************************************************
**		File: pjm5TaskActiveBrowse.sql
**		Name: pjm5TaskActiveBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5TaskActiveBrowse]
AS
	SET NOCOUNT ON
	DECLARE
		@today datetime,
		@ViewAllFinance TBool,
		@CurrentEmployeeID TIdentifier
		
	SET @today = GETDATE()
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
		
	DECLARE
		@PeriodStart TDate,
		@PeriodEnd TDate
	SELECT
		@PeriodStart = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime),
		@PeriodEnd = DATEADD(day, 1, @PeriodStart)
	
	SELECT
		[Task].[Class],
		[Task].[ID],
		[Task].[State],
		[Task].[Flag],
		[Task].[FileAs],
		[Task].[ProjectID],
		[Task].[PriorityID],
		[Task].[ParentID],
		[Task].[StartDate],
		[Task].[DueDate],
		[Task].[EndDate],
		[Task].[Duration],
		[Task].[PercentComplete],
		[Task].[Milestone],
		dbo.fnPjm5GetWorkingDays(@today, [Task].[DueDate]) AS [RestDays],
		[Task].[PlanPercent],
		[Task].[ManHour] / 60.0 AS [ManHour],
		CASE 
			WHEN @ViewAllFinance = 1 OR [Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID
				THEN [Task].[Budget]
			ELSE -1
		END AS [Budget],
		[Task].[RealManHour],
		CASE
			WHEN [Task].[ManHour] != 0 THEN
				CAST([Task].[RealManHour] as decimal(18,2))/[Task].[ManHour]
			ELSE 0
		END AS [RealManHourPercent],
		CASE 
			WHEN @ViewAllFinance = 1 OR [Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID
				THEN [Task].[TimeRealBudget]+[Task].[ExpenseRealBudget]
			ELSE -1
		end AS [RealBudget],
		CASE
			WHEN [Task].[Budget] != 0 THEN
				CAST([Task].[TimeRealBudget]+[Task].[ExpenseRealBudget] as decimal(18,2))/[Task].[Budget]
			ELSE 0
		END AS [RealBudgetPercent],
		[Task].[Comments],
		[Task].[Created],
		[Task].[CreatedBy],
		[Task].[Modified],
		[Task].[ModifiedBy],
		[Task].[Timestamp],
		CAST([Task].[Milestone] as tinyint) as M,
		(CAST([Task].[PercentComplete] * 100 as int) / 25) * 25 as PC
	FROM
		[pjm5vwTask] AS [Task] 
		INNER JOIN [Project]
			ON [Project].[ID] = [Task].[ProjectID]
		INNER JOIN 
			(SELECT DISTINCT
				[TaskAssignment].[TaskID]
			FROM 
				[TaskAssignment] INNER JOIN [vwAssignment] AS [Assignment]
				ON ([TaskAssignment].[AssignmentID] = [Assignment].[ID] 
					AND [Assignment].[EmployeeID] = @CurrentEmployeeID
					AND [TaskAssignment].[MsAvailable] = 1)
			) as [A]
			ON ([Task].[ID] = [A].[TaskID]) 
	WHERE
		(
			([Task].[State] = 2 AND [Task].[StartDate] < @PeriodEnd) OR 
			([Task].[State] = 3 AND [Task].[EndDate] >= @PeriodStart AND [Task].[EndDate] < @PeriodEnd)
		) AND [Task].[SubprojectID] IS NULL
	RETURN 0
GO

GRANT EXECUTE ON [pjm5TaskActiveBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskActiveBrowse1]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5TaskActiveBrowse1'
	DROP PROCEDURE [dbo].[pjm5TaskActiveBrowse1]
END
GO
/*******************************************************************************/


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskActiveBrowse2]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5TaskActiveBrowse2'
	DROP PROCEDURE [dbo].[pjm5TaskActiveBrowse2]
END
GO

PRINT 'Creating procedure pjm5TaskActiveBrowse2'
GO

/******************************************************************************
**		File: pjm5TaskActiveBrowse2.sql
**		Name: pjm5TaskActiveBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5TaskActiveBrowse2]
AS
	SET NOCOUNT ON
	DECLARE
		@ViewAllTasks TBool,
		@today datetime,
		@ViewAllFinance TBool,
		@CurrentEmployeeID TIdentifier
		
	SET @today = GETDATE()	
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	SET @ViewAllTasks = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllTasks'))

	DECLARE
		@PeriodStart TDate,
		@PeriodEnd TDate
	SELECT
		@PeriodStart = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime),
		@PeriodEnd = DATEADD(day, 1, @PeriodStart)
	
	SELECT
		[Task].[Class],
		[Task].[ID],
		[Task].[State],
		[Task].[Flag],
		[Task].[FileAs],
		[Task].[ProjectID],
		[Task].[PriorityID],
		[Task].[ParentID],
		[Task].[StartDate],
		[Task].[DueDate],
		[Task].[EndDate],
		[Task].[Duration],
		[Task].[PercentComplete],
		[Task].[Milestone],
		dbo.fnPjm5GetWorkingDays(@today, [Task].[DueDate]) AS [RestDays],
		[Task].[PlanPercent],
		[Task].[ManHour] / 60.0 AS [ManHour],
		CASE 
			WHEN @ViewAllFinance = 1 OR [Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID
				THEN [Task].[Budget]
			ELSE -1
		END AS [Budget],
		[Task].[RealManHour],
		CASE
			WHEN [Task].[ManHour] != 0 THEN
				CAST([Task].[RealManHour] as decimal(18,2))/[Task].[ManHour]
			ELSE 0
		END AS [RealManHourPercent],
		CASE 
			WHEN @ViewAllFinance = 1 OR [Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID
				THEN [Task].[TimeRealBudget]+[Task].[ExpenseRealBudget]
			ELSE -1
		end AS [RealBudget],
		CASE
			WHEN [Task].[Budget] != 0 THEN
				CAST([Task].[TimeRealBudget]+[Task].[ExpenseRealBudget] as decimal(18,2))/[Task].[Budget]
			ELSE 0
		END AS [RealBudgetPercent],
		[Task].[Comments],
		[Task].[Created],
		[Task].[CreatedBy],
		[Task].[Modified],
		[Task].[ModifiedBy],
		[Task].[Timestamp],
		CAST([Task].[Milestone] as tinyint) as M,
		(CAST([Task].[PercentComplete] * 100 as int) / 25) * 25 as PC
	FROM
		[pjm5vwTask] AS [Task] 
		INNER JOIN [Project]
			ON ([Task].[ProjectID] = [Project].[ID])
		LEFT OUTER JOIN 
			(SELECT DISTINCT
				[TaskAssignment].[TaskID]
			FROM 
				[TaskAssignment] INNER JOIN [vwAssignment] AS [Assignment]
				ON ([TaskAssignment].[AssignmentID] = [Assignment].[ID] 
					AND [Assignment].[EmployeeID] = @CurrentEmployeeID)
			) as [A]
			ON ([Task].[ID] = [A].[TaskID])			
	WHERE
		(
			([Task].[State] = 2) OR 
			(
				[Task].[State] = 3 AND 
				[Task].[EndDate] >= @PeriodStart AND 
				[Task].[EndDate] < @PeriodEnd
			)
		) 
		AND
		(
			@ViewAllTasks = 1 OR 
			[Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID OR 
			[A].[TaskID] IS NOT NULL
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5TaskActiveBrowse2] TO PUBLIC
GO

