IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TaskExists]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6TaskExists'
		DROP PROCEDURE [dbo].[pjm6TaskExists]
	END
GO

PRINT 'Creating procedure pjm6TaskExists'
GO

/******************************************************************************
**		File: pjm6TaskExists.sql
**		Name: pjm6TaskExists
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6TaskExists]
	@EmployeeID TIdentifier,
	@ProjectID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @result TBool
	SET @result = 0
	
	IF @EmployeeID IS NULL
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	IF EXISTS(
		SELECT *
		FROM
			[Task]
			INNER JOIN [TaskAssignment]
				ON [TaskAssignment].[TaskID] = [Task].[ID]
			INNER JOIN [vwAssignment]
				ON [vwAssignment].[ID] = [TaskAssignment].[AssignmentID]
		WHERE
			[Task].[ProjectID] = @ProjectID AND
			[vwAssignment].[EmployeeID] = @EmployeeID AND
			[Task].[State] = 2
	)
		SET @result = 1

	SELECT @result AS [TaskExists]
	RETURN 0
GO

GRANT EXECUTE ON [pjm6TaskExists] TO PUBLIC
GO 