IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[Pjm7TaskRequestBrowseByProjectTemplate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure Pjm7TaskRequestBrowseByProjectTemplate'
		DROP PROCEDURE [dbo].[Pjm7TaskRequestBrowseByProjectTemplate]
	END
GO

PRINT 'Creating procedure Pjm7TaskRequestBrowseByProjectTemplate'
GO

/******************************************************************************
**		File: pjm7TaskRequestBrowseByProjectTemplate.sql
**		Name: pjm7TaskRequestBrowseByProjectTemplate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [Pjm7TaskRequestBrowseByProjectTemplate]
	@ProjectID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE 
		@CurrentEmployeeID TIdentifier,
		@ViewAllFinance TBool
		
		
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	
	SELECT
		[TaskRequest].[Class],
		[TaskRequest].[ID],
		[TaskRequest].[State],
		[TaskRequest].[Flag],
		[TaskRequest].[FileAs],
		[TaskRequest].[ProjectID],
		[TaskRequest].[DueTime],
		[TaskRequest].[StartTime],
		[TaskRequest].[SendStatusReport],
		[TaskRequest].[TaskRequestStatusID],
		[TaskRequest].[DocumentCardID],
		[TaskRequest].[SupervisorAssignmentID],
		[TaskRequest].[Comments],
		[TaskRequest].[ExternalID],
		[TaskRequest].[Created],
		[TaskRequest].[CreatedBy],
		[TaskRequest].[Modified],
		[TaskRequest].[ModifiedBy],
		[TaskRequest].[Timestamp],
		CASE 
			WHEN @ViewAllFinance = 1 OR [Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID
				THEN [TaskRequest].[Budget]
			ELSE -1
		END AS [Budget],
		[TaskRequest].[ManHour]
	FROM
		[TaskRequest]
		INNER JOIN [Project]
			ON ([Project].[ID] = [TaskRequest].[ProjectID] AND [Project].[ID] = @ProjectID)
			
	RETURN 0
GO

GRANT EXECUTE ON [Pjm7TaskRequestBrowseByProjectTemplate] TO PUBLIC
GO