IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ToDoListBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ToDoListBrowse'
		DROP PROCEDURE [dbo].[pjm5ToDoListBrowse]
	END
GO

PRINT 'Creating procedure pjm5ToDoListBrowse'
GO

/******************************************************************************
**		File: pjm5ToDoListBrowse.sql
**		Name: pjm5ToDoListBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 08/01/2006 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		16.11.10	SYV				   
**		23.10.12	SAP				  
**		26.10.12	SAP				   
**									 
**		12.12.13	SAP				    /  .  
*******************************************************************************/
CREATE PROCEDURE [pjm5ToDoListBrowse]
	@Classes INT,
	@Date TDate,
	@Today TBool = NULL
AS
	SET NOCOUNT ON
	DECLARE @CurrentEmployeeID TIdentifier, @CurrentUserID TIdentifier
	
	SET @CurrentUserID = dbo.adfGetCurrentUserID()
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @Date = CONVERT(datetime, CONVERT(varchar(8), @Date, 112), 112)
	
	IF @Today IS NULL
	BEGIN
		IF @Date <= CONVERT(datetime, CONVERT(varchar(8), GETDATE(), 112), 112)
			SET @Today = 1
		ELSE
			SET @Today = 0
	END	
	
	IF (@Classes & 1) = 1
	BEGIN	
		SELECT
			[TimeEntry].[Class],
			[TimeEntry].[ID],
			[TimeEntry].[State],
			[TimeEntry].[Flag],
			500 as [PriorityID],
			[TimeEntry].[StartTime] as [DueDate],
			[TimeEntry].[ProjectID],
			[TimeEntry].[FileAs],
			[TimeEntry].[Comments],
			[TimeEntry].[Created],
			[TimeEntry].[CreatedBy],
			[TimeEntry].[Modified],
			[TimeEntry].[ModifiedBy],
			[TimeEntry].[Timestamp],
			CAST(0 as INT) as [Completed]
		FROM
			[TimeEntry]
		WHERE
			(
				(@Today = 0 AND CONVERT(datetime, CONVERT(varchar(8), [TimeEntry].[StartTime], 112), 112) = @Date)
			OR
				(@Today = 1 AND CONVERT(datetime, CONVERT(varchar(8), [TimeEntry].[StartTime], 112), 112) <= @Date)
			)
		AND
			[TimeEntry].[State] = 1 AND [TimeEntry].[MeetingRequestID] IS NULL
		AND
			[TimeEntry].[EmployeeID] = @CurrentEmployeeID
	END
	
	IF (@Classes & 2) = 2
	BEGIN
		SELECT DISTINCT
			[MeetingRequest].[Class],
			[MeetingRequest].[ID],
			[MeetingRequest].[State],
			[MeetingRequest].[Flag],
			[MeetingRequest].[PriorityID],
			[MeetingRequest].[StartTime] as [DueDate],
			[MeetingRequest].[ProjectID],
			[MeetingRequest].[FileAs],
			[MeetingRequest].[Comments],
			[MeetingRequest].[Created],
			[MeetingRequest].[CreatedBy],
			[MeetingRequest].[Modified],
			[MeetingRequest].[ModifiedBy],
			[MeetingRequest].[Timestamp],
			CAST(0 as INT) as [Completed]
		FROM
			[MeetingRequest] LEFT OUTER JOIN [Attendee]
				ON ([MeetingRequest].[ID] = [Attendee].[MeetingRequestID])
		WHERE
			(
				(@Today = 0 AND CONVERT(datetime, CONVERT(varchar(8), [MeetingRequest].[StartTime], 112), 112) = @Date)
			OR
				(@Today = 1 AND CONVERT(datetime, CONVERT(varchar(8), [MeetingRequest].[StartTime], 112), 112) <= @Date)
			)
		AND
			[MeetingRequest].[State] = 2
		AND
			(ISNULL([Attendee].[ResponseType], 'Tentative') != 'Decline' OR [MeetingRequest].[OriginatorEmployeeID] = @CurrentEmployeeID)
		AND
			([MeetingRequest].[OriginatorEmployeeID] = @CurrentEmployeeID OR [Attendee].[EmployeeID] = @CurrentEmployeeID)
	END
	
	
	IF (@Classes & 4) = 4
	BEGIN
		SELECT
			[Task].[Class],
			[Task].[ID],
			[Task].[State],
			[Task].[Flag],
			[Task].[PriorityID],
			[Task].[DueDate],
			[Task].[ProjectID],
			[Task].[FileAs],
			[Task].[Comments],
			[Task].[Created],
			[Task].[CreatedBy],
			[Task].[Modified],
			[Task].[ModifiedBy],
			[Task].[Timestamp],
			CAST((CASE WHEN [Task].[PercentComplete] = 1 THEN 1 ELSE 0 END) as INT) as [Completed]
		FROM
			[Task] INNER JOIN [TaskAssignment]
				ON ([Task].[ID] = [TaskAssignment].[TaskID])
			INNER JOIN [vwAssignment]
				ON ([TaskAssignment].[AssignmentID] = [vwAssignment].[ID])
		WHERE
			[vwAssignment].[EmployeeID] = @CurrentEmployeeID AND
			[TaskAssignment].[State] = 1
		AND
			(
				(@Today = 0 AND @Date BETWEEN [Task].[StartDate] AND [Task].[DueDate] AND [Task].[State] = 2)
			OR
				(@Today = 1 AND 
					(
						([Task].[State] = 2 AND [Task].[StartDate] <= @Date)
					--OR
						--([Task].[State] = 3 AND CONVERT(datetime, CONVERT(varchar(8), [EndDate], 112), 112) = @Date)
					)
				)
			)
	END
			
	IF (@Classes & 8) = 8
	BEGIN
		DECLARE @AccessToPublicFolders TBool
		SET @AccessToPublicFolders = dbo.adfHasAccessRight(dbo.adfGetRightID('AccessToPublicFolders'))
		
		SELECT
			[TaskRequest].[Class],
			[TaskRequest].[ID],
			[TaskRequest].[State],
			[TaskRequest].[Flag],
			[TaskRequest].[PriorityID],
			[TaskRequest].[DueTime] as [DueDate],
			[TaskRequest].[ProjectID],
			[TaskRequest].[FileAs],
			[TaskRequest].[Comments],
			[TaskRequest].[Created],
			[TaskRequest].[CreatedBy],
			[TaskRequest].[Modified],
			[TaskRequest].[ModifiedBy],
			[TaskRequest].[Timestamp],
			CAST((CASE WHEN [TaskRequest].[PercentComplete] = 1 THEN 1 ELSE 0 END) as INT) as [Completed]
		FROM
			[TaskRequest]
			INNER JOIN [TaskRequestAssignment]
				ON ([TaskRequest].[ID] = [TaskRequestAssignment].[TaskRequestID])
			LEFT OUTER JOIN [DocumentCard]
				ON [DocumentCard].[ID] = [TaskRequest].[DocumentCardID]
		WHERE
			[TaskRequestAssignment].[EmployeeID] = @CurrentEmployeeID AND
			(
				@AccessToPublicFolders = 1 OR
				[TaskRequest].[DocumentCardID] IS NULL
			) AND
			(
				(@Today = 0 AND @Date BETWEEN CONVERT(datetime, CONVERT(varchar(8), ISNULL([TaskRequest].[StartTime], [TaskRequest].[DueTime]), 112), 112)
					 AND CONVERT(datetime, CONVERT(varchar(8), [TaskRequest].[DueTime], 112), 112) AND [TaskRequest].[State] = 2)
			OR
				(@Today = 1 AND 
					(
						([TaskRequest].[State] = 2 AND CONVERT(datetime, CONVERT(varchar(8), ISNULL([TaskRequest].[StartTime], [TaskRequest].[DueTime]), 112), 112) <= @Date)
					--OR
						--([TaskRequest].[State] = 3 AND CONVERT(datetime, CONVERT(varchar(8), [TaskRequest].[Modified], 112), 112) = @Date)
					)
				)
			)
	END		


	IF (@Classes & 16) = 16
	BEGIN
		SELECT
			[Issue].[Class],
			[Issue].[ID],
			[Issue].[State],
			[Issue].[Flag],
			[Issue].[PriorityID],
			[Issue].[DueDate],
			[Issue].[ProjectID],
			[Issue].[FileAs],
			[Issue].[Comments],
			[Issue].[Created],
			[Issue].[CreatedBy],
			[Issue].[Modified],
			[Issue].[ModifiedBy],
			[Issue].[Timestamp],
			CAST(0 as INT) as [Completed]
		FROM
			[Issue]
		WHERE
			/*(
				(@Today = 0 AND CONVERT(datetime, CONVERT(varchar(8), [Issue].[DueDate], 112), 112) = @Date)
			OR
				(@Today = 1 AND CONVERT(datetime, CONVERT(varchar(8), [Issue].[DueDate], 112), 112) <= @Date)
			)
		AND*/
			[Issue].[EmployeeID] = @CurrentEmployeeID
		AND
			[Issue].[State] = 3
	END
	
	IF (@Classes & 32) = 32
	BEGIN
		SELECT
			[ServiceRequest].[Class],
			[ServiceRequest].[ID],
			[ServiceRequest].[State],
			[ServiceRequest].[Flag],
			[ServiceRequest].[PriorityID],
			[ServiceRequest].[DueDate],
			[ServiceRequest].[ProjectID],
			[ServiceRequest].[FileAs],
			[ServiceRequest].[Comments],
			[ServiceRequest].[Created],
			[ServiceRequest].[CreatedBy],
			[ServiceRequest].[Modified],
			[ServiceRequest].[ModifiedBy],
			[ServiceRequest].[Timestamp],
			CAST(0 as INT) as [Completed]
		FROM
			[ServiceRequest]
		WHERE
			/*(
				(@Today = 0 AND CONVERT(datetime, CONVERT(varchar(8), [ServiceRequest].[DueDate], 112), 112) = @Date)
			OR
				(@Today = 1 AND CONVERT(datetime, CONVERT(varchar(8), [ServiceRequest].[DueDate], 112), 112) <= @Date)
			)
		AND*/
			[ServiceRequest].[EmployeeID] = @CurrentEmployeeID
		AND
			[ServiceRequest].[State] = 2
	END
	
		
	IF (@Classes & 64) = 64
	BEGIN
		SELECT
			[Employee].[Class],
			[Employee].[ID],
			[Employee].[State],
			[Employee].[Flag],
			500 as [PriorityID],
			[Reminder].[EventTime] as [DueDate],
			NULL as [ProjectID],
			[Employee].[FileAs],
			[UserReminder].[Description] as [Comments],
			[Employee].[Created],
			[Employee].[CreatedBy],
			[Employee].[Modified],
			[Employee].[ModifiedBy],
			[Employee].[Timestamp],
			CAST(0 as INT) as [Completed]
		FROM
			[Employee]
			INNER JOIN [Reminder]
				ON [Employee].[ID] = [Reminder].[DocumentID] AND
					[Employee].[Class] = [Reminder].[DocumentClass]
			INNER JOIN [UserReminder]
				ON [UserReminder].[ReminderID] = [Reminder].[ID] AND
					[UserReminder].[UserID] = @CurrentUserID
		WHERE
			[Employee].[State] = 1
			AND
			(
				(@Today = 0 AND CONVERT(datetime, CONVERT(varchar(8), [Reminder].[EventTime], 112), 112) = @Date)
			OR
				(@Today = 1 AND CONVERT(datetime, CONVERT(varchar(8), [Reminder].[EventTime], 112), 112) <= @Date)
			)
			AND
			[UserReminder].[State] = 1
			AND
			[Reminder].[Subtype] <> 'CB'
	END

	IF (@Classes & 128) = 128
	BEGIN
		SELECT
			[Employee].[Class],
			[Employee].[ID],
			[Employee].[State],
			[Employee].[Flag],
			500 as [PriorityID],
			[Reminder].[EventTime] as [DueDate],
			NULL as [ProjectID],
			[Employee].[FileAs],
			[UserReminder].[Description] as [Comments],
			[Employee].[Created],
			[Employee].[CreatedBy],
			[Employee].[Modified],
			[Employee].[ModifiedBy],
			[Employee].[Timestamp],
			CAST(0 as INT) as [Completed]
		FROM
			[Employee]
			INNER JOIN [Reminder]
				ON [Employee].[ID] = [Reminder].[DocumentID] AND
					[Employee].[Class] = [Reminder].[DocumentClass]
			INNER JOIN [UserReminder]
				ON [UserReminder].[ReminderID] = [Reminder].[ID] AND
					[UserReminder].[UserID] = @CurrentUserID
		WHERE
			[Employee].[State] = 1
			AND
			CAST(DATEADD(Year,DATEDIFF(Year,[Reminder].[EventTime],@Date),[Reminder].[EventTime]) as date) = @Date
			AND
			DATEDIFF(Year, GETDATE(), @Date) >= 0			
			AND
			[UserReminder].[State] = 1
			AND
			[Reminder].[Subtype] = 'CB'
	END
				
	IF (@Classes & 64) = 64
	BEGIN
		SELECT
			[Company].[Class],
			[Company].[ID],
			[Company].[State],
			[Company].[Flag],
			500 as [PriorityID],
			[Reminder].[EventTime] as [DueDate],
			NULL as [ProjectID],
			[Company].[FileAs],
			[UserReminder].[Description] as [Comments],
			[Company].[Created],
			[Company].[CreatedBy],
			[Company].[Modified],
			[Company].[ModifiedBy],
			[Company].[Timestamp],
			CAST(0 as INT) as [Completed]
		FROM
			[Company] 
			INNER JOIN [Reminder]
				ON [Company].[ID] = [Reminder].[DocumentID] AND
					[Company].[Class] = [Reminder].[DocumentClass]
			INNER JOIN [UserReminder]
				ON [UserReminder].[ReminderID] = [Reminder].[ID] AND
					[UserReminder].[UserID] = @CurrentUserID
		WHERE
			[Company].[State] = 1
		AND 
			[Company].[Own] = 0
		AND
			[UserReminder].[State] = 1
		AND
			(
				(@Today = 0 AND CONVERT(datetime, CONVERT(varchar(8), [Reminder].[EventTime], 112), 112) = @Date)
			OR
				(@Today = 1 AND CONVERT(datetime, CONVERT(varchar(8), [Reminder].[EventTime], 112), 112) <= @Date)
			)
	END

	IF (@Classes & 64) = 64
	BEGIN
		DECLARE
			@CalculationClass	TClass,
			@StatementClass		TClass,
			@InvoiceClass		TClass,
			@FactureClass		TClass,
			@ProjectClass		TClass,
			@BudgetClass		TClass,
			@ExpenseClass		TClass,
			@MeetingClass		TClass,
			@IssueClass			TClass,
			@TaskClass			TClass,
			@TaskRequestClass	TClass,
			@ServiceRequestClass	TClass
		

			SET @CalculationClass	  = dbo.adfGetClassByName('Pjm5.Calculation')
			SET @StatementClass		  = dbo.adfGetClassByName('Pjm5.Statement')
			SET @InvoiceClass		  = dbo.adfGetClassByName('Pjm5.Invoice')
			SET @FactureClass		  = dbo.adfGetClassByName('Pjm5.Facture')
			SET @ProjectClass		  = dbo.adfGetClassByName('Pjm5.Project')
			SET @BudgetClass		  = dbo.adfGetClassByName('Pjm6.Budget')
			SET @ExpenseClass		  = dbo.adfGetClassByName('Pjm5.Expense')
			SET @MeetingClass		  = dbo.adfGetClassByName('Pjm5.MeetingRequest')
			SET @IssueClass			  = dbo.adfGetClassByName('Pjm5.Issue')
			SET @TaskClass			  = dbo.adfGetClassByName('Pjm5.Task')
			SET @TaskRequestClass	  = dbo.adfGetClassByName('Pjm5.TaskRequest')
			SET @ServiceRequestClass  = dbo.adfGetClassByName('Pjm5.ServiceRequest')

		SELECT
			[Document].[Class],
			[Document].[ID],
			[Document].[State],
			[Document].[Flag],
			500 as [PriorityID],
			CASE
			WHEN [ReminderType].[IsTimeFormat] = 1 THEN
					DATEADD(minute, -[UserReminder].[OriginalInterval], [Reminder].[EventTime])
				ELSE [Reminder].[EventTime]
			END AS [DueDate],				
			[DocumentProjectID].[ProjectID] AS [ProjectID],			
			[Document].[FileAs],
			[UserReminder].[Description] as [Comments],
			[Document].[Created],
			[Document].[CreatedBy],
			[Document].[Modified],
			[Document].[ModifiedBy],
			[Document].[Timestamp],
			CAST(0 as INT) as [Completed]
		FROM
			[Document] 
			INNER JOIN [Reminder]
				ON [Document].[ID] = [Reminder].[DocumentID] AND
					[Document].[Class] = [Reminder].[DocumentClass]
			INNER JOIN [ReminderType]
				ON [ReminderType].[Subtype] = [Reminder].[Subtype]
			INNER JOIN [UserReminder]
				ON [UserReminder].[ReminderID] = [Reminder].[ID] AND
					[UserReminder].[UserID] = @CurrentUserID
			INNER JOIN 
				(
				SELECT 
					[uTable].[Class] AS DocumentClass,
					[uTable].[ID] AS DocumentID,
					[uTable].[ProjectID] 
				FROM
				(
					(
					SELECT --
						[Document].[Class],
						[Document].[ID],
						[Calculation].[ProjectID]
					FROM
						[Document]
						INNER JOIN [Calculation]
							ON [Calculation].[ID] = [Document].[ID]
							AND [Calculation].[Class] = [Document].[Class]
					)
				UNION ALL
					(
					SELECT --
						[Document].[Class],
						[Document].[ID],
						[Statement].[ProjectID]
					FROM
						[Document]
						INNER JOIN [Statement]
							ON [Statement].[ID] = [Document].[ID]
							AND [Statement].[Class] = [Document].[Class]
					)			
				UNION ALL
					(
					SELECT --
						[Document].[Class],
						[Document].[ID],
						[Invoice].[ProjectID]
					FROM
						[Document]
						INNER JOIN [Invoice]
							ON [Invoice].[ID] = [Document].[ID]
							AND [Invoice].[Class] = [Document].[Class]
					)		
				UNION ALL
					(
					SELECT---
						[Document].[Class],
						[Document].[ID],
						[Facture].[ProjectID]
					FROM
						[Document]
						INNER JOIN [Facture]
							ON [Facture].[ID] = [Document].[ID]
							AND [Facture].[Class] = [Document].[Class]
					)
				UNION ALL
					(
					SELECT--
						[Document].[Class],
						[Document].[ID],
						[Project].[ID]
					FROM
						[Document]
						INNER JOIN [Project]
							ON [Project].[ID] = [Document].[ID]
							AND [Project].[Class] = [Document].[Class]
					)
				UNION ALL
					(		
					SELECT--
						[Document].[Class],
						[Document].[ID],
						[Budget].[DocumentID] AS ProjectID
					FROM
						[Document]
						INNER JOIN [Budget]
							ON [Budget].[ID] = [Document].[ID]
							AND [Budget].[Class] = [Document].[Class]
					)
				UNION ALL
					(							
					SELECT--	
						[Document].[Class],
						[Document].[ID],
						[Expense].[ProjectID]
					FROM
						[Document]
						INNER JOIN [Expense]
							ON [Expense].[ID] = [Document].[ID]
							AND [Expense].[Class] = [Document].[Class]
					)
				UNION ALL
					(								
					SELECT--
						[Document].[Class],
						[Document].[ID],
						[MeetingRequest].[ProjectID]
					FROM
						[Document]
						INNER JOIN [MeetingRequest]
							ON [MeetingRequest].[ID] = [Document].[ID]
							AND [MeetingRequest].[Class] = [Document].[Class]
					)
				UNION ALL
					(						
					SELECT--
						[Document].[Class],
						[Document].[ID],
						[Issue].[ProjectID]
					FROM
						[Document]
						INNER JOIN [Issue]
							ON [Issue].[ID] = [Document].[ID]
							AND [Issue].[Class] = [Document].[Class]
					)
				UNION ALL
					(			
					SELECT--
						[Document].[Class],
						[Document].[ID],
						[Task].[ProjectID]
					FROM
						[Document]
						INNER JOIN [Task]
							ON [Task].[ID] = [Document].[ID]
							AND [Task].[Class] = [Document].[Class]
					)
				UNION ALL
					(								
					SELECT--
						[Document].[Class],
						[Document].[ID],
						[TaskRequest].[ProjectID]
					FROM
						[Document]
						INNER JOIN [TaskRequest]
							ON [TaskRequest].[ID] = [Document].[ID]
							AND [TaskRequest].[Class] = [Document].[Class]
					)
				UNION ALL
					(			
					SELECT--
						[Document].[Class],
						[Document].[ID],
						[ServiceRequest].[ProjectID]
					FROM
						[Document]
						INNER JOIN [ServiceRequest]
							ON [ServiceRequest].[ID] = [Document].[ID]
							AND [ServiceRequest].[Class] = [Document].[Class]	
					)					
				) AS uTable) AS DocumentProjectID
				ON [DocumentProjectID].[DocumentClass] = [Document].[Class]
					AND
				    [DocumentProjectID].[DocumentID] = [Document].[ID]
		WHERE
			[Document].[Class] IN (@CalculationClass, @StatementClass, @InvoiceClass, @FactureClass, @ProjectClass, @BudgetClass,
									@ExpenseClass, @MeetingClass, @IssueClass, @TaskClass, @TaskRequestClass, @ServiceRequestClass)								
		AND
			[UserReminder].[State] = 1
		AND
			(
				(@Today = 0 AND CONVERT(datetime, CONVERT(varchar(8), [Reminder].[EventTime], 112), 112) = @Date)
			OR
				(@Today = 1 AND CONVERT(datetime, CONVERT(varchar(8), [Reminder].[EventTime], 112), 112) <= @Date)
			)
		AND
			(
				([Document].[Class] NOT IN (@StatementClass, @InvoiceClass, @FactureClass,@BudgetClass) AND [Reminder].[Subtype] IN ('UR'))
			OR
				([Document].[Class] IN (@StatementClass, @InvoiceClass, @FactureClass,@BudgetClass) AND [Reminder].[Subtype] IN 
				(SELECT DISTINCT [Subtype] FROM [ReminderDescription]))				 
			)	
	END

	
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ToDoListBrowse] TO PUBLIC
GO
 